unit mainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, CoolMenu;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Menu1: TMenuItem;
    Item1: TMenuItem;
    Item21: TMenuItem;
    item31: TMenuItem;
    PopupMenu1: TPopupMenu;
    popup1: TMenuItem;
    popup2: TMenuItem;
    popup3: TMenuItem;
    MenuItemAdditionalInfo1: TMenuItemAdditionalInfo;
    N1: TMenuItem;
    Close1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Item1Click(Sender: TObject);
    procedure Item21Click(Sender: TObject);
    procedure item31Click(Sender: TObject);
    procedure popup1Click(Sender: TObject);
    procedure popup2Click(Sender: TObject);
    procedure popup3Click(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Close1Click(Sender: TObject);
  private
    procedure WMDrawItem(var Msg: TWMDrawItem); message WM_DRAWITEM;
    procedure WMMeasureItem(var Msg: TWMMeasureItem); message WM_MEASUREITEM;
    procedure WMCommand(var Msg: TWMCommand); message WM_COMMAND;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ModifyMenu(PopUpMenu1.Handle, popup1.Command, MF_OWNERDRAW, popup1.Command, PChar(0));
  ModifyMenu(MainMenu1.Handle, Item1.Command, MF_OWNERDRAW, Item1.Command, PChar(0));
  ModifyMenu(MainMenu1.Handle, Item21.Command, MF_OWNERDRAW, Item21.Command, PChar(0));
  ModifyMenu(MainMenu1.Handle, Item31.Command, MF_OWNERDRAW, Item31.Command, PChar(0));
  ModifyMenu(MainMenu1.Handle, Close1.Command, MF_OWNERDRAW, Close1.Command, PChar(0));
end;

procedure TForm1.WMDrawItem(var Msg: TWMDrawItem);
begin
 inherited;
  with Msg.DrawItemStruct^ do
  begin
    if CtlType = ODT_MENU then
    begin
      MenuItemAdditionalInfo1.Picture.Assign(nil);
      MenuItemAdditionalInfo1.Font.Color := clBlack;
      MenuItemAdditionalInfo1.Font.Style := [];
      if ItemID = Item1.Command then MenuItemAdditionalInfo1.DrawItem(TMessage(Msg), Item1.Caption);

      MenuItemAdditionalInfo1.Picture.Icon.Assign(Icon);
      MenuItemAdditionalInfo1.Font.Color := clRed;
      MenuItemAdditionalInfo1.Font.Style := [fsBold];
      if ItemID = Item21.Command then MenuItemAdditionalInfo1.DrawItem(TMessage(Msg), Item21.Caption);

      MenuItemAdditionalInfo1.Font.Color := clGreen;
      MenuItemAdditionalInfo1.Picture.Icon.Assign(Application.Icon);
      MenuItemAdditionalInfo1.Font.Style := [fsBold, fsItalic];
      if ItemID = Item31.Command then MenuItemAdditionalInfo1.DrawItem(TMessage(Msg), Item31.Caption);

      MenuItemAdditionalInfo1.Font.Color := clMaroon;
      MenuItemAdditionalInfo1.Picture.Icon.Handle := LoadIcon(0, IDI_Hand);
      MenuItemAdditionalInfo1.Font.Style := [fsBold, fsItalic];
      if ItemID = Close1.Command then MenuItemAdditionalInfo1.DrawItem(TMessage(Msg), Close1.Caption);

      MenuItemAdditionalInfo1.Font.Color := clMaroon;
      MenuItemAdditionalInfo1.Font.Style := [fsUnderLine];
      MenuItemAdditionalInfo1.Picture.Icon.Assign(Application.Icon);
      if ItemID = popup1.Command then MenuItemAdditionalInfo1.DrawItem(TMessage(Msg), popup1.Caption);
    end
  end
end;


procedure TForm1.WMMeasureItem(var Msg: TWMMeasureItem);
begin
 inherited;
  With Msg.MeasureItemStruct^ do
  begin
    if CtlType = ODT_MENU then
    begin
      if ItemID = Item1.Command then MenuItemAdditionalInfo1.MeasureItem(TMessage(Msg), Item1.Caption);
      if ItemID = Item21.Command then MenuItemAdditionalInfo1.MeasureItem(TMessage(Msg), Item21.Caption);
      if ItemID = Item31.Command then MenuItemAdditionalInfo1.MeasureItem(TMessage(Msg), Item31.Caption);
      if ItemID = Close1.Command then MenuItemAdditionalInfo1.MeasureItem(TMessage(Msg), Close1.Caption);      
      if ItemID = popup1.Command then MenuItemAdditionalInfo1.MeasureItem(TMessage(Msg), popup1.Caption);
    end
  end
end;

procedure TForm1.WMCommand(var Msg: TWMCommand);
begin
  inherited;
  with Msg do
  begin
    if (itemID = popup1.Command) then popup1.OnClick(Self);
    if (itemID = popup2.Command) then popup2.OnClick(Self);
    if (itemID = popup3.Command) then popup3.OnClick(Self);
  end;
end;

procedure TForm1.Item1Click(Sender: TObject);
begin
  ShowMessage('Item1');
end;

procedure TForm1.Item21Click(Sender: TObject);
begin
  ShowMessage('Item2');
end;

procedure TForm1.item31Click(Sender: TObject);
begin
  ShowMessage('Item3');
end;

procedure TForm1.popup1Click(Sender: TObject);
begin
  ShowMessage('popup');
end;

procedure TForm1.popup2Click(Sender: TObject);
begin
  ShowMessage('popup1');
end;

procedure TForm1.popup3Click(Sender: TObject);
begin
  ShowMessage('popup2');
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
    TrackPopupMenu(PopupMenu1.handle,TPM_LEFTALIGN or TPM_RIGHTBUTTON,x+left,y+top,0,Handle,NIL)
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  Close;
end;

end.
