unit DemoMain;

{This is the source of the demo application of the Perseus VCP. It should
 show you how to use the components!

 Copyright  1995: Sebastian Modersohn
                   Softwaredevelopment
                   Heinestrasse 20
                   D 15370 Petershagen
                   Phone: ++49 33439 7462
                   CompuServe: 100340,1474
                   Internet: 100340.1474@compuserve.com

 Written by: Sebastian Modersohn

 If you have questions to the source or whatever, just contact us and we'll
 help you.}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Controls, Graphics,
  Forms, Dialogs, StdCtrls, Vlistbox, TabNotBk, Slider, Wheel, Buttons,
  ExtCtrls, Pslabel, PSCCtl, Mbhint, Trans;

type
  TPDemoMain = class(TForm)
    MainTabs: TTabbedNotebook;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Wheel1: TWheel;
    Wheel2: TWheel;
    Slider1: TSlider;
    Slider2: TSlider;
    Slider3: TSlider;
    VListBox1: TVListBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn1: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    GroupBox1: TGroupBox;
    Image2: TImage;
    Label11: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    BitBtn9: TBitBtn;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    PSLabel1: TPSLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    BitBtn10: TBitBtn;
    BitBtn11: TBitBtn;
    Wheel3: TWheel;
    Wheel4: TWheel;
    Wheel5: TWheel;
    MBHint1: TMBHint;
    Label13: TLabel;
    PSLabel2: TPSLabel;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    Label17: TLabel;
    Label26: TLabel;
    procedure btnWheelHlpClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Wheel1Select(Sender: TObject);
    procedure Wheel2Track(Sender: TObject);
    procedure Slider1Select(Sender: TObject);
    procedure Slider2Track(Sender: TObject);
    procedure Slider3Track(Sender: TObject);
    procedure VListBox1GetItem(Sender: TVListBox; Index: Longint;
      Col: Integer; var Strg: OpenString; State: TOwnerDrawState;
      var Font: TFont; var BGColor: TColor);
    procedure VListBox1Change(Sender: TObject);
    procedure VListBox1IsProtected(Sender: TVListBox; Index: Longint;
      var Protect: Boolean);
  end;

var
  PDemoMain: TPDemoMain;

implementation

{$R *.DFM}

{For displaying the help after pressing one of the buttons}
procedure TPDemoMain.btnWheelHlpClick(Sender: TObject);
begin
  Application.HelpContext(TBitBtn(Sender).HelpContext)
end;

{for setting the helpfile}
procedure TPDemoMain.FormCreate(Sender: TObject);
begin
  Application.HelpFile:='persdemo.hlp';
end;

{the next 5 proc's react on OnTrack or OnSelect events
 of some Wheels or Sliders for displaying their values}
procedure TPDemoMain.Wheel1Select(Sender: TObject);
begin
  Label18.Caption:=IntToStr(Wheel1.Position);
end;

procedure TPDemoMain.Wheel2Track(Sender: TObject);
begin
  Label19.Caption:=IntToStr(Wheel2.Position);
end;

procedure TPDemoMain.Slider1Select(Sender: TObject);
begin
  Label20.Caption:=IntToStr(Slider1.Position);
end;

procedure TPDemoMain.Slider2Track(Sender: TObject);
begin
  Label21.Caption:=IntToStr(Slider2.Position);
end;

procedure TPDemoMain.Slider3Track(Sender: TObject);
begin
  Label22.Caption:=IntToStr(Slider3.Position);
end;

{tha absolutely important OnGetItem event of the virtual listbox}
procedure TPDemoMain.VListBox1GetItem(Sender: TVListBox; Index: Longint;
  Col: Integer; var Strg: OpenString; State: TOwnerDrawState; var Font: TFont;
  var BGColor: TColor);
begin
  {standard string for all items: "Item [No] [ColNo]}
  Strg:='Item '+IntToStr(Index+1)+' '+IntToStr(Col);
  {for setting a custom font for the 10th item:}
  if Index=9 then
  begin
    {for the second column display the string: "10th item with custom font and color"}
    if Col=2 then
    begin
      Strg:='10th item with custom font and color!';
      {if the item isn't selected set the font's color to red for the second column}
      if not (odSelected in State) then Font.Color:=clRed;
    end;
    {change the font to Arial 12 for the whole 10th item}
    Font.Name:='Arial';
    Font.Size:=12;
  end;
  {for the 4th item in the second columns display "Unselectable!"}
  if (Index=3) and (Col=2) then
    Strg:='Unselectable!';
end;

{react after an item(-range) in the vlistbox was selected}
procedure TPDemoMain.VListBox1Change(Sender: TObject);
var I: LongInt;
begin
  {if checkbox1 ("Track selections") is checked display the selected items
   in Memo1}
  if CheckBox1.Checked then
  begin
    Memo1.Lines.Clear;
    {i is the counter of the selections}
    for i:=1 to VListBox1.Selections.Count do
      Memo1.Lines.Add(IntToStr(VListBox1.Selections.GetSelections(i)+1));
  end;
end;

procedure TPDemoMain.VListBox1IsProtected(Sender: TVListBox;
  Index: Longint; var Protect: Boolean);
begin
  if Index=3 then Protect:=True;
end;

end.
