///////////////////////////////////////////////////////
// ignore.c                                          //
// -- Demonstration program ignores all input.       //
// -- Written by Paul R. Bonneau 12/18/94.           //
// -- To compile: "cc -DSTRICT ignore.c"             //
///////////////////////////////////////////////////////
#include <windows.h>

char szClass[]	= "Ignore";

LRESULT CALLBACK __export LwWndProc(HWND hwnd,
  UINT wm, WPARAM wParam, LPARAM lParam);

#ifdef __WATCOMC__
    #pragma off (unreferenced);
#endif

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hins, HINSTANCE hinsPrev,
                                      LPSTR lpsz, int wShow)
    {
    HWND  hwnd;
    MSG   msg;
    HDC   hdc;
    DWORD lwCounter;
    char  szBuf[256];

    if (NULL == hinsPrev)
        {
        WNDCLASS wcs;

        wcs.style = 0;
        wcs.lpfnWndProc = LwWndProc;
        wcs.cbClsExtra = 0;
        wcs.cbWndExtra = 0;
        wcs.hInstance = hins;
        wcs.hIcon = LoadIcon(NULL, IDI_APPLICATION);
        wcs.hCursor = LoadCursor(NULL, IDC_ARROW);
        wcs.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
        wcs.lpszMenuName = NULL;
        wcs.lpszClassName = szClass;

        if (!RegisterClass(&wcs))
            return 0;
        }

    msg.wParam = 0;
    if (NULL != (hwnd = CreateWindow(szClass,
      "Ignore Message Demo", WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
      CW_USEDEFAULT, NULL, NULL, hins, NULL)))
        {
        ShowWindow(hwnd, wShow);

        // The "tight" loop.
        for (lwCounter = 0; IsWindow(hwnd) &&
          GetMessage(&msg, NULL, 0, 0); lwCounter++)
            {
            if (NULL != (hdc = GetDC(hwnd)))
                {
                wsprintf(szBuf, "%ld", lwCounter);
                TextOut(hdc, 0, 0, szBuf,
                  lstrlen(szBuf));
                ReleaseDC(hwnd, hdc);
                }
            }
        }

    return msg.wParam;
    }

LRESULT CALLBACK __export LwWndProc(HWND hwnd,
  UINT wm, WPARAM wParam, LPARAM lParam)
    {
    if (WM_DESTROY == wm)
        PostQuitMessage(0);

    return DefWindowProc(hwnd, wm, wParam, lParam);
    }
