///////////////////////////////////////////////////////
// ignore2.c                                         //
// -- Demonstration program ignores all input.       //
// -- Written by Paul R. Bonneau 12/18/94.           //
// -- To compile: "cc -DSTRICT ignore2.c"            //
///////////////////////////////////////////////////////
#include <windows.h>

char szClass[] = "Ignore2";

// Exported.
LRESULT CALLBACK __export LwWndProc(HWND hwnd,
  UINT wm, WPARAM wParam, LPARAM lParam);

// Imported.
BOOL WINAPI WaitEvent(HTASK);

#ifdef __WATCOMC__
    #pragma off (unreferenced);
#endif

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hins, HINSTANCE hinsPrev,
                                      LPSTR lpsz, int wShow)
    {
    HWND         hwnd;
    MSG          msg;
    LPWORD       lpsel;
    LPBYTE       lpb;
    DWORD        lwCounter;
    HDC          hdc;
    char         szBuf[256];
    int          bOffset;
    WINDEBUGINFO wdi;

    lpsel = MAKELP(SELECTOROF(WaitEvent), 0x0030);
    bOffset =
      GetWinDebugInfo(&wdi, 0) ? 0x0355 : 0x0335;
    lpb = MAKELP(*lpsel, bOffset);
    if (NULL == hinsPrev)
        {
        WNDCLASS wcs;

        wcs.style = 0;
        wcs.lpfnWndProc = LwWndProc;
        wcs.cbClsExtra = 0;
        wcs.cbWndExtra = 0;
        wcs.hInstance = hins;
        wcs.hIcon = LoadIcon(NULL, IDI_APPLICATION);
        wcs.hCursor = LoadCursor(NULL, IDC_ARROW);
        wcs.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
        wcs.lpszMenuName = NULL;
        wcs.lpszClassName = szClass;

        if (!RegisterClass(&wcs))
            return 0;
        }

    msg.wParam = 0;
    if (NULL != (hwnd = CreateWindow(szClass,
      "Ignore Message Demo", WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
      CW_USEDEFAULT, NULL, NULL, hins, NULL)))
        {
        ShowWindow(hwnd, wShow);

        // The "tight" loop.
        for (lwCounter = 0;; lwCounter++)
            {
            if (NULL != (hdc = GetDC(hwnd)))
                {
                wsprintf(szBuf, "%ld", lwCounter);
                TextOut(hdc, 0, 0, szBuf,
                  lstrlen(szBuf));
                ReleaseDC(hwnd, hdc);
                }
            *lpb = 0x01;
            }
        }

    return msg.wParam;
    }

LRESULT CALLBACK __export LwWndProc(HWND hwnd,
  UINT wm, WPARAM wParam, LPARAM lParam)
    {
    if (WM_DESTROY == wm)
        PostQuitMessage(0);

    return DefWindowProc(hwnd, wm, wParam, lParam);
    }
