unit Agenda;
interface
uses SysUtils, Classes, StdCtrls, Date, Convert;

Type
  TAgenda = class(TMemo)
              private
                FAgenda: String;
                FDate:   TDate;

              protected
                procedure SetAgenda(Const FileName: String);

              published
                property Agenda: String read FAgenda write SetAgenda;

              public
                constructor Create(AOwner: TComponent); override;
            end {TAgenda};

  procedure Register;

implementation

  constructor TAgenda.Create(AOwner: TComponent);
  begin
    inherited Create(AOwner);
    ScrollBars := ssVertical; { set vertical scrollbars }
    FDate := TDate.Create(self);
  end {Create};

  procedure TAgenda.SetAgenda(Const FileName: string);
  var f: System.Text;
      Str: String;
      FConvert: TConvert;
  begin
    {$I-}
    System.Assign(f,FileName);
    Reset(f);
    if IOResult = 0 then
    begin
      FConvert := TConvert.Create(self);
      FConvert.Decimal := FDate.Year;
      FAgenda := FileName;
      Lines.Clear; { clear contents }
      Lines.Add(FDate.DateString + ' ' + FConvert.Roman);
      Lines.Add('-----');
      while not eof(f) do
      begin
        readln(f,Str);
        if System.Pos(FDate.DateString,Str) = 1 then Lines.Add(Str)
      end;
      FConvert.Destroy;
      System.Close(f)
    end
    {$I+}
  end {SetAgenda};

  procedure Register;
  begin
    RegisterComponents('Dr.Bob', [TAgenda])
  end {Register};
end.
