unit Date;
interface
uses SysUtils, Classes;

Type
  TDayOfWeek = (Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday);

  TDate = class(TComponent)
                private
                  FInternalDate: TDateTime;

                  FDay:   Word;
                  FMonth: Word;
                  FYear:  Word;

                protected
                  procedure SetDay(NewDay: Word);
                  procedure SetMonth(NewMonth: Word);
                  procedure SetYear(NewYear: Word);

                  function GetDayOfWeek: TDayOfWeek;
                  function GetDateString: String;

                public
                  DummyTDayOfWeek: TDayOfWeek;
                  DummyDateString: String;

                published
                  property Day:   Word read FDay   write SetDay;
                  property Month: Word read FMonth write SetMonth;
                  property Year:  Word read FYear  write SetYear;

                  property DayOfWeek: TDayOfWeek read GetDayOfWeek
                                                 write DummyTDayOfWeek;

                  property DateString: String read GetDateString
                                              write DummyDateString;

                public
                  constructor Create(AOwner: TComponent); override;
                end {TDate};

  procedure Register;

implementation

  Constructor TDate.Create(AOwner: TComponent);
  begin
    inherited Create(AOwner);
    FInternalDate := SysUtils.Date;
    DecodeDate(SysUtils.Date,FYear,FMonth,FDay);
  end {Create};

  procedure TDate.SetDay(NewDay: Word);
  begin
    if (NewDay in [1..31]) then
    begin
      FDay := NewDay;
      FInternalDate := EncodeDate(FYear,FMonth,FDay);
    end;
  end {SetDay};

  procedure TDate.SetMonth(NewMonth: Word);
  begin
    if (NewMonth in [1..12]) then
    begin
      FMonth := NewMonth;
      FInternalDate := EncodeDate(FYear,FMonth,FDay);
    end;
  end {SetMonth};

  procedure TDate.SetYear(NewYear: Word);
  begin
    FYear := NewYear;
    FInternalDate := EncodeDate(FYear,FMonth,FDay);
  end {SetYear};

  function TDate.GetDayOfWeek: TDayOfWeek;
  begin
    GetDayOfWeek := TDayOfWeek(Pred(SysUtils.DayOfWeek(FInternalDate)));
  end {GetDayOfWeek};

  function TDate.GetDateString: String;
  var D,M: String;
  begin
    System.Str(FMonth:2,M);
    System.Str(FDay:2,D);
    if (D[1] = ' ') then D[1] := '0';
    GetDateString := M + '/'+ D; { MM/DD }
  end {GetDateString};

  procedure Register;
  begin
    RegisterComponents('Dr.Bob', [TDate])
  end {Register};
end.
