unit Frmedit;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, Tx4vb, VBXCtrl;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    New1: TMenuItem;
    Close1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    TXRuler1: TTXRuler;
    TXButtonBar1: TTXButtonBar;
    TextControl1: TTextControl;
    TXStatusBar1: TTXStatusBar;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Clear1: TMenuItem;
    Search1: TMenuItem;
    Find1: TMenuItem;
    Replace1: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TextControl1Change(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Exit1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
  private
    { Private declarations }
    CaptionBase: String;
    TextChanged: Boolean;
    procedure UpdateCaption;
    procedure CheckSave(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.UpdateCaption;
begin
  with OpenDialog1 do
    if FileName = '' then
      Caption := Format(CaptionBase, ['[none]'])
    else
      Caption := Format(CaptionBase, [FileName])
end;

procedure TForm1.CheckSave(Sender: TObject);
begin
  if TextChanged then
    if MessageDlg('The current file has changed, do you want to save it?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes
    then
      Save1Click(Sender);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  MessageDlg(Format(CaptionBase, ['demo for Premiere issue of The Delphi Magazine']), mtInformation, [mbOK], 0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CaptionBase := Caption;
  TextChanged := False;
  UpdateCaption;
end;

procedure TForm1.TextControl1Change(Sender: TObject);
begin
  TextChanged := True;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  with OpenDialog1 do
    if FileName = '' then
      SaveAs1Click(Sender)
    else begin
      TextControl1.RTFExport := FileName;
      TextChanged := False;
    end;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
begin
  with SaveDialog1 do begin
    FileName := OpenDialog1.FileName;
    InitialDir := OpenDialog1.InitialDir;
    if Execute and (FileName <> '') then begin
      OpenDialog1.FileName := FileName;
      Save1Click(Sender);
      UpdateCaption;
    end;
  end;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  CheckSave(Sender);
  with OpenDialog1 do
    if Execute then begin
      TextControl1.RTFImport := FileName;
      UpdateCaption;
      TextChanged := False;
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CheckSave(Sender);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  if ClientHeight >=
    (TXButtonBar1.Height +
     TXRuler1.Height +
     TXStatusBar1.Height +  { minimum height for TextControl component }
     TXStatusBar1.Height)
  then begin
    TXStatusBar1.Top := ClientHeight - TXStatusBar1.Height;
    TextControl1.Height := ClientHeight -
      (TXButtonBar1.Height +
       TXRuler1.Height +
       TXStatusBar1.Height);
  end;
  TXButtonBar1.Width := ClientWidth;
  TXRuler1.Width := ClientWidth;
  TextControl1.Width := ClientWidth;
  TXStatusBar1.Width := ClientWidth;
end;

procedure TForm1.Cut1Click(Sender: TObject);
begin
  TextControl1.Clip := 1;
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
  TextControl1.Clip := 2;
end;

procedure TForm1.Paste1Click(Sender: TObject);
begin
  TextControl1.Clip := 3;
end;

procedure TForm1.Clear1Click(Sender: TObject);
begin
  TextControl1.Clip := 4;
end;

procedure TForm1.Find1Click(Sender: TObject);
begin
  TextControl1.FindReplace := 1;
end;

procedure TForm1.Replace1Click(Sender: TObject);
begin
  TextControl1.FindReplace := 2;
end;

end.
