unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, ShellAPI;

type
  TfrmDragPrint = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }

    procedure wmDropFiles(var Message : TMessage); message WM_DROPFILES;
    procedure wmSysCommand(var Message : TWMSysCommand); message WM_SYSCOMMAND;

  public
    { Public declarations }
  end;

var
  frmDragPrint: TfrmDragPrint;

implementation

{$R *.DFM}

{=========================================================}
procedure SetCharacteristics(handle : HWND);
{to set special characteristics for the window on handle}

var
  hSystemMenu : hMenu;

begin
  {turn this window into a drag-drop recipient of file manager}
  DragAcceptFiles(handle, true);

  {make the window icon stay on top, nb set to start minimized}
  SetWindowPos(handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE);

  {get system menu handle}
  hSystemMenu := GetSystemMenu(handle, false);

  {remove unnecessary items from system menu}
  DeleteMenu(hSystemMenu, 2, MF_BYPOSITION);   {size}
  DeleteMenu(hSystemMenu, 3, MF_BYPOSITION);   {maximize}

  {change the Restore menu item to About with a dividing line}
  ModifyMenu(hSystemMenu, 0, MF_BYPOSITION + MF_STRING, SC_RESTORE, '&About...');
  InsertMenu(hSystemMenu, 1, MF_BYPOSITION + MF_SEPARATOR, 0, NIL);

end;

{=========================================================}
procedure TfrmDragPrint.FormCreate(Sender: TObject);
{to perform any initialisation}

begin
	{check if already running, if so just exit cos only need one,
   could set focus to prev inst... but cant be bothered}
  if hPrevInst <> 0 then application.terminate;

  {set up the characteristics for this form}
  SetCharacteristics(handle);
end;

{=========================================================}
procedure TfrmDragPrint.wmDropFiles(var Message : TMessage);
{takes the file(s) dropped on the window and del or print or .. them}

const
  maxPathSize = 68;		{nb max total len of dos path is 67 chars+NULL}

var
  iNumberDropped : integer;
  szPathName : string[maxPathSize];
  II : integer;

begin

  {get the number of files dropped, nb index to first file is 0}
  iNumberDropped := DragQueryFile(THandle(message.wParam), $FFFF, NIL, 0);

  {loop over all the files and delete them}
  for II := 0 to iNumberDropped-1 do
  begin
    DragQueryFile(THandle(message.wParam), II, @szPathName, maxPathSize);
    szPathName := strPas(@szPathName);
    showMessage('Are you reeeeally certain that you want to delete the file: ' + szPathName);
    {DeleteFile(szPathName);}
  end;

  {free the memory holding the dropped files info}
  DragFinish(THandle(message.wParam));

  inherited; {runs the default - mostly harmless!}

end;

{=========================================================}
procedure TfrmDragPrint.wmSysCommand(var Message : TWMSysCommand);
{to process the WM_SYSCOMMAND message for what we want and pass others back}

begin

  case message.CmdType of
    SC_ICON :
    {iconize window
    - got to intercept this msg cos if left to Delphi it resets everything to normal}
    begin
      CloseWindow(handle);
    end;

  else
    {do the default for everything else}
    inherited;
  end;

end;

end.
