unit Persu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, BDay, StdCtrls, ClipBrd, ExtCtrls, Mask;

type
  TForm1 = class(TForm)
    CopyBtn: TButton;
    NameEdit: TEdit;
    AgePaEdit: TEdit;
    BDPaEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    Label3: TLabel;
    PasteBtn: TButton;
    BDMaskEdit: TMaskEdit;
    AgeMaskEdit: TMaskEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Bevel1: TBevel;
    NamePaEdit: TEdit;
    procedure PasteBtnClick(Sender: TObject);
    procedure CopyBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.CopyBtnClick(Sender: TObject);
var
  PersonRec: TPersonRec;
  MyBirthDay: TBirthDay;
begin
  MyBirthDay := TBirthDay.Create(self);
  try
    PersonRec.Name := NameEdit.Text;   { Put data from edit controls into PersonRec }
    PersonRec.Age := StrToInt(AgeMaskEdit.Text);
    PersonRec.BirthDate := StrToDate(BDMaskEdit.Text);
    MyBirthDay.Person := PersonRec;    { Assign the record to the Person property }
    MyBirthDay.CopyToClipboard;        { Copy the data to the clipboard }
  finally
    MyBirthDay.Free;
  end;
end;

procedure TForm1.PasteBtnClick(Sender: TObject);
var
  PersonRec: TPersonRec;
  MyBirthDay: TBirthDay;
begin
  MyBirthDay := TBirthDay.Create(self);
  try
    if ClipBoard.HasFormat(CF_BIRTHDAY) then    { Check if format is available }
    begin
      MyBirthDay.PasteFromClipBoard;            { Get the clipboard data }
      PersonRec := MyBirthDay.Person;           { Copy over the person data }
      NamePaEdit.Text := PersonRec.Name;        { Update the edit controls }
      AgePaEdit.Text := IntToStr(PersonRec.Age);
      BDPaEdit.Text := DateToStr(PersonRec.BirthDate);
      Memo1.PasteFromClipBoard;                 { Data in CF_TEXT format also }
    end;
  finally
    MyBirthDay.Free;
  end;
end;

end.

