unit Enumwndu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    WindowBox: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure WindowBoxKeyPress(Sender: TObject; var Key: Char);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function GetWindowInfo(Wnd: HWnd): String;
var
  Caption: array[0..255] of Char;
  ClassName: array[0..255] of Char;
  ExeName: array[0..255] of Char;
  Instance: Cardinal;
const
  Visibility: array[False..True] of String[8] = ('(hidden)', '');
begin
  GetWindowText(Wnd, Caption, SizeOf(Caption));
  GetClassName(Wnd, ClassName, SizeOf(ClassName));
  {$ifndef WIN32}
  Instance := GetWindowWord(Wnd, gww_HInstance);
  {$else}
  Instance := GetWindowLong(Wnd, gwl_HInstance);
  {$endif}
  GetModuleFileName(Instance, ExeName, SizeOf(ExeName));
  Result :=
    '{' + StrPas(ClassName) + '} ' +
    StrPas(ExeName) + ' "' +
    StrPas(Caption) + '" ' +
    Visibility[GetWindowLong(Wnd, gwl_Style) and ws_Visible <> 0];
end;

function EnumWindowsProc(Wnd: HWnd; UserData: Longint): Bool;
{$ifndef WIN32} export;{$else} stdcall;{$endif}
begin
  Result := True;
  TListBox(UserData).Items.Add(GetWindowInfo(Wnd));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  EnumWindows(@EnumWindowsProc, Longint(WindowBox));
end;

procedure TForm1.WindowBoxKeyPress(Sender: TObject; var Key: Char);
begin
  WindowBox.Clear;
  EnumWindows(@EnumWindowsProc, Longint(WindowBox));
end;

end.
