unit Testw32;       {Draws Bezier curves in Win95/WinNT, which is normally impossible in
Win16}
                    {Written in Delphi for Windows 1.0         }
                    {By Christian Ghisler, CIS: 100332,1175    }
                    {Released to the public domain June 14,1995}
interface

uses
  WinTypes, WinProcs, Forms,
  call32nt, Classes, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Declarations }
  public
    { Public-Declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{Declaration of the 32 bit functions}

var
GetDC:function(wnd,id:longint):longint;
PolyBezier:function(hdc:longint;var
points:tagPoint;count,id:Longint):Longint;
CreatePen:function(style,w,c,id:Longint):Longint;
SelectObject:function(hdc,hpen,id:longint):Longint;
DeleteObject:function(hpen,id:Longint):Longint;
ReleaseDC:function(wnd,hdc,id:Longint):longint;

{Declaration of a unique identifier for each 32 bit function}
var
  idGetDC,
  idReleaseDC,
  idPolyBezier,
  idCreatePen,
  idSelectObject,
  idDeleteObject: LongInt;


procedure TForm1.Timer1Timer(Sender: TObject);
var i:Integer;
    dc, hpen,oldpen:Longint;
    points:array[0..3] of record
       x,y:longint;
     end;

begin
    dc := GetDC (Form1.handle, idGetDC);
    hpen := CreatePen (ps_Solid, 1, trunc (Random * $1000000),
idCreatePen);

    For i:= 0 To 3 do
    begin
      points [i].x := Random (Width);
      points [i].y := Random (Height);
    end;

    OldPen :=SelectObject (dc, hpen, idSelectObject);
    PolyBezier(dc, points, 4, idPolyBezier);
    SelectObject(dc, OldPen, idSelectObject);
    DeleteObject(hpen, idDeleteObject);
    ReleaseDC (Form1.handle,dc,idReleaseDC);
end;

begin
  {Initialization of the 32 bit functions}
  @GetDC:=@Call32;
  @ReleaseDC:=@Call32;
  @PolyBezier:=@Call32;
  @CreatePen:=@Call32;
  @SelectObject:=@Call32;
  @DeleteObject:=@Call32;

  idGetDC:=Declare32('GetDC', 'user32', 'w');
  idReleaseDC:=Declare32('ReleaseDC', 'user32', 'wi');
  idPolyBezier:=Declare32('PolyBezier', 'gdi32', 'ipi');
  idCreatePen:=Declare32('CreatePen', 'gdi32', 'iii');
  idSelectObject:=Declare32('SelectObject', 'gdi32', 'ii');
  idDeleteObject:=Declare32('DeleteObject', 'gdi32', 'I');

  {Check if everything ok }

  if Call32NTError then
  begin
    messagebox(0,'Sorry, cannot load 32 bit system!','testw32',
mb_ok);
    halt(1);
  end;
end.