unit Login0;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls;

type
  TForm1 = class(TForm)
    Database1: TDatabase;
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Button2: TButton;
    procedure Database1Login(Database: TDatabase; LoginParams: TStrings);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    UserName,                { Hold a global user name }
    PassWord: String;        { Holds a global password }
    LoginSuccess: Boolean;   { Determines Login success }
  end;

var
  Form1: TForm1;

implementation
uses Login1;  { Make sure to add this to the uses clause }

{$R *.DFM}

procedure TForm1.Database1Login(Database: TDatabase;
  LoginParams: TStrings);
begin
  { Get the user name and password from the form's variables }
  LoginParams.Values['USER NAME'] := UserName;
  LoginParams.Values['PASSWORD'] := PassWord;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if LoginForm.ShowModal = mrOk then begin
    { Set the form's UserName and Password variables to that specified }
    { by the LoginForm edit controls }
    UserName := LoginForm.UserNameEdit.Text;
    PassWord := LoginForm.PasswordEdit.Text;
    try try
      DataBase1.Connected := false;   { Disconnect the database }
      DataBase1.Connected := true;    { Re-connect the database }
      Table1.Active := true;          { Set the table to active }
      LoginSuccess := true;
      except
        on E:EDBEngineError do begin
          MessageDlg(E.Message, mtError, [mbok], 0);
          LoginSuccess := false;
        end;
      end;
    finally
     { Here you might handle application level security such as hiding or  }
     { displaying controls based on the value of LoginSuccess }
      if LoginSuccess then
        ShowMessage('YES!')
      else
        ShowMessage('Nope');
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  DataBase1.Connected := false;
  UserName := '';
  Password := '';
end;

end.
