unit Hugarayu;
{$X+}
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ArrayU, StdCtrls, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    MemBtn: TButton;
    LowerShowLimit: TSpinEdit;
    LowerBound: TSpinEdit;
    UpperBound: TSpinEdit;
    UpperShowLimit: TSpinEdit;
    ShowBtn: TButton;
    procedure ShowBtnClick(Sender: TObject);
    procedure MemBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    Arr: TArray;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ShowBtnClick(Sender: TObject);
var
  Loop: Longint;
begin
  Memo1.Clear;
  for Loop := LowerShowLimit.Value to UpperShowLimit.Value do
    try
      Memo1.Lines.Add(IntToStr(Arr[Loop]))
    except
      on ERangeError do
    end;
end;

procedure TForm1.MemBtnClick(Sender: TObject);
const
  Caption: Array[Boolean] of String = ('&Deallocate', '&Allocate');
var
  Loop: Longint;
begin
  if not ShowBtn.Enabled then
    try
      Screen.Cursor := crHourGlass;
      try
        Arr := TArray.Create(LowerBound.Value, UpperBound.Value);
        for Loop := Arr.Low to Arr.High do
          Arr[Loop] := Loop;
        ShowBtn.Enabled := True;
        MemBtn.Caption := Caption[not ShowBtn.Enabled];
      finally
        Screen.Cursor := crDefault;
      end
    except
      on E: EOutOfMemory do
        ShowMessage(E.Message);
    end
  else
  begin
    Arr.Free;
    ShowBtn.Enabled := False;
    MemBtn.Caption := Caption[not ShowBtn.Enabled];
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ShowBtn.Enabled then
    Arr.Free;
end;

end.
