{ Source code from Windows Resource Limits
  Tips & Tricks, Issue 4 of The Delphi Magazine }

{ Listing 1 }
procedure TForm1.TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
var
  PresentPage, NewPage : TWinControl;
begin
  if Sender is  TTabbedNotebook then
  begin
    with TTabbedNotebook(Sender) do
    begin
      PresentPage := TWinControl(Pages.Objects[PageIndex]);
      LockWindowUpdate(Handle);
      NewPage := TWinControl(Pages.Objects[NewTab]);
      while PresentPage.ControlCount  > 0 do
        PresentPage.Controls[0].Parent := NewPage;
      LockWindowUpdate(0);
    end;
  end;
end;

{ Listing 2 }
procedure TForm1.TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
var
  aPage: TWinControl;
begin
  if Sender is TTabbedNotebook then
    with TTabbedNotebook(Sender) do
    begin
      aPage := TWinControl(Pages.Objects[PageIndex]);
      LockWindowUpdate(Handle);
      THintWindow(aPage).ReleaseHandle;
      TWinControl(Pages.Objects[NewTab]).HandleNeeded;
      LockWindowUpdate(0);
    end;
end;

{ Listing 3 }
procedure TForm1.TabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
var
  aPage: TWinControl;
begin
  LockWindowUpdate(Handle);
  if Sender is TTabset then
    with TTabSet(Sender)  do
    begin
      if TabIndex > -1 then
      begin
        aPage := TWinControl(Tabs.Objects[TabIndex]);
        THintWindow(aPage).ReleaseHandle;
        TWinControl(Tabs.Objects[NewTab]).HandleNeeded;
      end;
    end;
  LockWindowUpdate(0);
end;


{ Remaining procedures are from Listing 4 }

procedure TMDIChild.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TMDIChild.FormDeactivate(Sender: TObject);
begin
  aBitmap := GetFormImage;
  LockWindowUpdate(Handle);
  THintWindow(Panel1).ReleaseHandle;
  LockWindowUpdate(Handle);
end;

procedure TMDIChild.FormPaint(Sender: TObject);
begin
  if Assigned(aBitmap) then
    Canvas.Draw(0,0,aBitmap);
end;

procedure TMDIChild.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FormResize(nil);
end;

procedure TMDIChild.FormResize(Sender: TObject);
var
   ParentForm: TForm;
begin
   if Assigned(aBitmap) then
        aBitmap.Free;
   aBitmap := nil;
   LockWindowUpdate(Handle);
   Panel1.HandleNeeded;
   ParentForm := GetParentForm(Panel1);
   ParentForm.ActiveControl := Panel1;
   with Panel1 do
   begin
    BringToFront;
    Visible := false;
    Visible := True;
    end;
   LockWindowUpdate(0);
end;
