unit Notifyu;
{$ifdef WIN32}
  This is Windows 3.x-specific
{$endif}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, ThunkU;

const
  wm_DoNotification = wm_User + 65;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ListBox1: TListBox;
    TestBtn: TButton;
    Label1: TLabel;
    NumNfysLbl: TLabel;
    Timer1: TTimer;
    procedure TestBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure WMDoNotification(var Msg: TMessage); message wm_DoNotification;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  ToolHelp, NfyUtil;

{$R *.DFM}

const
  NumNfys: Longint = 0;

function NotifyFunction(wID: Word; dwData: Longint): Bool; export;
begin
  Result := False;
  Inc(NumNfys);
  if not (wID in [nfy_OutStr, nfy_LogError, nfy_LogParamError]) then
    Exit;
  ProblemTask := GetCurrentTask;
  SendMessage(Form1.Handle, wm_DoNotification, wID, dwData);
end;

procedure TForm1.TestBtnClick(Sender: TObject);
begin
  OutputDebugString('Hello world!');
  SetMenu(0, 0);
  SetMenu(Handle, $9876);
  GlobalAlloc(0, 100000000);
end;

procedure TidyUp; far;
begin
  NotifyUnregister(GetCurrentTask);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  NumNfysLbl.Caption := IntToStr(NumNfys);
end;

procedure TForm1.WMDoNotification(var Msg: TMessage);
begin
  with Msg, Listbox1.Items do
    case WParam of
      nfy_OutStr: Add(DoString(LParam));
      nfy_LogError: Add(DoLogError(LParam));
      nfy_LogParamError: Add(DoLogParamError(LParam));
    end;
end;

var
  NotifyFunctionThunk: TFarProc;

procedure TForm1.FormCreate(Sender: TObject);
begin
  if DebuggerRunning then
    MessageDlg('Debugger active - some notifications will be lost',
      mtWarning, [mbOk], 0);
end;

initialization
  NotifyFunctionThunk := NewMakeProcInstance(@NotifyFunction, HInstance);
  NotifyRegister(GetCurrentTask, TNotifyCallBack(NotifyFunctionThunk), nf_Normal);
  AddExitProc(TidyUp);
end.
