program ChangApp;

{$ifdef WINDOWS}
uses
  WinCrt;
{$else}
  {$ifndef CONSOLE}
  'Turn on Project | Options | Linker | Generate console application'
  {$endif}
{$endif}

type
  TWordRec = record
    Lo, Hi: Byte;
  end;

procedure UpdateApp(const FileName: String);
var
  F: File;
  Num, NewExeOffset: Word;
const
  Sig: String[2] = '  ';
begin
  AssignFile(F, FileName);
  try
    Reset(F, 1);
    BlockRead(F, Sig[1], SizeOf(Word));
    if Sig <> 'MZ' then
    begin
      WriteLn('Not a valid EXE file');
      Exit;
    end;
    Seek(F, $18);
    BlockRead(F, Num, SizeOf(Word));
    if Num < $40 then
    begin
      WriteLn('Not a Windows EXE file');
      Exit;
    end;
    Seek(F, $3C);
    BlockRead(F, NewExeOffset, SizeOf(Word));
    Seek(F, NewExeOffset);
    BlockRead(F, Sig[1], SizeOf(Word));
    if Sig <> 'NE' then
    begin
      WriteLn('Not a Windows EXE file');
      Exit;
    end;
    Seek(F, NewExeOffset + $3E);
    BlockRead(F, Num, SizeOf(Word));
    with TWordRec(Num) do
      WriteLn('Current expected Windows version is ', Hi, '.', Lo);
    WriteLn('Setting to 4.0');
    Seek(F, NewExeOffset + $3E);
    Num := $400;
    BlockWrite(F, Num, SizeOf(Word));
  finally
    CloseFile(F);
  end;
end;

var
  Buf: Char;
  Num: Integer;

begin
  if ParamCount = 0 then
  begin
    WriteLn('Pass the filename as a command-line parameter');
    Exit;
  end;
  UpdateApp(ParamStr(1));
  WriteLn;
  Write('Press Enter to exit...');
  ReadLn;
{$ifndef WIN32}
  DoneWinCrt;
{$endif}
end.
