Code Listings for "Private Investigations" by Bob Swart
=======================================================

{ Listing 1 }

 Type
   TPerson = record
     Name: String;
     BirthDay: TDate; { has Year, Month and Day subfields }
     Age: Integer;
   end {TPerson};

   function CalculateAge(BirthDay, Now: TDate): Integer;
   var Age: Integer;
   begin
     Age := Now.Year - BirthDay.Year;
     if (Now.Month < BirthDay.Month) or
       ((Now.Month = BirthDay.Month) and
        (Now.Day < BirthDay.Day)) then Dec(Age); { no birthday this year }
     CalculateAge := Age
   end {CalculateAge};


{ Listing 2 }

 Type
   TPerson = class
     Name: String;
     BirthDay: TDate;
     Age: Integer;

     procedure CalculateAge(Now: TDate);
   end {TPerson};

   procedure TPerson.CalculateAge(Now: TDate): Integer;
   begin
     Age := Now.Year - BirthDay.Year;
     if (Now.Month < BirthDay.Month) or
       ((Now.Month = BirthDay.Month) and
        (Now.Day < BirthDay.Day)) then Dec(Age); { no birthday this year }
   end {CalculateAge};


{ Listing 3 }

 Type
   TPerson = class
   public
     procedure SetName(NewName: String);
     function  GetName: String;
     procedure SetBirthDay(NewBirthDay: TDate); { calls previous CalculateAge }
     function  GetBirthDay: TDate;
     function  GetAge: Integer;

   protected
     Name: String;
     BirthDay: TDate;

   private
     Age: Integer;
   end {TPerson};


{ Listing 4 }

 Type
   TPerson = class (TComponent)
   private
     FName: String;
     FBirthDay: TDate;
     FAge: Integer;

   protected
     procedure SetBirthDay(NewBirthDay: TDate); { calls previous CalculateAge }
     function  GetBirthDay: TDate;
     function  GetAge: Integer;

   published
     property Name: String read FName write FName;
     property BirthDay: TDate read GetBirthDay write SetBirthDay;
     property Age: Integer read GetAge;
   end {TPerson};


{ Listing 5 }

 Type
   TPerson = class (TComponent)
   private
     FName: String;
     FBirthDay: TDate;

   protected
     procedure SetBirthDay(NewBirthDay: TDate); { calls previous CalculateAge }
     function  GetBirthDay: TDate;
     function  GetAge: Integer;

   published
     property Name: String read FName write FName;
     property BirthDay: TDate read GetBirthDay write SetBirthDay;
     property Age: Integer read GetAge;
   end {TPerson};

   { The implementation of the property access methods is as follows: }

   procedure TPerson.SetBirthDay(NewBirthDay: TDate);
   begin
   { we can do some checks here }
     FBirthDay := NewBirthDay;
   end {SetBirthDay};

   function TPerson.GetBirthDay: TDate;
   begin
     GetBirthDay := FBirthDay;
   end {GetBirthDay};


   function TPerson.GetAge: Integer;
   var Age: Integer;
       Now: TDate;
   begin
   { somehow, get the value of Now: TDate }
     Age := Now.Year - FBirthDay.Year;
     if (Now.Month < FBirthDay.Month) or
       ((Now.Month = FBirthDay.Month) and
        (Now.Day < FBirthDay.Day)) then Dec(Age); { no birthday this year }
     GetAge := Age
   end {GetAge};
