unit OoTable;
{Object Oriented Table. At least I think so..}
{we're going to create a property that represents the current record's
unique id }

interface
uses db, dbtables;

type
  TTableUniqueIDField=class(TTable)
  private
    fUniqueID: TField;
  protected
    function GetUniqueID:LongInt;
    procedure SetUniqueID(aValue:LongInt);
  public
    procedure DoAfterOpen; Override;
  published
    property UniqueID: LongInt read GetUniqueID write SetUniqueID stored
false;
    end;  

  {note: while you could make this a component you probably'd want to define
individual
  components for every major table in the system vis inheritance.. but that
get tricky if
  you want tables to know about each other. otoh you can create new instance
of tables
  easy if they have a type. you can set table names in the Create procs so
that you can
  instantiate and open them without knowing a tablename or alias!.. e.g. at
least do:}

  TCustomerTable= class(TTableUniqueIDField); {that's enough to get an alias
type for this}

const
  cUniqueID='UniqueID'; {reference to the field name. use a stringtable
resource! how/help!}

implementation

procedure TTableUniqueIDField.DoAfterOpen;
begin
  inherited DoAfterOpen;
  fUniqueID:=FieldByName(cUniqueId); {raises exception if not there}
  fUniqueID.ReadOnly:=True;          {user can not change the field}
  {now the table is open and the field has been hooked up.}
end;

procedure TTableUniqueIDField.SetUniqueID(aValue:LongInt);
begin
  if State<>dsInactive then {while the table is open}
    with fUniqueID do             {change the property/field if needed}
      if AsInteger<>Value then begin
        ReadOnly:=False;               {gain access}
        AsInteger:=aValue;             {set}
        ReadOnly:=True;                {restrict access} {without
passwording things}
        end
end;

function TTableUniqueIDField.GetUniqueID:LongInt;
begin
  if State<>dsInactive then {while the table is open}
    Result:=fUniqueID.AsInteger {return the property}
  else
    Result:=0;
end;

end.

