unit ChrtFXEx ;
(*****) interface (*******************************)
uses
  SysUtils, 
  WinTypes, 
  WinProcs, 
  Messages, 
  Classes, 
  Graphics, 
  Controls,
  Forms, 
  Dialogs,
  Menus,
  ChartFX,   {import unit for ChartFX constants and function prototypes}
  CustChrt ; {abstract ChartFX VBX wrapper unit } 

type 
  tcfxGridType = ( cfxNoGrid, cfxHorzGrid, cfxVertGrid, cfxBothGrid ) ;

type
  TChart2FXEx = class( TCustChart )
    (**)private(**)
      function GetBorderStyle : TBorderStyle ;
      procedure SetBorderStyle( Value : TBorderStyle ) ;
      function GetGrid : tcfxGridType ;
      procedure SetGrid( Value : tcfxGridType ) ;
    (**)protected(**)
    (**)public(**)
    (**)published(**)
    property BorderStyle: TBorderStyle 
      read GetBorderStyle 
      write SetBorderStyle
      default bsSingle ;

    property Grid : tcfxGridType 
      read GetGrid
      write SetGrid
      default cfxNoGrid ;

    property Align ;
    property Hint ;
    property PopupMenu ;
    property ParentShowHint ;

    property TabOrder ;
    property TabStop ;

    property OnClick ;
    property OnMouseDown ;
    property OnMouseUp ;
    property OnMouseMove ;
    property OnRButtonDown ;
  end;

procedure Register;

(*****) implementation (**************************)

function TChart2FXEx.GetBorderStyle : TBorderStyle ;
begin
  case inherited BorderStyle of
    0 : Result := bsNone ;
    1 : Result := bsSingle ;
  end (* case *) ;
end ;

procedure TChart2FXEx.SetBorderStyle( Value : TBorderStyle ) ;
begin
  case Value of
    bsNone   : inherited BorderStyle := 0 ;
    bsSingle : inherited BorderStyle := 1 ;
  end (* case *) ;
end ;

function TChart2FXEx.GetGrid : TcfxGridType ;
begin
  case inherited Grid of
    CHART_NOGRID   : Result := cfxNoGrid ;
    CHART_HORZGRID : Result := cfxHorzGrid ;
    CHART_VERTGRID : Result := cfxVertGrid ;
    CHART_BOTHGRID : Result := cfxBothGrid ;
  end (* case *) ;
end ;

procedure TChart2FXEx.SetGrid( Value : TcfxGridType ) ;
begin
  case Value of
    cfxNoGrid   : inherited Grid := CHART_NOGRID ;
    cfxHorzGrid : inherited Grid := CHART_HORZGRID ;
    cfxVertGrid : inherited Grid := CHART_VERTGRID ;
    cfxBothGrid : inherited Grid := CHART_BOTHGRID ;
  end (* case *) ;
end ;

procedure Register;
begin
  RegisterComponents( 'VBX', [TChart2FXEx] );
end;

initialization
    (* unit ChrtFXEx  -- initialization code *)
  (* NONE *)
end (* unit ChrtFXEx  -- initialization code *) .
