{$A+,B-,D-,F-,G+,I-,K+,L-,N-,P-,Q-,R-,S+,T-,V-,W-,X+,Y-}
unit MarcoBob;
interface
uses
  WinTypes,
  WinProcs,
  ExptIntf,
  VirtIntf,
  ToolIntf,
  Dialogs,
  Forms,
  MainForm;

Type
  TMarcoBobExpert = class(TIExpert)
  public
    { Expert Style }
    function GetStyle: TExpertStyle; override;

    { Expert Strings }
    function GetName: string; override;
    function GetComment: string; override;
    function GetGlyph: HBITMAP; override;
    function GetState: TExpertState; override;
    function GetIDString: string; override;
    function GetMenuText: string; override;

    { Launch the Expert }
    procedure Execute; override;
  end;

  procedure Register;

implementation
uses Classes, IStreams, SysUtils, NewF;

  function TMarcoBobExpert.GetStyle: TExpertStyle;
  begin
    Result := esStandard
  end {GetStyle};

  function TMarcoBobExpert.GetName: String;
  begin
    Result := 'MarcoBob Expert'
  end {GetName};

  function TMarcoBobExpert.GetComment: String;
  begin
    Result := ''
  end {GetComment};

  function TMarcoBobExpert.GetGlyph: HBITMAP;
  begin
    Result := 0
  end {GetGlyph};

  function TMarcoBobExpert.GetState: TExpertState;
  begin
    Result := [esEnabled]
  end {GetState};

  function TMarcoBobExpert.GetIDString: String;
  begin
    Result := 'Marco.DrBob.Database.Expert'
  end {GetIDString};

  function TMarcoBobExpert.GetMenuText: String;
  begin
    Result := 'Marco && Dr.Bob''s Database Expert'
  end {GetMenuText};


  procedure TMarcoBobExpert.Execute;
  Const Size = 4096;
  var Buffer: Array[1..Size] of Char;
      UnitName, FormName: String;
      FileStream: TFileStream;
      MemoryStream: TMemoryStream;
      IUnitStream,IFormStream: TIMemoryStream;
      ProjectDir: String;
  begin
    if (ToolServices = nil) then
      MessageDlg('ToolServices not available!', mtError, [mbOk], 0)
    else
    begin
      ToolServices.GetNewModuleName(UnitName, FormName);
      ProjectDir := ExtractFilePath(FormName);
      if not Assigned(Form1) then { Create Expert form... }
        Form1 := TForm1.Create(Application);
      { ProjectDir := ExtractFilePath(ToolServices.GetProjectName);
      }
      if ProjectDir[Length(ProjectDir)] = '\' then
        Delete(ProjectDir,Length(ProjectDir),1);
      ChDir(ProjectDir);
      UnitName := ProjectDir + '\' + ChangeFileExt(UnitName,'');
      Form1.UnitName := UnitName;
      UnitName := UnitName + '.PAS';

      if (Form1.ShowModal = idOk) then { Action! }
      begin
        FormName := ProjectDir + '\' +
                    ExtractFileName(ChangeFileExt(FormName, '.DFM'));
        { write form to file }
        WriteComponentResFile(FormName, ResultForm);
        ResultForm.Close; { will free itself }
        ResultForm := nil;
        { copy form data to a IMemoryStream }
        MemoryStream := TMemoryStream.Create;
        FileStream := TFileStream.Create(FormName, fmShareDenyNone);
        repeat until MemoryStream.Write(
          Buffer,FileStream.Read(Buffer,Size)) = 0;
        FileStream.Free;
        MemoryStream.Position := 0;
        IFormStream := TIMemoryStream.Create(MemoryStream);
        IFormStream.OwnStream := True;
        { copy unit data to a IMemoryStream }
        MemoryStream := TMemoryStream.Create;
        FileStream := TFileStream.Create(UnitName, fmShareDenyNone);
        repeat until MemoryStream.Write(
          Buffer,FileStream.Read(Buffer,Size)) = 0;
        FileStream.Free;
        MemoryStream.Position := 0;
        IUnitStream := TIMemoryStream.Create(MemoryStream);
        IUnitStream.OwnStream := True;
        { add unit and form to project }
        ToolServices.CreateModule(UnitName,
                                  IUnitStream,
                                  IFormStream,
                                 [cmAddToProject, cmShowSource, cmShowForm])
      end
      else
        MessageBeep($FFFF)
    end
  end {Execute};


  procedure Register;
  begin
    RegisterLibraryExpert(TMarcoBobExpert.Create)
  end {R_gister};
end.
