unit Filehetc;

interface

procedure DoOp(OpNum: Byte; Exceptions: Boolean);

implementation

uses
  SysUtils, Dialogs, ErrHand;

const
  FileName = 'c:\deleteme.dat';

procedure DoOp(OpNum: Byte; Exceptions: Boolean);
var
  AssignMe, AssignMeNot: File of Byte;
  TxtFile: TextFile;
  B: Byte;
begin
{$ifopt I+}
  if not Exceptions then
    ErrorProc := @ErrorHandler;
{$endif}
  AssignFile(TxtFile, FileName);
  AssignFile(AssignMe, FileName);
  try
    case OpNum of
      2:
        begin
          { Use non-existent file }
          AssignFile(AssignMe, 'zyxwvuts.rqp');
          try
            Rename(AssignMe, 'NewName');
          finally
            { Set file name back to what it was }
            AssignFile(AssignMe, FileName);
          end;
        end;
      3:
        begin
          { Use non-existent pathname }
          AssignFile(AssignMe, '\zyxw\vuts.rqp');
          try
            Rename(AssignMe, 'NewName');
          finally
            { Set file name back to what it was }
            AssignFile(AssignMe, FileName);
          end;
        end;
      4: MessageDlg('This one''s a bit tedious to show',
             mtInformation, [mbOk], 0);
      5:
        begin
          FileMode := fmOpenRead;
          Reset(AssignMe);
          try
            Write(AssignMe, B);
          finally
            CloseFile(AssignMe);
            FileMode := fmOpenReadWrite;
          end;
        end;
      6:
        begin
          TFileRec(AssignMeNot).Mode := fmInOut;
          TFileRec(AssignMeNot).Handle := 255;
          Read(AssignMeNot, B);
        end;
      100:
        begin
          Rewrite(AssignMe);
          try
            Reset(AssignMe);
            { Cause error 100 }
            Read(AssignMe, B);
          finally
            CloseFile(AssignMe);
          end;
        end;
      101: MessageDlg('You don''t want me to fill up your disk, do you?',
             mtConfirmation, [mbNo], 0);
      102: Reset(AssignMeNot); { Use an unassigned file }
      103: Truncate(AssignMeNot); { Use an unopened file }
      104: ReadLn;{ Read from standard input }
      105: WriteLn; { Write to standard output }
      106:
        begin
          Rewrite(TxtFile);
          try
            WriteLn(TxtFile, '1.2.3');
            Reset(TxtFile);
            Read(TxtFile, B);
          finally
            CloseFile(TxtFile);
          end;
        end;
    end;
  except
    on E: EInOutError do
      MessageDlg(Format('EInOutError exception'#13 +
        'Message: %s'#13'Code: %d', [E.Message, E.ErrorCode]),
        mtWarning, [mbOk], 0);
  end;
{$ifopt I-}
  MessageDlg(Format('IOResult = %d', [IOResult]),
             mtWarning, [mbOk], 0);
{$endif}
end;

end.
