
program RecLock;

uses
  WinProcs,
  WinTypes,
  NetLock,
  WinCrt,
  SysUtils;

const
  String1: String = 'Hello world 1';
  String2: String = 'Hello world 2';
  String3: String = 'Hello world 3';

var
  F: File of String;

procedure RunChild;
begin
  WriteLn('Press any key when child has terminated');
  WinExec('RECLOCK2.EXE', sw_ShowNormal);
  ReadKey;
end; { RunChild }

begin
  ScreenSize.X := 70;
  ScreenSize.Y := 10;
  WriteLn('Note: If [V]SHARE is not loaded, this program');
  WriteLn('will not show any file locking.');
  WriteLn;
  AssignFile(F, 'Test.Txt');
  Rewrite(F);
  Write(F, String1);
  Write(F, String2);
  Write(F, String3);
  Close(F);
  FileMode := fmOpenReadWrite + fmShareDenyWrite;
  Reset(F);
  WriteLn('File opened as Read/Write and in Deny Write Mode in parent');
  RunChild;
  Close(F);
  FileMode := fmOpenWrite + fmShareDenyNone;
  Reset(F);
  WriteLn('File opened as Read/Write and in Deny None Mode in parent');
  RunChild;
  if LockFileVar(F, 1, False) then
    WriteLn('Record 1 locked in parent');
  RunChild;
  if LockFileVar(F, 1, True) then
    WriteLn('Record 1 unlocked in parent');
  RunChild;
  CloseFile(F);
  DoneWinCrt;
end. { RecLock }
