unit Xldemo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Oleauto, XlAutom, ToCtrl;

const
  ExcelTrue  = -1;
  ExcelFalse = 0;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    OleAutoClient1: TOleAutoClient;
    Label2: TLabel;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    ComboBox1: TComboBox;
    Label3: TLabel;
    OleContainer1: TOleContainer;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure OleContainer1DblClick(Sender: TObject);
  private
    ExcelObj: TExcelObj;
    WorkBook: TExcelWorkBook;
    CellA1: TExcelRange;
    FontA1: TExcelFont;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ExcelObj := TExcelObj.CreateObject('excel.application');
  ExcelObj.Visible := 0;
  ExcelObj.WorkBooks.FileOpen(ExtractFilePath(ParamStr(0)) + 'xlautovb.xls');
  WorkBook := ExcelObj.ActiveWorkBook;
  CellA1 := ExcelObj.ActiveWorkSheet.Cells(1, 1);
  FontA1 := CellA1.Font;
  CheckBox1.Checked :=  FontA1.Bold = ExcelTrue;
  CheckBox2.Checked := FontA1.Italic = ExcelTrue;
  ComboBox1.Text := IntToStr(FontA1.Size);
  Edit1.Text := CellA1.Value;
  Edit2.Text := CellA1.Value;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  CellA1.Value := Edit1.Text;
  Edit2.Text := CellA1.Value;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  WorkBook.Save;
  ExcelObj.Quit;
  ExcelObj.Release;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    FontA1.Bold := ExcelTrue
  else
    FontA1.Bold := ExcelFalse;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked then
    FontA1.Italic := ExcelTrue
  else
    FontA1.Italic := ExcelFalse;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if Length(ComboBox1.Text) > 0 then begin
    try
      FontA1.Size := StrToInt(ComboBox1.Text);
    except
      on EConvertError do begin
        ComboBox1.Text := IntToStr(FontA1.Size);
      end;
    end;
  end;
end;

procedure TForm1.OleContainer1DblClick(Sender: TObject);
var
  Info: Pointer;
begin
  if not OleContainer1.OleObjAllocated then begin
    if InsertOleObjectDlg(Form1, 0, Info) then begin
      OleContainer1.PInitInfo := Info;
      ReleaseOLEInitInfo(Info);
    end;
  end
  else
    OleContainer1.Active := true;
end;

end.
