unit ALMain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, TabNotBk;

type
  TMainForm = class(TForm)
    Label1: TLabel;
    AliasNames: TListBox;
    Label2: TLabel;
    AliasParams: TMemo;
    Label4: TLabel;
    AliasTables: TListBox;
    Label5: TLabel;
    AliasProcs: TListBox;
    AliasServerName: TEdit;
    Label3: TLabel;
    NewAliasBtn: TButton;
    ShowDBObjectsBtn: TButton;
    ExitBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure AliasNamesClick(Sender: TObject);
    procedure ShowDBObjectsBtnClick(Sender: TObject);
    procedure NewAliasBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  DB, ALNew;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Session.GetAliasNames(AliasNames.Items);
  AliasNames.ItemIndex := 0;
  AliasNamesClick(nil);
end;

procedure TMainForm.AliasNamesClick(Sender: TObject);
begin
  AliasTables.Clear;
  AliasProcs.Clear;
  with AliasNames do
    Session.GetAliasParams(Items[ItemIndex], AliasParams.Lines);
  AliasServerName.Text := AliasParams.Lines.Values['SERVER NAME'];
end;

procedure TMainForm.ShowDBObjectsBtnClick(Sender: TObject);
var
  I: Integer;
begin
  with AliasNames do
  begin
    Session.GetTableNames(Items[ItemIndex], '', False, False, AliasTables.Items);
    try
      Session.GetStoredProcNames(Items[ItemIndex], AliasProcs.Items);
    except
    end;
  end;
end;

procedure TMainForm.NewAliasBtnClick(Sender: TObject);
begin
  NewAliasForm.ShowModal;
  Session.GetAliasNames(AliasNames.Items);
end;

procedure TMainForm.ExitBtnClick(Sender: TObject);
begin
  Close;
end;

end.
