unit Opendlgu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, FileCtrl, Newctrls;

type
  TOpenDlgFrm = class(TForm)
    DriveComboBox1: TNewDriveCombo;
    FilterComboBox1: TFilterComboBox;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    FileName: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FileListBox1DblClick(Sender: TObject);
    procedure DriveComboBox1DriveError(Sender: TObject;
      var Retry: Boolean);
  private
    FMode: Word;
  end;

var
  OpenDlgFrm: TOpenDlgFrm;

implementation

{$R *.DFM}

procedure TOpenDlgFrm.FormCreate(Sender: TObject);
begin
  FMode := SetErrorMode(sem_FailCriticalErrors or
    sem_NoOpenFileErrorBox);
end;

procedure TOpenDlgFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SetErrorMode(FMode);
end;

procedure TOpenDlgFrm.FileListBox1DblClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TOpenDlgFrm.DriveComboBox1DriveError(Sender: TObject;
  var Retry: Boolean);
begin
  Retry := MessageDlg('Can''t find drive. Retry?',
      mtConfirmation, mbOkCancel, 0) = mrOk;
end;

end.
