unit Mbform1;

interface

uses
  SysUtils,
  WinTypes,
  WinProcs,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  ClipBrd,
  StrFunc,
  ExptTool ;

type
  TMBDesigner = class(TForm)
    TestBtn: TButton;
    BuildBtn: TButton;
    PasteBtn: TButton;
    OnTopBtn: TButton;
    ExitBtn: TButton;
    TitleEdit: TEdit;
    MessageEdit: TEdit;
    FormatRGrp: TRadioGroup;
    ButtonsRGrp: TRadioGroup;
    IconRGrp: TRadioGroup;
    DefaultButtonRGrp: TRadioGroup;
    ModalityRGrp: TRadioGroup;
    CommandEdit: TEdit;
    HandleLabel: TLabel;
    HandleEdit: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure TestBtnClick(Sender: TObject);
    procedure BuildBtnClick(Sender: TObject);
    procedure PasteBtnClick(Sender: TObject);
    procedure OnTopBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure FormatRGrpClick(Sender: TObject);
    procedure ButtonsRGrpClick(Sender: TObject);
    procedure IconRGrpClick(Sender: TObject);
    procedure DefaultButtonRGrpClick(Sender: TObject);
    procedure ModalityRGrpClick(Sender: TObject);
    procedure TitleEditChange(Sender: TObject);
    procedure MessageEditChange(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    TheIcon, TheButtons, TheDefaultButton : word ;
    TheTitle, TheMessage,
    StartStr, IconStr, ButtonStr,
    DefaultButtonStr, ModalityStr : string ;
    OnTop : boolean ;
  end ;

var
  MBDesigner: TMBDesigner ;

implementation

{$R *.DFM}

procedure TMBDesigner.FormCreate(Sender: TObject);
begin
  TheMessage := '' ;
  TheTitle := '' ;
  StartStr := 'Application.MessageBox( ' ;
  ButtonStr := ' MB_OK' ;
  OnTop := FALSE ;
  OnTopBtn.Caption := '&On Top' ;
end ;

procedure TMBDesigner.TestBtnClick(Sender: TObject);
var
  MsgBuff, TitleBuff : array [0..127] of char ;
begin
  Application.MessageBox
  (
    StrPCopy( MsgBuff, Trim( MessageEdit.Text, #39 )),
    StrPCopy( TitleBuff, Trim( TitleEdit.Text, #39 )),
    TheButtons or TheIcon or TheDefaultButton
  ) ;
end;

procedure TMBDesigner.BuildBtnClick(Sender: TObject);
begin
  if FormatRGrp.ItemIndex = 0 then
    if HandleEdit.Text <> '' then
      StartStr := StartStr + HandleEdit.Text + ', '
    else
      StartStr := StartStr + 'HWindow, ' ;

  CommandEdit.Text :=
    StartStr
    + TheMessage + ', '
    + TheTitle + ', '
    + ButtonStr
    + IconStr
    + DefaultButtonStr
    + ModalityStr
    + ' ) ; '
end ;

procedure TMBDesigner.PasteBtnClick(Sender: TObject);
var
  Wnd : HWnd ;
begin
  ClipBoard.AsText := CommandEdit.Text ;
  SendMessage( FindChild( 'TEditWindow', 'TEditControl' ), WM_PASTE, 0, 0 ) ;
end ;

procedure TMBDesigner.OnTopBtnClick(Sender: TObject);
begin
  OnTop := not OnTop ;

  case OnTop of
    TRUE :
    begin
      NoStayOnTop( Handle ) ;
      OnTopBtn.Caption := '&On Top' ;
    end ;

    FALSE :
    begin
      StayOnTop( Handle ) ;
      OnTopBtn.Caption := '&Off Top' ;
    end ;

  end ;
end;

procedure TMBDesigner.ExitBtnClick(Sender: TObject);
begin
  Close ;
end ;

procedure TMBDesigner.FormatRGrpClick(Sender: TObject);
begin
  case FormatRGrp.ItemIndex of
    0 :
    begin
      HandleEdit.Enabled := TRUE ;
      HandleLabel.Enabled := TRUE ;
      StartStr := 'MessageBox( ' ;
    end ;

    1 :
    begin
      HandleEdit.Text := '' ;
      HandleEdit.Enabled := FALSE ;
      HandleLabel.Enabled := FALSE ;
      StartStr := 'Application.MessageBox( ' ;
    end ;
  end (* case *) ;

end ;

procedure TMBDesigner.ButtonsRGrpClick(Sender: TObject);
begin
  case ButtonsRGrp.ItemIndex of
    0 :
    begin
      TheButtons := MB_ABORTRETRYIGNORE ;
      ButtonStr := 'MB_ABORTRETRYIGNORE ' ;
    end ;

    1 :
    begin
      TheButtons := MB_OK ;
      ButtonStr := 'MB_OK ' ;
    end ;

    2 :
    begin
      TheButtons := MB_OKCANCEL ;
      ButtonStr := 'MB_OKCANCEL ' ;
    end ;

    3 :
    begin
      TheButtons := MB_RETRYCANCEL ;
      ButtonStr := 'MB_RETRYCANCEL ' ;
    end ;

    4 :
    begin
      TheButtons := MB_YESNO ;
      ButtonStr := 'MB_YESNO ' ;
    end ;

    5 :
    begin
      TheButtons := MB_YESNOCANCEL ;
      ButtonStr := 'MB_YESNOCANCEL ' ;
    end ;

  end (* case *) ;
end ;

procedure TMBDesigner.IconRGrpClick(Sender: TObject);
begin
  case IconRGrp.ItemIndex of
    0 :
    begin
      TheIcon := 0 ;
      IconStr := '' ;
    end ;

    1 :
    begin
      TheIcon := MB_ICONEXCLAMATION ;
      IconStr := 'or MB_ICONEXCLAMATION ' ;
    end ;

    2 :
    begin
      TheIcon := MB_ICONINFORMATION ;
      IconStr := 'or MB_ICONINFORMATION ' ;
    end ;

    3 :
    begin
      TheIcon := MB_ICONQUESTION ;
      IconStr := 'or MB_ICONQUESTION ' ;
    end ;

    4 :
    begin
      TheIcon := MB_ICONSTOP ;
      IconStr := 'or MB_ICONSTOP ' ;
    end ;

  end (* case *) ;
end ;

procedure TMBDesigner.DefaultButtonRGrpClick(Sender: TObject);
begin
  case DefaultButtonRGrp.ItemIndex of
    0 :
    begin
      TheDefaultButton := MB_DEFBUTTON1 ;
      DefaultButtonStr := ''
    end ;

    1 :
    begin
      TheDefaultButton := MB_DEFBUTTON2 ;
      DefaultButtonStr := 'or MB_DEFBUTTON2 '
    end ;

    2 :
    begin
      TheDefaultButton := MB_DEFBUTTON3 ;
      DefaultButtonStr := 'or MB_DEFBUTTON3 '
    end ;

  end (* case *) ;
end ;

procedure TMBDesigner.ModalityRGrpClick(Sender: TObject);
begin
  case ModalityRGrp.ItemIndex of
    0 :
    begin
      ModalityStr := '' ;
    end ;

    1 :
    begin
      ModalityStr := 'or MB_SYSTEMMODAL ' ;
    end ;

    2 :
    begin
      ModalityStr := 'or MB_TASKMODAL ' ;
    end ;

  end (* case *) ;
end ;

procedure TMBDesigner.TitleEditChange(Sender: TObject);
begin
  TheTitle := TitleEdit.Text ;
end ;

procedure TMBDesigner.MessageEditChange(Sender: TObject);
begin
  TheMessage := MessageEdit.Text ;
end ;

end.


