unit Mpdu3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Tabs;

type
  TForm3 = class(TForm)
    PagesGrp: TRadioGroup;
    PresentChk: TCheckBox;
    procedure PresentChkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure HidePage(Notebook: TNotebook; Tabset: TTabset;
      PageNum: Word; Hide: Boolean);
  end;

var
  Form3: TForm3;

implementation

uses
  MpdU4;

{$R *.DFM}

procedure TForm3.HidePage(Notebook: TNotebook; Tabset: TTabset;
  PageNum: Word; Hide: Boolean);
const
  Proxy: TPage = nil;
  ProxyName: String = '';
var
  Page: TPage;
begin
  if Hide then
  begin
    { Can't assign new value to Pages.Objects[i] }
    { Make surrogate parent window instead }
    Proxy := TPage.Create(Self);
    Page := Notebook.Pages.Objects[PageNum] as TPage;
    { Save page name }
    ProxyName := Page.Caption;
    { Transfer all page children to foster parent }
    while Page.ControlCount > 0 do
      Page.Controls[0].Parent := Proxy;
    { Delete target page }
    Tabset.Tabs.Delete(PageNum);
    Notebook.Pages.Delete(PageNum);
    { Sync notebook to tabs and ensure the page shows }
    Notebook.PageIndex := Tabset.TabIndex;
    Page := Notebook.Pages.Objects[Notebook.PageIndex] as TPage;
    Page.Show;
    Page.BringToFront;
  end
  else
  begin
    { Can't use InsertObject - instead use Insert }
    Notebook.Pages.Insert(PageNum, ProxyName);
    Tabset.Tabs.Insert(PageNum, ProxyName);
    Page := Notebook.Pages.Objects[PageNum] as TPage;
    { Move children back to natural parent }
    while Proxy.ControlCount > 0 do
      Proxy.Controls[0].Parent := Page;
    { Sync tabs to notebook and ensure page shows }
    Tabset.TabIndex := Notebook.PageIndex;
    Page.Show;
    Page.BringToFront;
    { Destroy foster parent }
    Proxy.Free;
  end;
end;

procedure TForm3.PresentChkClick(Sender: TObject);
begin
  PagesGrp.Enabled := PresentChk.Checked;
  HidePage(Form4.Notebook, Form4.Tabset, PagesGrp.ItemIndex, not PresentChk.Checked);
end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Application.Terminate;
end;

end.
