unit Options;
interface
uses
{$IFDEF WIN32}
  Windows,
{$ELSE}
  WinTypes, WinProcs,
{$ENDIF}
  SysUtils, Messages, Classes, Graphics, Controls, Forms, Dialogs, FileCtrl, StdCtrls,
  Buttons, ExtCtrls, DB, DBTables;

Type
  TOptionsFrm = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    Label3: TLabel;
    Label4: TLabel;
    OkBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Label5: TLabel;
    Edit1: TEdit;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FileListBox1: TFileListBox;
    CreateBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure CreateBtnClick(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
  end;

{$IFDEF WIN32}
Var
{$ELSE}
Const
{$ENDIF}
  OptionsFrm: TOptionsFrm = nil;

implementation
uses DbiProcs, DbiTypes, DbiErrs;
{$R *.DFM}

procedure TOptionsFrm.FormCreate(Sender: TObject);
var netUserName: DbiUserName;
begin
  if DbiGetNetUserName(netUserName) = DBIERR_NONE then
    Edit1.text := StrPas(netUserName)
  else
    Edit1.text := 'USER'
end;

procedure TOptionsFrm.FileListBox1Change(Sender: TObject);
begin
  Label3.Caption := ExtractFileName(FileListBox1.FileName);
  Label4.Caption := FileListBox1.FileName
end;

procedure TOptionsFrm.OkBtnClick(Sender: TObject);
begin
  if FileListBox1.FileName = '' then
  begin
    MessageBeep($FFFF);
    ModalResult := mrNone
  end
end;

procedure TOptionsFrm.CreateBtnClick(Sender: TObject);
begin
  with TTable.Create(Self) do
  begin
    DatabaseName := DirectoryListBox1.Directory;
    TableName := 'ViCiouS.DB';
    Active := False;
    TableType := ttParadox;
    with FieldDefs do
    begin
      Clear;
      Add('FileName', ftString, 17, True);
      Add('Version', ftInteger, 0, True);
      Add('VersionRevision', ftInteger, 0, True);

      Add('VersionComments', ftMemo, 1, False);
      Add('VersionTimeStamp', ftDateTime, 0, True);

      Add('FileDate', ftDateTime, 0, True);
      Add('FileContents', ftBlob, 0, True);
      Add('FormDate', ftDateTime, 0, True);
      Add('FormContents', ftBlob, 0, False);
      Add('FileReadOnly', ftBoolean, 0, True); { both File & Form }

      Add('Locked', ftBoolean, 0, True);
      Add('LockedBy', ftString, 12, False);
      Add('LockedComments', ftMemo, 1, False);
      Add('LockedTimeStamp', ftDateTime, 0, False)
    end;
    with IndexDefs do
    begin
      Clear;
      Add('Index', 'FileName;Version;VersionRevision', [ixPrimary, ixUnique])
    end;
    CreateTable;
    Free
  end;
  FileListBox1.FileName := DirectoryListBox1.Directory + '\ViCiouS.DB';
{ ModalResult := mrOk }
end;

end.
