unit Snglins1;

{ This unit displays the main window for the application. When you    }
{ click on the 'Create Form' button an instance of TClientForm is     }
{ created. After doing this, TClientForm.DataView property is set     }
{ depending on the state of the radio buttons. After doing this       }
{ DisplayInstanceCounts displays the number of copies for each class. }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids;

type
  TMainWindow = class(TForm)
    BtnCreateForm: TButton;
    GroupBox1: TGroupBox;
    BtnQuit: TButton;
    Label1: TLabel;
    RBAll: TRadioButton;
    RBNumeric: TRadioButton;
    GroupBox2: TGroupBox;
    LblAll: TLabel;
    LblNumeric: TLabel;
    procedure BtnCreateFormClick(Sender: TObject);
    procedure BtnQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure DisplayInstanceCounts;
  end;

var
  MainWindow: TMainWindow;

implementation

{$R *.DFM}

uses SnglIns2, Snglins3, SnglIns9;

const
  Count: Integer = 0;
  WinCreated: Integer = -1;

procedure TMainWindow.BtnCreateFormClick(Sender: TObject);
begin
  with TClientForm.Create(Application) do
    begin
      { Tile each window so it doesn't cover the previous one }
      Inc(WinCreated);
      Top := ((WinCreated mod 10) * 20) + 250;
      Left := ((WinCreated mod 10) * 20) + 20;
      if RBAll.Checked then
        begin
          Caption := 'Client form ' + IntToStr(WinCreated) + ' (All)';
          DataView := dvAll;
        end;
      if RBNumeric.Checked then
        begin
          Caption := 'Client form ' + IntToStr(WinCreated) + ' (Numeric)';
          DataView := dvNumeric;
        end;
      Show;
    end;

  DisplayInstanceCounts;

end;

procedure TMainWindow.BtnQuitClick(Sender: TObject);
begin
  Close;
end;

{ This method is also called from unit SnglIns3 when the client       }
{ window is destroyed. It is simply for illustration purpoeses.       }

procedure TMainWindow.DisplayInstanceCounts;
begin
  LblAll.Caption := IntToStr(TSLSingle.Usage);
  LblNumeric.Caption := IntToStr(TSLSingleNum.Usage);
end;

procedure TMainWindow.FormCreate(Sender: TObject);
begin
  DisplayInstanceCounts;
end;

end.

