unit Copyingu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Mask, Grids, DBGrids, DB, DBTables,
  Menus, DBCtrls;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DataSource2: TDataSource;
    Table2: TTable;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    MaskEdit1: TMaskEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    DBImage1: TDBImage;
    DBMemo1: TDBMemo;
    DBEdit1: TDBEdit;
    Label1: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

uses DBConsts, DbiProcs, DbiTypes;

{$R *.DFM}

procedure CopyTableStructure(Source, Destination: TTable);
begin
 Source.FieldDefs.Update;
 Source.IndexDefs.Update;
 Destination.TableType := Source.TableType;
 Destination.FieldDefs.Assign(Source.FieldDefs);
 Destination.IndexDefs.Assign(Source.IndexDefs);
 Destination.CreateTable;
end;

procedure CopyTable(Source, Destination: TTable; CopyMode: TBatchMode);
var
  Loop: Integer;
begin
  Destination.BatchMove(Source, CopyMode);
  if CopyMode = batCopy then
    with Source.IndexDefs do
    begin
      Update;
      for Loop := 0 to Count - 1 do
        with Items[Loop] do
          Destination.AddIndex(Name, Fields, Options);
    end;
end;

procedure CopyRecord(Source, Destination: TTable);
var
  Loop: Integer;
begin
  try
    Destination.Insert;
    for Loop := 0 to Source.FieldCount - 1 do
      Destination.Fields[Loop].Assign(
        Source.FieldByName(Destination.Fields[Loop].FieldName));
    Destination.Post;
  except
    Destination.Cancel;
    raise;
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Table2.Close;
  Table2.TableName := MaskEdit1.Text;
  CopyTable(Table1, Table2, batCopy);
  Table2.Open;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  Table2.Close;
  Table2.TableName := MaskEdit1.Text;
  CopyTableStructure(Table1, Table2);
  Table2.Open;
  CopyRecord(Table1, Table2);
end;

end.
