unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    ToPrinter: TButton;
    procedure Form1Paint(Sender: TObject);
    procedure ToPrinterClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses Printers;

{$R *.DFM}

procedure PrintRuler(pCanvas: TCanvas);
const
  { In MM_LOMETRIC each unit is 1/100th of a centimeter. Therefore, we need
    a multiplier to be used with the drawing routines. }
  UnitsInCent = 100;
var
  i: integer;
  OldMapMode: integer;
begin
  { First set the mapping mode to MM_LOMETRIC and then draw a bounding
    rectangle }
  OldMapMode := SetMapMode(pCanvas.Handle, MM_LOMETRIC);
  try
    pCanvas.Rectangle(0, 0, 1100, -200);
    { Now draw each line to represent a centimeter and 1/2 centimeter }
    for i := 1 to 10 do begin
      pCanvas.MoveTo(i*UnitsInCent, -0);
      pCanvas.LineTo(i*UnitsInCent, -75);
      pCanvas.MoveTo(i*UnitsInCent-round(UnitsInCent / 2), -0);
      pCanvas.LineTo(i*UnitsInCent-round(UnitsInCent / 2), -50);
      pCanvas.TextOut(i*UnitsInCent-5, -80, IntToStr(i));
    end;
  finally
    SetMapMode(pCanvas.Handle, OldMapMode); // Restore the old mapping mode
  end;
end;

procedure TForm1.Form1Paint(Sender: TObject);
{ This is Form1's OnPaint event handler. It calls the PrintRuler procedure and
  passes the form's Canvas as the parameter }
begin
  PrintRuler(Form1.Canvas);
end;

procedure TForm1.ToPrinterClick(Sender: TObject);
{ This is the OnClick method for the button. It calls the PrintRuler procedure
  but passes the printer's Canvas as the parameter after setting up the
  printer for output. }
begin
  Printer.BeginDoc;           // Initiate a print job
  PrintRuler(Printer.Canvas); // Print the ruler
  Printer.EndDoc;             // Terminate the print job
end;

end.
