unit List2bU;
{$O-}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    LstModules: TListBox;
    Button1: TButton;
    BtnTasks: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnModulesClick(Sender: TObject);
    procedure BtnTasksClick(Sender: TObject);
    procedure ListModules(Sender: TObject);
    procedure ListTasks(Sender: TObject);
  private
    List: TStrings;
  end;

var
  Form1: TForm1;

implementation

uses
  TlHelp32;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  //Use a seperate TStringList rather than the TListbox.Items
  //It will be quicker in Windows 95 due to listbox's being
  //implemented in 16-bit and so requiring thunking for
  //every string operation, as well as all other op.s
  List := TStringList.Create;
  Timer1.OnTimer(Timer1);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  List.Free;
end;

procedure TForm1.BtnModulesClick(Sender: TObject);
begin
  Timer1.OnTimer := ListModules;
  Timer1.OnTimer(Timer1);
end;

procedure TForm1.BtnTasksClick(Sender: TObject);
begin
  Timer1.OnTimer := ListTasks;
  Timer1.OnTimer(Timer1);
end;

procedure TForm1.ListModules(Sender: TObject);
var
  SnapAll, SnapShot: THandle;
  PE: TProcessEntry32;
  ME: TModuleEntry32;
  OldTop, OldItem: Integer;
begin
  //Get all processes
  SnapAll := CreateToolhelp32Snapshot(th32cs_SnapAll, 0);
  try
    PE.dwSize := SizeOf(PE);
    //Loop through all processes
    if Process32First(SnapAll, PE) then
      with LstModules, List do
      begin
        OldTop := TopIndex;
        OldItem := ItemIndex;
        Clear;
        repeat
          //Operate in this process
          SnapShot := CreateToolhelp32Snapshot(
            th32cs_SnapModule, PE.th32ProcessID);
          try
            ME.dwSize := SizeOf(ME);
            //Get all modules for this process in the loop
            if Module32First(SnapShot, ME) then
              repeat
                //Only add unique module names
                //There will be a lot of duplicates
                if IndexOf(StrPas(ME.szModule)) = -1 then
                  Add(StrPas(ME.szModule));
              until not Module32Next(SnapShot, ME);
          finally
            CloseHandle(SnapShot);
          end;
        until not Process32Next(SnapAll, PE);
        Items := List;
        ItemIndex := OldItem;
        TopIndex := OldTop;
      end;
  finally
    CloseHandle(SnapAll);
  end;
end;

procedure TForm1.ListTasks(Sender: TObject);
var
  SnapShot: THandle;
  PE: TProcessEntry32;
  OldTop, OldItem: Integer;
begin
  //Get all processes
  SnapShot := CreateToolhelp32Snapshot(th32cs_SnapAll, 0);
  try
    PE.dwSize := SizeOf(PE);
    //Loop through all processes
    if Process32First(SnapShot, PE) then
      with LstModules, List do
      begin
        OldTop := TopIndex;
        OldItem := ItemIndex;
        Clear;
        repeat
          Add(ExtractFileName(StrPas(PE.szExeFile)));
        until not Process32Next(SnapShot, PE);
        Items := List;
        ItemIndex := OldItem;
        TopIndex := OldTop;
      end;
  finally
    CloseHandle(SnapShot);
  end;
end;

end.
