unit ListU;

interface

uses
  WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, Buttons;

type
  TForm1 = class(TForm)
    LstEntries: TListBox;
    Timer1: TTimer;
    BtnModules: TButton;
    BtnTasks: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BtnModulesClick(Sender: TObject);
    procedure BtnTasksClick(Sender: TObject);
    procedure ListModules(Sender: TObject);
    procedure ListTasks(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
{$ifdef Win32}
  TlHelp16;
{$else}
  ToolHelp;
{$endif}

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Timer1.OnTimer(Timer1);
end;

procedure TForm1.BtnModulesClick(Sender: TObject);
begin
  Timer1.OnTimer := ListModules;
  Timer1.OnTimer(Timer1);
end;

procedure TForm1.BtnTasksClick(Sender: TObject);
begin
  Timer1.OnTimer := ListTasks;
  Timer1.OnTimer(Timer1);
end;

procedure TForm1.ListModules(Sender: TObject);
var
  ME: TModuleEntry;
  OldTop, OldItem: Integer;
begin
  ME.dwSize := SizeOf(ME);
  with LstEntries, Items do
  begin
    BeginUpdate;
    OldTop := TopIndex;
    OldItem := ItemIndex;
    Clear;
    if ModuleFirst(@ME) then
      repeat
        Add(StrPas(ME.szModule));
      until not ModuleNext(@ME);
    ItemIndex := OldItem;
    TopIndex := OldTop;
    EndUpdate;
  end;
end;

procedure TForm1.ListTasks(Sender: TObject);
var
  TE: TTaskEntry;
  OldTop, OldItem: Integer;
begin
  TE.dwSize := SizeOf(TE);
  with LstEntries, Items do
  begin
    BeginUpdate;
    OldTop := TopIndex;
    OldItem := ItemIndex;
    Clear;
    if TaskFirst(@TE) then
      repeat
        Add(StrPas(TE.szModule));
      until not TaskNext(@TE);
    ItemIndex := OldItem;
    TopIndex := OldTop;
    EndUpdate;
  end;
end;

end.
