unit QTFuncsU;

interface

const
  // These are from Delphi 1's WinTypes unit
  gfsr_SystemResources = $0000;
  gfsr_GDIResources    = $0001;
  gfsr_UserResources   = $0002;

function GetFreeSystemResources(SysResource: Word): Word;

implementation

{$define One_Possible_Implementation}

{$ifdef One_Possible_Implementation}
uses
  QTThunkU;

var
  GetFreeSystemRes: Pointer;

//32-bit thunktion for GetFreeSystemResources
function GetFreeSystemResources(SysResource: Word): Word;
var
  EatStackSpace: array[0..$3C] of Char;
begin
  // Make sure to use the local variable so it's not optimised away
  EatStackSpace := '';
  GetFreeSystemRes := GetAddress16(User16Handle, 'GetFreeSystemResources');
  if Assigned(GetFreeSystemRes) then
    asm
      push    SysResource
      mov     edx, [GetFreeSystemRes]
      call    QT_Thunk
      mov     Result, ax
    end;
end;

{$else}

uses
  ToolHelp16;

//Alternative wrapper routine for GetFreeSystemResources
//based on how the real one works
function GetFreeSystemResources(SysResource: Word): Word;
var
  SHI: TSysHeapInfo;
begin
  SHI.dwSize := SizeOf(SHI);
  SystemHeapInfo(@SHI);
  //Set up a possible return value
  Result := SHI.wGDIFreePercent;
  case SysResource of
    gfsr_GDIResources: { GDI value already set up };
    gfsr_UserResources: Result := SHI.wUserFreePercent;
  else
    //If neither GDI nor User value requested
    //return the lower of the two
    if Result > SHI.wUserFreePercent then
      Result := SHI.wUserFreePercent;
  end;
end;
{$endif}

end.
