unit fmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, Grids, DBGrids, DB, DBTables, StdCtrls, Mask;

type
  TfrmMain = class(TForm)
    dbEmployee: TDatabase;
    qryGetEmployees: TQuery;
    dsGetEmployees: TDataSource;
    UpdateSQL1: TUpdateSQL;
    grpEditableView: TGroupBox;
    DBNavigator1: TDBNavigator;
    Panel2: TPanel;
    grdEmployees: TDBGrid;
    btnPost: TButton;
    btnUndoAll: TButton;
    btnExit: TButton;
    grpQuery: TGroupBox;
    memQuery: TMemo;
    chkConnectUpdateSQL: TCheckBox;
    Label1: TLabel;
    lblResultSetState: TLabel;
    procedure Query1UpdateRecord(DataSet: TDataSet;
      UpdateKind: TUpdateKind; var UpdateAction: TUpdateAction);
    procedure FormCreate(Sender: TObject);
    procedure qryGetEmployeesAfterOpen(DataSet: TDataSet);
    procedure chkConnectUpdateSQLClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure btnUndoAllClick(Sender: TObject);
    procedure btnPostClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.Query1UpdateRecord(DataSet: TDataSet;
  UpdateKind: TUpdateKind; var UpdateAction: TUpdateAction);
begin
  if UpdateKind = ukModify then
  begin
    UpdateSQL1.Apply(UpdateKind);
    UpdateAction := uaApplied;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  qryGetEmployees.Open;
  memQuery.Lines.Assign(qryGetEmployees.SQL);
end;

procedure TfrmMain.qryGetEmployeesAfterOpen(DataSet: TDataSet);
begin
  if qryGetEmployees.CanModify then
    lblResultSetState.Caption := 'Modifiable'
  else
    lblResultSetState.Caption := 'Read-Only';
end;

procedure TfrmMain.chkConnectUpdateSQLClick(Sender: TObject);
begin
  with qryGetEmployees do
  begin
    DisableControls;
    try
      Close;

      { Set the UpdateObject property of qryGetEmployees }
      if chkConnectUpdateSQL.Checked then
        UpdateObject := UpdateSQL1
      else
        UpdateObject := nil;
      Open;
    finally
      EnableControls;
    end;
  end;
end;

procedure TfrmMain.btnPostClick(Sender: TObject);
begin
  dbEmployee.ApplyUpdates([qryGetEmployees]);
end;

procedure TfrmMain.btnUndoAllClick(Sender: TObject);
begin
  qryGetEmployees.CancelUpdates;
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
  Close;
end;

end.
