Unit ErrorHandler;

{  Andrew McLellan, teraformation ltd, 1995, 1996}

Interface

Uses
  Classes, SysUtils;

Type
  EError = Class(Exception)
    Messages : TStringList;
    Destructor  Destroy; Override;
    Procedure   Add(Const S : String);
  End;

Procedure NewError(E : Exception; Const NewMessage : String);
  {-Re-raises an exception as an EError with old info kept, adding NewMessage}

Procedure NewErrorFmt(E : Exception; Const NewMessage : String; Args : Array Of Const);
  {-Re-raises an exception as an EError with old info kept, adding NewMessage formatted}

Procedure NewErrorNo(E : Exception; Number : Word);
  {-Re-raises an exception as an EError with the old info kept, looking up the
    new message}

Implementation



{-EError methods----------------------------------------------------------------}

Destructor EError.Destroy;
Begin
  Messages.Free;
  Inherited;
End;


Procedure EError.Add(Const S : String);
Begin
  If Not Assigned(Messages) Then
    Messages := TStringList.Create;
  Messages.Add(S);
End;



{-Procedures--------------------------------------------------------------------}

procedure NewError(E : Exception; Const NewMessage : String);
Var
  NewE : EError;
Begin
  NewE := EError.Create(NewMessage);
  If Assigned(E) Then Begin
    NewE.Messages := TStringList.Create;
    If (E Is EError) And (EError(E).Messages <> Nil) Then
      NewE.Messages.Assign(EError(E).Messages);
    NewE.Messages.Add(E.Message);
  End;
  Raise NewE;
End;


Procedure NewErrorFmt(E : Exception; Const NewMessage : String; Args : Array Of Const);
  {-Raises an EError exception, formatting S with Args}
Begin
  NewError(E, Format(NewMessage, Args));
End;


Procedure NewErrorNo(E : Exception; Number : Word);
Begin
  NewError(E, LoadStr(Number));
End;




End.
