Unit FErrorForm;

{  Andrew McLellan, teraformation ltd, 1995, 1996}

Interface

Uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons, ErrorHandler;

Type
  TErrorForm = class(TForm)
    ErrorLabel: TLabel;
    Bevel1: TBevel;
    PreviousButton: TButton;
    NextButton: TButton;
    CloseButton: TButton;
    procedure FormActivate(Sender: TObject);
    procedure PreviousButtonClick(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
  Private
    ErrPos :    Integer;
    FError :    EError;
    Procedure   Buttons;
    Procedure   Messages;
    Procedure   Position;
  Public
    Property    Error : EError Write FError;
  End;

Const
  ErrorForm: TErrorForm = Nil;

  Procedure ShowError(E : Exception);

implementation


{$R *.DFM}


procedure TErrorForm.FormActivate(Sender: TObject);
begin
  If Assigned(FError.Messages) Then
    ErrPos := FError.Messages.Count
  Else
    ErrPos := 0;
  Position;
  Buttons;
  Messages;
  Screen.Cursor := crDefault;
end;


Procedure TErrorForm.Buttons;
Begin
  PreviousButton.Enabled := ErrPos <> 0;
  NextButton.Enabled := Assigned(FError.Messages) And (ErrPos < FError.Messages.Count);
  ActiveControl := CloseButton;
End;


Procedure TErrorForm.Messages;
Begin
  If Not Assigned(FError.Messages) Or (ErrPos = FError.Messages.Count) Then
    ErrorLabel.Caption := FError.Message
  Else
    ErrorLabel.Caption := FError.Messages[ErrPos];
End;


Procedure TErrorForm.Position;
Begin
  Left := (Screen.Width - Width) Div 2;
  Top := (Screen.Height - Height) Div 2;
End;


procedure TErrorForm.PreviousButtonClick(Sender: TObject);
begin
  Dec(ErrPos);
  Buttons;
  Messages;
end;


procedure TErrorForm.NextButtonClick(Sender: TObject);
begin
  Inc(ErrPos);
  Buttons;
  Messages;
end;


Procedure ShowError(E : Exception);
Begin
  If Not (E Is EAbort) Then Begin
    If E Is EError Then Begin
      ErrorForm.Error := EError(E);
      ErrorForm.ShowModal;
    End Else
      MessageDlg(E.Message, mtError, [mbOk], 0);
  End;
End;


end.
