unit FErrorTestForm;

{  Andrew McLellan, teraformation ltd, 1995, 1996}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBTables;

type
  TForm1 = class(TForm)
    SimpleExceptionButton: TButton;
    CascadingExceptionButton: TButton;
    CloseButton: TButton;
    BDEMistakeButton: TButton;
    procedure SimpleExceptionButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure CascadingExceptionButtonClick(Sender: TObject);
    procedure BDEMistakeButtonClick(Sender: TObject);
  private
    Procedure BDEMistake;
    Procedure Mistake;
    Procedure ExceptionHandler(Sender : TObject; E: Exception);
  public
  end;

var
  Form1: TForm1;

implementation

Uses
  ErrorHandler, FErrorForm;

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
  {-Set the application wide exception handler to point at our own handler}
begin
  Application.OnException := ExceptionHandler;
end;


Procedure TForm1.ExceptionHandler(Sender : TObject; E: Exception);
  {-All application exceptions that haven't been handled end up here. Call the
    error form to show the user the error}
Begin
  ShowError(E);
End;


Procedure TForm1.BDEMistake;
  {-Make a mistake in the BDE}
Var
  T : TTable;
Begin
  T := TTable.Create(Self);
  Try
    Try
      T.Active := True;
    Except
      On E : Exception Do
        NewError(E, 'Error opening customer table');
    End;
  Finally
    T.Free;
  End;
End;


Procedure TForm1.Mistake;
  {-Make a run time error exception}
Var
  I : Integer;
Begin
  I := 0;
  Tag := 1 Div I;
End;


procedure TForm1.CloseButtonClick(Sender: TObject);
begin
  Close;
end;


procedure TForm1.SimpleExceptionButtonClick(Sender: TObject);
  {-Make a run time exception}
begin
  Mistake;
end;


procedure TForm1.BDEMistakeButtonClick(Sender: TObject);
  {-make a BDE error}
begin
  BDEMistake;
end;


procedure TForm1.CascadingExceptionButtonClick(Sender: TObject);
begin
  {$DEFINE ShowTheError}
  Try
    Mistake;
  Except
    {$IFDEF ShowTheError}
    On E : Exception Do
      NewError(E, 'An error occurred when you pressed that button');
    {$ELSE}
    Raise;
    {$ENDIF}
  End;
end;


end.
