{ *****************************************************
                   UnitsInProject Expert

  This expert is designed to read and display the units in an 
  open project.

                    Paul Warren
           HomeGrown Software Development
         (c) 1995 Langley British Columbia.
                  (604) 530-9097
           e-mail:  hg_soft@uniserve.com
     Home page: http://haven.uniserve.com/~hg_soft
  ***************************************************** }

unit UnitsIn;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExptIntf, ToolIntf, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  end;

type
  UnitsInProjectStandardExpert = class(TIExpert)
  public
    function GetStyle: TExpertStyle; override;
    function GetIDString: string; override;
    function GetName: string; override;
    function GetComment: string; override;
    function GetGlyph: HICON; override;
    function GetState: TExpertState; override;
    function GetMenuText: string; override;
    procedure Execute; override;
  end;

procedure Register;

var
  Form1: TForm1;

implementation

uses VirtIntf, IStreams;

{$R *.DFM}

const
  SourceBufferSize = 1024;

procedure Register;
begin
  RegisterLibraryExpert(UnitsInProjectStandardExpert.Create);
end;

{ UnitsInProjectStandardExpert code }
function UnitsInProjectStandardExpert.GetStyle: TExpertStyle;
begin
  Result := esStandard;
end;

function UnitsInProjectStandardExpert.GetIDString: String;
begin
  Result := 'hg_soft.UnitsInProjectStandardExpert';
end;

function UnitsInProjectStandardExpert.GetComment: String;
begin
  Result := ''; { not needed for esStandard }
end;

function UnitsInProjectStandardExpert.GetGlyph: HICON;
begin
  Result := 0; { not needed for esStandard }
end;

function UnitsInProjectStandardExpert.GetName: String;
begin
  Result := 'UnitsInProject Generator'
end;

function UnitsInProjectStandardExpert.GetState: TExpertState;
begin
  Result := [esEnabled]
end;

function UnitsInProjectStandardExpert.GetMenuText: String;
begin
  Result := 'UnitsInProject Standard Expert...'
end;

procedure UnitsInProjectStandardExpert.Execute;
begin
  if not Assigned(Form1) then
    Form1 := TForm1.Create(Application);
  Form1.Show;
  Form1.SetFocus
end;

{ TForm1 code }

procedure TForm1.FormShow(Sender: TObject);
var
  i: integer;
begin
  ListBox1.Clear;
  if ToolServices <> nil then { I'm an expert!! }
    for i := 0 to ToolServices.GetUnitCount do
      ListBox1.Items.Add(ToolServices.GetUnitName(i));
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

end.