unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, Grids, DBGrids, DB, DBTables, StdCtrls, Buttons;

type
  TfrmMain = class(TForm)
    dbEmployee: TDatabase;
    dsGetEmployees: TDataSource;
    grdEmployees: TDBGrid;
    qryGetEmployees: TQuery;
    navEmployees: TDBNavigator;
    qryGetEmployeesFULL_NAME: TStringField;
    qryGetEmployeesDEPT_NO: TStringField;
    qryGetEmployeesSALARY: TFloatField;
    grpSearch: TGroupBox;
    Label1: TLabel;
    edtSearchMask: TEdit;
    btnFindFirst: TButton;
    btnFindNext: TButton;
    grpDirection: TGroupBox;
    btnUp: TRadioButton;
    btnDown: TRadioButton;
    btnClose: TBitBtn;
    procedure dbEmployeeLogin(Database: TDatabase; LoginParams: TStrings);
    procedure FormCreate(Sender: TObject);
    procedure edtSearchMaskChange(Sender: TObject);
    procedure btnFindFirstClick(Sender: TObject);
    procedure btnFindNextClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnDownClick(Sender: TObject);
    procedure btnUpClick(Sender: TObject);
  private
  public
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.dbEmployeeLogin(Database: TDatabase;
  LoginParams: TStrings);
begin
  LoginParams.Values['USER NAME'] := 'SYSDBA';
  LoginParams.Values['PASSWORD'] := 'masterkey';
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  qryGetEmployees.Open;
end;

procedure TfrmMain.edtSearchMaskChange(Sender: TObject);
begin
  btnFindFirst.Enabled := edtSearchMask.Text <> '';
  btnFindNext.Enabled := btnFindFirst.Enabled;

  if edtSearchMask.Text = '' then
    qryGetEmployees.Filter := ''
  else
    qryGetEmployees.Filter := Format('Dept_No = ''%s''', [edtSearchMask.Text]);
end;

procedure TfrmMain.btnFindFirstClick(Sender: TObject);
begin
  with qryGetEmployees do
  begin
    if btnDown.Checked then FindFirst
    else FindLast;
    if not Found then
      MessageDlg('No matches found.', mtError, [mbOk], 0);
  end;
end;

procedure TfrmMain.btnFindNextClick(Sender: TObject);
begin
  with qryGetEmployees do
  begin
    if btnDown.Checked then FindNext
    else FindPrior;
    if not Found then
      MessageDlg('No matches found.', mtError, [mbOk], 0);
  end;
end;

procedure TfrmMain.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.btnUpClick(Sender: TObject);
begin
  btnFindFirst.Caption := 'Find &Last';
  btnFindNext.Caption := 'Find &Previous';
end;

procedure TfrmMain.btnDownClick(Sender: TObject);
begin
  btnFindFirst.Caption := 'Find &First';
  btnFindNext.Caption := 'Find &Next';
end;

end.
