{ LISTINGS FOR VARIANTS ARTICLE BY XAVIER PACHECO }
{ THE DELPHI MAGAZINE SEPTEMBER 1996 }

{LISTING 1}
var
  V: Variant;
begin
  V := 'Delphi 2.0 is Great!'; // Variant holds a string
  V := 1;		        // Variant now holds an integer
  V := 123.34;                // Variant now holds a floating point
  V := True;			// Variant holds a boolean
end;

{LISTING 2}
TVarData = record
    VType: Word;
    Reserved1, Reserved2, Reserved3: Word;
    case Integer of
      varSmallint: (VSmallint: Smallint);
      varInteger:  (VInteger: Integer);
      varSingle:   (VSingle: Single);
      varDouble:   (VDouble: Double);
      varCurrency: (VCurrency: Currency);
      varDate:     (VDate: Double);
      varOleStr:   (VOleStr: PWideChar);
      varDispatch: (VDispatch: Pointer);
      varError:    (VError: Integer);
      varBoolean:  (VBoolean: WordBool);
      varUnknown:  (VUnknown: Pointer);
      varByte:     (VByte: Byte);
      varString:   (VString: Pointer);
      varArray:    (VArray: PVarArray);
      varByRef:    (VPointer: Pointer);
  end;

{LISTING 3}
{ Variant type codes }

  varEmpty    = $0000;
  varNull     = $0001;
  varSmallint = $0002;
  varInteger  = $0003;
  varSingle   = $0004;
  varDouble   = $0005;
  varCurrency = $0006;
  varDate     = $0007;
  varOleStr   = $0008;
  varDispatch = $0009;
  varError    = $000A;
  varBoolean  = $000B;
  varVariant  = $000C;
  varUnknown  = $000D;
  varByte     = $0011;
  varString   = $0100;
  varTypeMask = $0FFF;
  varArray    = $2000;
  varByRef    = $4000;

{LISTING 4}
procedure ShowVariant;
var
  V: Variant
begin
  { First allocate memory for the string and make the assignment }
  try
    V := This is a long string;
    ShowMessage(V);
  finally
    { Now free the memory associated with the variant }
  end;
end;

{LISTING 5}
procedure ChangeVariant;
var
  V: Variant
begin
  { First allocate memory for the string and make the assignment }
  try
    V := This is a long string;
  finally
    { Now free the memory associated with the variant before making the assignment
      below }
  end;
  V := 34;
end;
{ SECOND PART...}
procedure ChageVariant;
var
  V: Variant
begin
  V := This is a long string;
  TVarData(V).VType := varInteger;
  TVarData(V).VInteger := 32;
  V := 34;
end;

{LISTING 6}
S := String(V);    // S will contain the string 1.6;
I := Integer(V);   // I is rounded to the nearest integer value, in this case - 2.
B := Boolean(V);   // B contains false if V contains 0, otherwise B is true
D := Double(V);    // D contains the value 1.6

{LISTING 7}
var
  V1, V2, V3: Variant;
begin
  V1 := '100';  // A String type
  V2 := '50';   // A String type
  V3 := 200;    // An Integer type
  V1 := V1 + V2 + V3;
end;

{LISTING 8}
procedure VarArrayRedim(var A: Variant; HighBound: Integer);
function VarArrayDimCount(const A: Variant): Integer;
function VarArrayLowBound(const A: Variant; Dim: Integer): Integer;
function VarArrayHighBound(const A: Variant; Dim: Integer): Integer;
function VarArrayLock(const A: Variant): Pointer;
procedure VarArrayUnlock(const A: Variant);
function VarArrayRef(const A: Variant): Variant;
function VarIsArray(const A: Variant): Boolean;

{LISTING 9}
procedure VarClear(var V: Variant);
procedure VarCopy(var Dest: Variant; const Source: Variant);
procedure VarCast(var Dest: Variant; const Source: Variant; VarType: Integer);
function VarType(const V: Variant): Integer;
function VarAsType(const V: Variant; VarType: Integer): Variant;
function VarIsEmpty(const V: Variant): Boolean;
function VarIsNull(const V: Variant): Boolean;
function VarToStr(const V: Variant): string;
function VarFromDateTime(DateTime: TDateTime): Variant;
function VarToDateTime(const V: Variant): TDateTime;
