unit Exceptsu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    procedure DoException(Sender: TObject; E: Exception);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure Delay(MSec: Longint);
const
  MSecPerDay = 24 * 60 * 60 * 1000;
var
  OldTime: TDateTime;
begin
  OldTime := Time;
  repeat
    Application.ProcessMessages;
    if Application.Terminated then
      Break
  until Time >= OldTime + MSec / MSecPerDay;
end;

procedure TForm1.DoException(Sender: TObject; E: Exception);
var
  S: String;
begin
{$ifdef Win32}
  if E is EAccessViolation then
{$else}
  if E is EGPFault then
{$endif}
  begin
    S := Caption;
    Caption := 'Ouch!';
    Delay(750);
    Caption := S
  end
  else
    MessageDlg(E.ClassName + ': ' + E.Message,
      mtError, [mbCancel], 0)
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnException := DoException
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  P: PByte;
begin
  P^ := 0 {Generate a GPF or AV }
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  StrToInt('A') { A is not a valid integer}
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  { Invalid typecast }
  (Sender as TListBox).ItemIndex := 0;
end;

end.
