unit PassWrdU;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, Grids, DBGrids, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  DbiProcs, DbiTypes, DBPwDlg;

{$R *.DFM}

procedure ChangePXPassword(Tbl: TTable; const Password: String);
var
  hDb: hDbiDb;
  TblDesc: CRTblDesc;
  DBName: array[0..dbiMaxNameLen] of Char;
begin
  Tbl.DisableControls;
  try
    Tbl.Close;
    FillChar(TblDesc, SizeOf(TblDesc), 0);
    TblDesc.bProtected := True;
    StrPCopy(TblDesc.szPassword, Password);
    StrPCopy(TblDesc.szTblName, Tbl.TableName);
    StrCopy(TblDesc.szTblType, szParadox);
    StrPCopy(DBName, Tbl.DatabaseName);
    Check(DbiOpenDatabase(DBName, szCfgDBStandard,
      dbiReadWrite, dbiOpenExcl, nil, 0, nil, nil, hDb));
    Check(DbiDoRestructure(hDb, 1, @TblDesc, nil, nil, nil, False));
    Check(DbiCloseDatabase(hDb));
    Tbl.Open;
  finally
    Tbl.EnableControls;
  end;
end;

{ There must be a password in the Session object for this to work }
procedure RemovePXPassword(Tbl: TTable);
var
  hDb: hDbiDb;
  TblDesc: CRTblDesc;
  DBName: array[0..dbiMaxNameLen] of Char;
begin
  Tbl.DisableControls;
  try
    Tbl.Close;
    FillChar(TblDesc, SizeOf(TblDesc), 0);
    StrPCopy(TblDesc.szTblName, Tbl.TableName);
    StrCopy(TblDesc.szTblType, szParadox);
    StrPCopy(DBName, Tbl.DatabaseName);
    Check(DbiOpenDatabase(DBName, szCfgDBStandard,
      dbiReadWrite, dbiOpenExcl, nil, 0, nil, nil, hDb));
    Check(DbiDoRestructure(hDb, 1, @TblDesc, nil, nil, nil, False));
    Check(DbiCloseDatabase(hDb));
  finally
    Tbl.EnableControls;
  end;
  Tbl.Open;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ChangePXPassword(Table1, 'HelloWorld');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  RemovePXPassword(Table1);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Session.RemoveAllPasswords
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Session.AddPassword('HelloWorld')
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Table1.Open
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Table1.Close
end;

end.
