unit Deldirs;

interface

uses SysUtils,Controls,Forms,Dialogs;

procedure Delete_Tree ( Dir_Path: string);
procedure Delete_Directories_Files ( const Dir_Path: string);
procedure Found_File_Or_Directory
           ( const SearchRec: TSearchRec; const Dir_Path: string );

implementation

{The next line will make all run-time I/O errors into exceptions.}
{$I+}

procedure Delete_Tree ( Dir_Path: string);
var
   Old_Screen_Cursor: TCursor;
begin
  Old_Screen_Cursor:= Screen.Cursor;
  Screen.Cursor:=     crHourGlass;
  Application.ProcessMessages;
  try
     if Copy( Dir_Path, Length(Dir_Path),1) <> '\' then
        Dir_Path:= Dir_Path + '\';
     Delete_Directories_Files ( Dir_Path );
  finally
         Screen.Cursor:= Old_Screen_Cursor;
  end;
end; { Delete_Dirs}


procedure Delete_Directories_Files ( const Dir_Path: string);
var
   SearchRec: TSearchRec;
   Directory_FileMask: string;
   DelDir: string;
   NewDir: string;
begin
  Directory_FileMask:= Dir_Path + '*.*';
  {Search for files & directories in current directory}
  if FindFirst (Directory_FileMask, faAnyFile, SearchRec) = 0 then
    begin
      Found_File_Or_Directory ( SearchRec, Dir_Path );
      while ( FindNext (SearchRec) = 0 ) do
         Found_File_Or_Directory ( SearchRec, Dir_Path );
    end;
  FindClose (SearchRec);
  {Now remove the current directory}
  {Must remove slash at end of Dir_Path}
  DelDir:=  LowerCase(Copy(Dir_Path, 1, Length(Dir_Path)-1));
  try
     RmDir ( DelDir ) ;
  except
        on E: EInOutError do
           {I/O Error 16 means that the directory is in use.
            So change directory}
           if E.ErrorCode = 16 then
              begin
                {Get parent directory}
                NewDir:= ExtractFilePath(DelDir);
                {Don't want the last slash}
                NewDir:= Copy(NewDir,1,Length(NewDir)-1);
                ChDir(NewDir);
                RmDir (DelDir);
              end
           else
               raise;
  end; { except }
end; { Delete_Directories_Files }


procedure Found_File_Or_Directory
           ( const SearchRec: TSearchRec; const Dir_Path: string );
begin
  {Make sure its not a pointer to a parent directory}
  if ( (SearchRec.Name <> '.') and (SearchRec.Name <> '..') ) then
     {See if file}
     if (SearchRec.Attr and faDirectory = 0) then
        begin
          if not DeleteFile ( Dir_Path + SearchRec.Name) then
             raise Exception.Create('Can''t delete file: Dir_Path + SearchRec.Name');
        end
     {else must be a directory}
     else
          {Delete any files or directories in directory found}
          Delete_Directories_Files ( Dir_Path + SearchRec.Name + '\');
end; {. Found_File_Or_Directory}


end.
