{$A+,B-,D-,E-,F-,G-,I+,L-,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$APPTYPE CONSOLE}
{.$DEFINE BOLESIAN}
{.$DEFINE DEBUG}
uses
  SysUtils, TBDosEnv, TDMBKS16, TDMBKS32;

Const
{$IFDEF BOLESIAN}
  root16 = 'http://www.bolesian.nl/groups/delphi/delbook1.htm/';
  root32 = 'http://www.bolesian.nl/groups/delphi/delbook2.htm/';
{$ELSE}
  root16 = 'http://members.aol.com/drbobnl/delbook1.htm/';
  root32 = 'http://members.aol.com/drbobnl/delbook2.htm/';
{$ENDIF}


Type
  TDataRec = record
    Delphi1: Boolean;
    Delphi2: Boolean;
    Title: String[64];
    Author: String[64];
    Publisher: String[32];
    ISBN: String[16];
    Level: Integer; { beginner, intermediate, advanced
    TechnicalContentsQuality: Integer;
    QualityOfWriting: Integer;
    ValueForMoney: Integer;
    OverallAssessment: Integer; }
  end;

var
  Data: String;
  Level: Array[1..3] of String[3] = ('Beg','Int','Adv');
  Roman: Array[1..5] of String[3] = ('I','II','III','IV','V');

  function Value(Const Field: ShortString): ShortString;
  var i: Integer;
  begin
    Result := '';
    i := Pos(Field+'=',Data);
    if i > 0 then
    begin
      Inc(i,Length(Field)+1);
      while Data[i] <> '&' do
      begin
        Result := Result + Data[i];
        Inc(i)
      end
    end
  end {Value};

  function ValueAsInteger(Str: ShortString): Integer;
  begin
    Result := 0;
    Str := Value(Str);
    if Str <> '' then
    try
      result := StrToInt(Str)
    except
    end;
  end {ValueAsInteger};

var
  Result16: Array[1..Books16] of Word; { hits }
  Result32: Array[1..Books32] of Word; { hits }
  DataRec: TDataRec;
  ContentLength,Hits,i,j: Integer;
  Hex: String[3];

begin
  writeln('HTTP/1.0 200 OK');
  writeln('SERVER: Bolesian Intranet WebServer 1.0');
  writeln('CONTENT-TYPE: TEXT/HTML');
  writeln;
  writeln('<HTML>');
  writeln('<TITLE>');
  writeln('The Delphi Magazine On-Line Review Database of Delphi Books');
  writeln('</TITLE>');
  writeln('<BODY>');
  writeln('<I>Generated by Dr.Bob''s CGI-Expert on </I>',DateTimeToStr(Now));

  with TBDosEnvironment.Create(nil) do
  begin
    for i := 0 to Pred(DosEnvCount) do
    begin
      if Pos('REQUEST_METHOD',DosEnvList[i]) > 0 then
      begin
        Data := DosEnvList[i];
        Delete(Data,1,Pos('=',Data))
      end
    end;

    if Data = 'POST' then
    begin
      ContentLength := StrToInt(GetDosEnvStr('CONTENT_LENGTH'));
      SetLength(Data,ContentLength+1);
      j := 0;
      for i:=1 to ContentLength do
      begin
        Inc(j);
        read(Data[j]);
        if Data[j] = '_' then Data[j] := ' ';
        if (Data[j] = '%') then { special code }
        begin
          Hex := '$00';
          read(Hex[2]);
          read(Hex[3]);
          try
            Data[j] := Chr(StrToInt(Hex))
          except
            Data[j] := '%' { error }
          end
        end
      end;
      Data[j+1] := '&';
      DataRec.Delphi1 := True;
      DataRec.Delphi2 := True;
      case ValueAsInteger('DELPHI') of
        1: DataRec.Delphi2 := False;
        2: DataRec.Delphi1 := False
      end;
      DataRec.ISBN := Value('ISBN');
      DataRec.Title := Value('Title');
      DataRec.Author := Value('Author');
      DataRec.Publisher := Value('Publisher');
      DataRec.Level := ValueAsInteger('Level');
    { DataRec.TechnicalContentsQuality := ValueAsInteger('TechnicalContentsQuality');
      DataRec.QualityOfWriting := ValueAsInteger('QualityOfWriting');
      DataRec.ValueForMoney := ValueAsInteger('ValueForMoney');
      DataRec.OverallAssessment := ValueAsInteger('OverallAssessment');
    end
    else
    begin
      DataRec.Level := 1;
      DataRec.Delphi1 := True;
      DataRec.Delphi2 := True;
      DataRec.Publisher := 'WROX Press';
      DataRec.Author := 'Bob Swart'; }
    end;
  {$IFDEF DEBUG}
    writeln('<HR>');
    writeln('<H3>The following query was executed:</H3>');
  {$ENDIF}

    if DataRec.Level > 0 then
    begin
    {$IFDEF DEBUG}
      writeln('Level: ',DataRec.Level,'<BR>');
    {$ENDIF}
      for i:=1 to Books16 do
        if Book16[i].Level = DataRec.Level then Inc(Result16[i]);
      for i:=1 to Books32 do
        if Book32[i].Level = DataRec.Level then Inc(Result32[i])
    end;
    if DataRec.Title <> '' then
    begin
    {$IFDEF DEBUG}
      writeln('Title: ',DataRec.Title,'<BR>');
    {$ENDIF}
      for i:=1 to Books16 do
        if Pos(DataRec.Title,Book16[i].Title) > 0 then Inc(Result16[i]);
      for i:=1 to Books32 do
        if Pos(DataRec.Title,Book32[i].Title) > 0 then Inc(Result32[i])
    end;
    if DataRec.Author <> '' then
    begin
    {$IFDEF DEBUG}
      writeln('Author: ',DataRec.Author,'<BR>');
    {$ENDIF}
      for i:=1 to Books16 do
        if Pos(DataRec.Author,Book16[i].Author) > 0 then Inc(Result16[i]);
      for i:=1 to Books32 do
        if Pos(DataRec.Author,Book32[i].Author) > 0 then Inc(Result32[i])
    end;
    if DataRec.Publisher <> '' then
    begin
    {$IFDEF DEBUG}
      writeln('Publisher: ',DataRec.Publisher,'<BR>');
    {$ENDIF}
      for i:=1 to Books16 do
        if Pos(DataRec.Publisher,Book16[i].Publisher) > 0 then Inc(Result16[i]);
      for i:=1 to Books32 do
        if Pos(DataRec.Publisher,Book32[i].Publisher) > 0 then Inc(Result32[i])
    end;
    if DataRec.ISBN <> '' then
    begin
    {$IFDEF DEBUG}
      writeln('ISBN: ',DataRec.ISBN,'<BR>');
    {$ENDIF}
      for i:=1 to Books16 do
        if Book16[i].ISBN = DataRec.ISBN then Inc(Result16[i]);
      for i:=1 to Books32 do
        if Book32[i].ISBN = DataRec.ISBN then Inc(Result32[i])
    end;
    writeln('<HR>');
    writeln('<P>');
    writeln('<H3>The following books have been found for you:</H3>');
    writeln('<TABLE BORDER>');
    writeln('<TR>');
    writeln('<TH><B>Hits</B></TH>');
    writeln('<TH><B>Title</B></TH>');
    writeln('<TH><B>Author</B></TH>');
    writeln('<TH><B>Publisher</B></TH>');
    writeln('<TH><B>ISBN</B></TH>');
    writeln('<TH><B>Level</B></TH>');
    writeln('<TH>Con</TH>');
    writeln('<TH>Wri</TH>');
    writeln('<TH>Val</TH>');
    writeln('<TH><B>Tot</B></TH>');
    writeln('</TR>');

    if DataRec.Delphi2 then
    begin
      for Hits := 5 downto 1 do
      begin
        for i:=1 to Books32 do if Result32[i] = Hits then
        begin
          writeln('<TR>');
          writeln('<TD>',Roman[Hits],'</TD>');
          writeln('<TD><A HREF="',root32,Book32[i].HREF,'">',Book32[i].Title,'</A></TD>');
          writeln('<TD>',Book32[i].Author,'</TD>');
          writeln('<TD>',Book32[i].Publisher,'</TD>');
          writeln('<TD>',Book32[i].ISBN,'</TD>');
          writeln('<TD>',Level[Book32[i].Level],'</TD>');
          writeln('<TD>',Book32[i].TechnicalContentsQuality,'</TD>');
          writeln('<TD>',Book32[i].QualityOfWriting,'</TD>');
          writeln('<TD>',Book32[i].ValueForMoney,'</TD>');
          writeln('<TD><B>',Book32[i].OverallAssessment,'</B></TD>');
          writeln('</TR>')
        end
      end;
      if DataRec.Delphi1 then writeln('<TR></TR>')
    end;
    if DataRec.Delphi1 then
    begin
      for Hits := 5 downto 1 do
      begin
        for i:=1 to Books16 do if Result16[i] = Hits then
        begin
          writeln('<TR>');
          writeln('<TD>',Roman[Hits],'</TD>');
          writeln('<TD><A HREF="',root16,Book16[i].HREF,'">',Book16[i].Title,'</A></TD>');
          writeln('<TD>',Book16[i].Author,'</TD>');
          writeln('<TD>',Book16[i].Publisher,'</TD>');
          writeln('<TD>',Book16[i].ISBN,'</TD>');
          writeln('<TD>',Level[Book16[i].Level],'</TD>');
          writeln('<TD>',Book16[i].TechnicalContentsQuality,'</TD>');
          writeln('<TD>',Book16[i].QualityOfWriting,'</TD>');
          writeln('<TD>',Book16[i].ValueForMoney,'</TD>');
          writeln('<TD><B>',Book16[i].OverallAssessment,'</B></TD>');
          writeln('</TR>')
        end
      end
    end;

    writeln('</TABLE>');
    writeln('<BR>');
    writeln('Thank you for using the TDMBKS on-line review database of Delphi Books!');
    writeln('<BR>');
    writeln('<HR>');
  {$IFDEF BOLESIAN}
    writeln('<A HREF="http://www.bolesian.nl/groups/delphi/home.htm">Dr.Bob''s Delphi Clinic</A>');
  {$ELSE}
    writeln('<A HREF="http://home.pi.net/~drbob/">Dr.Bob''s Delphi Clinic</A>');
  {$ENDIF}
    writeln('</BODY>');
    writeln('</HTML>');
    writeln;
    Free
  end
end.
