unit delcompo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, COMSlidr, delowl;

type
  TDelOwlHSlider = class(TDelOwlControl)
  private
    { Private declarations }
     FOnChange  : TNotifyEvent;
     FTic       : integer;
     procedure FOnChangeInternal(Sender : TObject); cdecl; export;

  protected
    { Protected declarations }
    procedure SetOnChange(func : TNotifyEvent); virtual;
    function  GetPos : integer;       virtual;
    procedure SetPos(pos : integer);  virtual;
    function  GetMinRange : integer;  virtual;
    function  GetMaxRange : integer;  virtual;
    procedure SetMinRange(amin: integer); virtual;
    procedure SetMaxRange(amax: integer); virtual;
    procedure SetTicGap(aticGap: integer);virtual;
  public
    { Public declarations }
     constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }

    property OnChange  : TNotifyEvent  read FOnChange write SetOnChange;
    property Position  : integer read GetPos write SetPos;
    property Min       : integer read GetMinRange write SetMinRange;
    property Max       : integer read GetMaxRange write SetMaxRange;
    property TicGap    : integer read FTic write SetTicGap;

  end;

procedure Register;

implementation


procedure TDelOwlHSlider.FOnChangeInternal(Sender : TObject);
begin
  if (csDesigning in ComponentState) or
     (csLoading in ComponentState)then Exit;
  if Assigned(FOnChange) then FOnChange(Self);
end;

procedure TDelOwlHSlider.SetOnChange(func : TNotifyEvent);
begin
  FOnChange := func;
  TCOMSliderInterface(OWLHelpControl).SetOnChange(FOnChangeInternal);
end;

procedure TDelOwlHSlider.SetPos(pos : integer);
begin
   TCOMSliderInterface(OWLHelpControl).Position := pos;
end;

function TDelOwlHSlider.GetPos : integer;
begin
  Result := TCOMSliderInterface(OWLHelpControl).Position;
end;

function TDelOwlHSlider.GetMinRange : integer;
begin
  Result := TCOMSliderInterface(OWLHelpControl).Min;
end;

function TDelOwlHSlider.GetMaxRange : integer;
begin
   Result := TCOMSliderInterface(OWLHelpControl).Max;
end;

procedure TDelOwlHSlider.SetMinRange(amin: integer);
begin
   TCOMSliderInterface(OWLHelpControl).Min := amin;
end;

procedure TDelOwlHSlider.SetMaxRange(amax: integer);
begin
    TCOMSliderInterface(OWLHelpControl).Max := amax;
end;

procedure TDelOwlHSlider.SetTicGap(aticGap: integer);
begin
 FTic := aticGap;
 TCOMSliderInterface(OWLHelpControl).TicGap := aticGap;
end;


constructor TDelOwlHSlider.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  TicGap   := 10;
end;


procedure Register;
begin
  RegisterComponents('Samples', [TDelOwlHSlider]);
end;

end.
