unit Inmemtab;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DbiProcs, DbiTypes, DBTables;

type
  TInMemTable = class(TDBDataset)
  private
    { Private declarations }
    FBorrowFrom: TTable;
  protected
    { Protected declarations }
    procedure CheckIsBorrowFromACtive;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    function CreateHandle: HDbiCur; override;
  published
    { Published declarations }
    property BorrowFrom: TTable read FBorrowFrom write FBorrowFrom;
  end;

procedure Register;

implementation

constructor TInMemTable.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FBorrowFrom := nil;
end;

function TInMemTable.CreateHandle: HDbiCur;
var PFieldDescs: Pointer;
    Props: CURProps;
    szTableName: DBITBLNAME;
begin
  Result := nil;
  PFieldDescs := nil;
  CheckIsBorrowFromActive;

  StrPCopy(szTableName, 'INMEMORYTABLE');
  Check(DbiGetCursorProps(FBorrowFrom.Handle, Props));
  try
    PFieldDescs := AllocMem(Props.iFields * sizeof(FLDDesc));
    Check(DbiGetFieldDescs(FBorrowFrom.Handle, PFieldDescs));
    Check(DbiCreateInMemTable(Database.Handle, szTableName, Props.iFields, PFieldDescs, Result));
  finally
    if Assigned(PFieldDescs) then
      FreeMem(PFieldDescs, Props.iFields * sizeof(FLDDesc));
  end;
end;

procedure TInMemTable.CheckIsBorrowFromActive;
begin
  if not FBorrowFrom.Active then
    DatabaseError(format('TTable %s is not open', [FBorrowFrom.Name]));
end;

procedure Register;
begin
  RegisterComponents('JOC', [TInMemTable]);
end;

end.
