library DavesApp;

uses
    Ole2, Windows, ContextM;

const
    { >>> This ID must match what we put into the registry <<< }
    OurCLSID: TGUID = (D1:$C0A3EA22; D2:$1C7A; D3:$11d0;
                       D4:($BF, $05, $44, $45, $53, $54, $00, $00));

{ Exported function - Create the class factory }

function DllGetClassObject (const clsid: TCLSID; const iid: TGUID; var ppv): HResult; stdcall export;
var
    ShellClassFactory: IShellClassFactory;
begin
    Pointer (ppv) := Nil;
    Result := Class_E_ClassNotAvailable;

    { Validate the passed CLSID }
    if IsEqualIID (clsid, OurCLSID) then
    begin
        { Validate the interface ID }
        Result := E_NoInterface;
        if (IsEqualIID (iid, IID_IUnknown)) or (IsEqualIID (iid, IID_IClassFactory)) then
        try
            // Instantiate the class factory
            ShellClassFactory := IShellClassFactory.Create;
            Result := ShellClassFactory.QueryInterface (iid, ppv);
            if Result < 0 then ShellClassFactory.Free;
        except
            Result := e_OutOfMemory;
            Pointer (ppv) := Nil;
        end;
    end;
end;

{ Exported function - See if DLL can be unloaded }

function DllCanUnloadNow: HResult;
begin
    if (LockCount = 0) and (ObjCount = 0) then Result := 0
    else Result:= 1;
end;

exports
    DllGetClassObject, DllCanUnloadNow;

begin
end.
