unit sdd; {string device driver to convert numbers and parse strings}
{$H-}
interface

uses SysUtils;

procedure AssignSt(var t:textFile;var s:string;dlm:char);

implementation

type
  PString=^string;
  usr=record
    ps : PString;
    dlim : char;
    ud : array[6..32] of byte;
  end;

function InStr(var t:textFile):integer; far;
var
  p : pointer;
  e : cardinal;
  dlm : char;
begin
  InStr := 0; {for ioResult}
  with TTextRec(t),usr(UserData) do
  begin
    if (BufPos<BufEnd) and (Handle<>0) then exit;
    BufPos := 0;
    BufEnd := length(ps^)-Handle;
    if BufEnd>BufSize then BufEnd := BufSize;
    move(ps^[succ(Handle)],BufPtr^,BufEnd);
    inc(Handle,BufEnd);
    p := BufPtr;
    e := BufEnd;
    dlm := dlim;
    asm
      push edi       {save Delphi's string pointer}
      mov edi,p      {point to buffer}
      mov al,dlm
      mov ah,13
      mov ecx,e      {keep track of how much buffer left to search}
      cld            {go forward}
      @@1:
      repnz scasb    {search for the delimeter in al}
      jnz @@2        {if not found this time must be at end}
      mov [edi-1],ah {found, so make the substitution }
      jcxz @@2       {if counter 0 then done}
      jmp @@1        {if not at end, look for another}
      @@2:
      pop edi        {restore Delphi's string pointer}
    end;
  end;
end; {InStr}

function OutStr(var t:textFile):integer; far;
var
  i : integer;
begin
  with TTextRec(t),usr(UserData) do
  begin
    for i := BufEnd to BufPos-1 do ps^ := ps^+PTextBuf(BufPtr)^[i];
    Handle := length(ps^);
    BufEnd := BufPos;
  end; {with}
  OutStr := 0; {for ioResult}
end; {OutStr}

function FlushStr(var t:textFile):integer; far;
begin
  FlushStr := 0; {for ioResult}
end; {FlushStr}

function CloseStr(var t:textFile):integer; far;
begin
  with TTextRec(t) do
  begin
    Mode := fmClosed;
    Handle := 0;
    BufEnd := 0;
  end;
  CloseStr := 0; {for ioResult}
end; {CloseStr}

function OpenStr(var t:textFile):integer; far;
begin
  with TTextRec(t),usr(UserData) do
  begin
    CloseFunc := @CloseStr;
    case Mode of
      fmInOut : begin
        Mode := fmOutput;
        InOutFunc := @OutStr;
        FlushFunc := @OutStr;
        Handle := length(ps^);
      end;
      fmInput : begin
        InOutFunc := @InStr;
        FlushFunc := @FlushStr;
      end;
      fmOutput : begin
        InOutFunc := @OutStr;
        FlushFunc := @OutStr;
        ps^ := '';
      end;
    end; {case}
  end; {with}
  OpenStr := 0; {for ioResult}
end; {OpenStr}

procedure AssignSt(var t:textFile;var s:string;dlm:char);
begin
  with TTextRec(t),usr(UserData) do
  begin
    Mode := fmClosed;
    BufSize := SizeOf(buffer);
    BufPtr := @buffer;
    OpenFunc := @OpenStr;
    BufPos := 0;
    BufEnd := 0;
    Name[0]:=#0;
    dlim := dlm;
    ps := @s;
    Handle := 0;
  end; {with}
end; {AssignStr}

end.
