library Dll16Bit;

uses
  Dialogs,
  SysUtils,
  WinProcs,
  WinTypes;

procedure NoParameters; export;
begin
  ShowMessage('Hello world from a 16-bit DLL');
end;

procedure Proc2ParamsPascal(X, Y: Longint); export;
begin
  ShowMessage(Format('%d + %d = %d', [X, Y, X + Y]));
end;

procedure Proc2ParamsC(X, Y: Longint); cdecl; export;
begin
  Proc2ParamsPascal(X, Y);
end;

procedure ProcPointerParam(Msg: PChar); export;
begin
  ShowMessage(Format('Msg received from 32-bit: %s', [Msg]));
end;

procedure ProcVarConstParams(var Num: Smallint; const Str: String); export;
begin
  Inc(Num, 10);
  ShowMessage(Str);
end;

procedure ProcOpenArrayParam(const Numbers: array of Smallint); export;
var
  Loop: Integer;
  Sum: Longint;
begin
  Sum := 0;
  for Loop := Low(Numbers) to High(Numbers) do
    Inc(Sum, Numbers[Loop]);
  ShowMessage(Format('Sum of passed values = %d', [Sum]));
end;

function Func2ParamsPascal(X, Y: Longint): Longint; export;
begin
  ShowMessage(Format('1st: %d 2nd: %d', [X, Y]));
  Result := X + Y;
end;

function Func2ParamsC(X, Y: Longint): Longint; cdecl; export;
begin
  Result := Func2ParamsPascal(X, Y);
end;

const
  Buffer: PChar = 'Hello world, returned from 16-bit';

function FuncPointerParam(Msg: PChar): PChar; export;
begin
  ShowMessage(Format('Msg received from 32-bit: %s', [Msg]));
  Result := Buffer;
end;

exports
  NoParameters,
  Proc2ParamsPascal,
  Proc2ParamsC,
  ProcPointerParam,
  ProcVarConstParams,
  ProcOpenArrayParam,
  Func2ParamsPascal,
  Func2ParamsC,
  FuncPointerParam;

begin
end.
