unit HintDemU;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls;

type
  TMainForm = class(TForm)
    SpeedBar: TPanel;
    SpeedButton1: TSpeedButton;  { &New }
    SpeedButton2: TSpeedButton;  { &Open... }
    SpeedButton3: TSpeedButton;  { &Save }
    SpeedButton4: TSpeedButton;  { &Print... }
    SpeedButton5: TSpeedButton;
    StatusLine: TPanel;
    MainMenu: TMainMenu;
    FileMenu: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    N1: TMenuItem;
    FilePrintItem: TMenuItem;
    FilePrintSetupItem: TMenuItem;
    N4: TMenuItem;
    FileExitItem: TMenuItem;
    Memo1: TMemo;
    Label1: TLabel;
    Button1: TButton;  { E&xit }
    procedure FormCreate(Sender: TObject);
    procedure DoHint(Sender: TObject);
    procedure DoShowHint(var HintStr: string;
      var CanShow: Boolean; var HintInfo: THintInfo);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.DoHint(Sender: TObject);
begin
  { Write hint on status bar }
  StatusLine.Caption := Application.Hint;
end;

procedure TMainForm.DoShowHint(var HintStr: string;
  var CanShow: Boolean; var HintInfo: THintInfo);
begin
  with HintInfo do
  begin
    { Move the hint horizontally }
    Inc(HintPos.X, 30);
    { Add more detail into the hint string }
    if HintControl.Name <> '' then
      HintStr := HintControl.Name + ': ' +
                 HintControl.ClassName + ' - ' +
                 HintStr;
    { Randomly change hint colour }
    HintColor := RGB(127+Random(128), 127+Random(128), 127+Random(128));
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := DoHint;
  Application.OnShowHint := DoShowHint;
  Randomize;
end;

end.
