unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TSaverForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    ptMpos: TPoint;
    procedure Trigger(Sender: TObject; var Done: Boolean);
    procedure SafeExit;
  public
    { Public declarations }
  end;

var
  SaverForm: TSaverForm;
  ScreenWd: Integer;
  ScreenHt: Integer;

implementation

{$R *.DFM}

procedure CursorOff;
var
  Cstate : Integer;
begin
  Cstate := ShowCursor(True);
  while Cstate >= 0 do Cstate := ShowCursor(False);
end;

procedure CursorOn;
var
  Cstate : Integer;
begin
  Cstate := ShowCursor(True);
  while Cstate < 0 do Cstate := ShowCursor(True);
end;

{ TSaverForm code }

procedure TSaverForm.FormCreate(Sender: TObject);
begin
  Top := 0; Left := 0;
  Width := Screen.Width;
  Height := Screen.Height;
  BorderStyle := bsNone;
end;

procedure TSaverForm.FormActivate(Sender: TObject);
begin
  CursorOff;
  ptMpos.X := -1;
  ptMpos.Y := -1;
  Application.OnIdle := Trigger; { Set the OnIdle Proc }
  {set this form as the capture control}
  SetCaptureControl(Self);
end;

procedure TSaverForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Application.OnIdle := nil;
  CursorOn;
end;

procedure TSaverForm.Trigger(Sender: TObject; var Done: Boolean);
begin
  PostMessage(Handle, WM_USER + 1,0,0);
end;

procedure TSaverForm.SafeExit;
begin
  {switch off the capture to the form}
  SetCaptureControl(NIL);
  Close;
end;

procedure TSaverForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SafeExit;
end;

procedure TSaverForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SafeExit;
end;

procedure TSaverForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if (ptMpos.X = -1) and (ptMpos.Y = -1) then
  begin
    ptMpos.X := X;
    ptMpos.Y := Y;
  end else
  if (Abs(X - ptMpos.X) > 2) and (Abs(Y - ptmPos.Y) > 2) then
    SafeExit;
end;

end.