unit Makewave;

interface

function CreateNewWave(NewFileName: String): Boolean;

implementation

uses MMSystem, SysUtils, Windows;

function CreateNewWave(NewFileName: String): Boolean;
var
  DeviceID: Word;
  MciOpen: TMCI_OPEN_PARMS;
  MciRecord: TMCI_RECORD_PARMS;
  MciSave: TMCI_SAVEPARMS;

  MCIResult: LongInt;
  Flags: Word;
  TempFileName: array[0..MAX_PATH] of Char;
begin
     Result := True; {If anything fails along the way, it will turn False}

     StrPCopy(TempFileName, NewFileName);

     {Open the Device}
     MciOpen.lpstrDeviceType := 'waveaudio';
     MciOpen.lpstrElementName := '';
     Flags := MCI_OPEN_ELEMENT or MCI_OPEN_TYPE;
     MCIResult := MciSendCommand(0, MCI_OPEN, Flags, LongInt(@MciOpen));
     Result := Result and (MCIResult = 0);
     DeviceID := MciOpen.wDeviceId;

     {Record only one byte of data}
     MciRecord.dwTo := 1;
     Flags := MCI_TO or MCI_WAIT;
     MCIResult := MciSendCommand(DeviceID, MCI_RECORD, Flags, LongInt(@MciRecord));
     Result := Result and (MCIResult = 0);

     {Save the file}
     mciSave.lpfileName := TempFilename;
     Flags := MCI_SAVE_FILE or MCI_WAIT;
     MCIResult := MciSendCommand(DeviceID, MCI_SAVE, Flags, LongInt(@MciSave));
     Result := Result and (MCIResult = 0);

     {Return True if device can be successfully closed}
     MCIResult := MciSendCommand(DeviceID, MCI_CLOSE, 0, LongInt(nil));
     Result := Result and (MCIResult = 0);
 end;

end.
 