unit AidData;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, DB;

type
  TAIDDataModule = class(TDataModule)
    ArticleQuery: TQuery;
    ArticleQueryArticleID: TIntegerField;
    ArticleQueryArticleType: TStringField;
    ArticleQueryTitle: TStringField;
    ArticleQueryAuthor1: TIntegerField;
    ArticleQueryAuthor2: TIntegerField;
    ArticleQueryAuthor3: TIntegerField;
    ArticleQueryIssue: TIntegerField;
    ArticleQueryPageNumber: TIntegerField;
    ArticleQuerySummary: TMemoField;
    ArticleQueryMonthYear: TStringField;
    AuthorQuery: TQuery;
    KeywordQuery: TQuery;
    KeywordQueryKeyword: TStringField;
    procedure AidDataModuleCreate(Sender: TObject);
    procedure ArticleQueryCalcFields(DataSet: TDataSet);
  private
  public
  end;

var
  AIDDataModule: TAIDDataModule;

implementation

{$R *.DFM}

uses
  CGIAPI, TDMComm;

procedure TAIDDataModule.ArticleQueryCalcFields(DataSet: TDataSet);
begin
  ArticleQueryMonthYear.AsString :=
    TDMComm.IssueNumToMonthYear(ArticleQueryIssue.AsInteger);
end;

procedure TAIDDataModule.AidDataModuleCreate(Sender: TObject);
var
  DataPath: string;
begin
  DataPath := ExtractFilePath(ParamStr(0)) + DataDirectory;
  ArticleQuery.DatabaseName := DataPath;
  AuthorQuery.DatabaseName := DataPath;
  KeywordQuery.DatabaseName := DataPath;
end;

initialization
  AIDDataModule := TAidDataModule.Create(Application);
finalization
  AIDDataModule.Free;
end.
