unit Smshwu16;

interface

uses
  WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShareM16, ExtCtrls, StdCtrls;

type
  TDisplayForm = class(TForm)
    ListBox1: TListBox;
    BtnClose: TButton;
    Panel1: TPanel;
    BtnReset: TButton;
    PnlCount: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnCloseClick(Sender: TObject);
    procedure BtnResetClick(Sender: TObject);
  private
    { Private declarations }
    FSharedMemory: TSharedMemory;
    FLastCount: Integer;
    procedure DataHasChanged(Sender: TObject);
  public
    { Public declarations }
  end;

var
  DisplayForm: TDisplayForm;

implementation

{$I SMCOMMON.INC}
{$R *.DFM}

procedure TDisplayForm.FormCreate(Sender: TObject);
begin
  FSharedMemory := TSharedMemory.Create('TestSharedMemory',sizeof(TArray_Element),Demo_Array_Capacity);
  FSharedMemory.OnChange := DataHasChanged;
end;

procedure TDisplayForm.FormDestroy(Sender: TObject);
begin
  FSharedMemory.Free;
end;

procedure TDisplayForm.DataHasChanged(Sender: TObject);
var
  WStr: string;
  I: longInt;
  Array_Element: TArray_Element;

begin
  { While we have ReadAccess do not call Application.Processmessages }
  { as this may allow the BtnResetClick event to execute which will  }
  { attempt to get update access which is incompatable with read.    }
  FSharedMemory.GetReadAccess;
  try
    ListBox1.Items.BeginUpdate;
    ListBox1.Items.Clear;
    for I := 0 to FSharedMemory.Count - 1 do
      begin
        FSharedMemory.Get(I,@Array_Element);
        With Array_Element do
          ListBox1.Items.Add(Format('Proc:%d Thread:%d Text: %s',[ProcessId,ThreadID,Text]));
      end;
    ListBox1.TopIndex := ListBox1.Items.Count -1;
    if FSharedMemory.Count <> FSharedMemory.Capacity then
      PnlCount.Caption := Format(' There are currently %d Items in the array',[FSharedMemory.Count])
    else
      PnlCount.Caption := Format(' The array is full!! The capacity is %d',[FSharedMemory.Capacity]);
    PnlCount.Refresh;
  finally
    ListBox1.Items.EndUpdate;
    FSharedMemory.ReleaseReadAccess;
  end;
  Application.ProcessMessages;
end;

procedure TDisplayForm.BtnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TDisplayForm.BtnResetClick(Sender: TObject);
begin
  FSharedMemory.Reset;
end;

end.
