unit Smtstu16;

interface

uses
  WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShareM16,
  StdCtrls, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    EdBaseText: TEdit;
    Panel3: TPanel;
    Label3: TLabel;
    SENumToAdd: TSpinEdit;
    Panel4: TPanel;
    SEWriteDelay: TSpinEdit;
    Label4: TLabel;
    Label6: TLabel;
    SEInterval: TSpinEdit;
    LBDataView: TListBox;
    BtnStart: TButton;
    LblProgress: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnStartClick(Sender: TObject);
  private
    { Private declarations }
    FSharedMemory: TSharedMemory;
    FProcessID: LongInt;
    FThreadID: LongInt;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  UpdText: string;

implementation

{$R *.DFM}

uses WinProcs, Thunk_32;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FSharedMemory := TSharedMemory.Create('TestSharedMemory',Sizeof(TArray_Element),Demo_Array_Capacity);
  FProcessID := GetCurrentProcessId(idGetCurrentProcessId);
  FThreadID := GetCurrentThreadId(idGetCurrentThreadId);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FSharedMemory.Free;
end;

procedure TForm1.BtnStartClick(Sender: TObject);
var
  I: Integer;
  PrevTicks: LongInt;
  Array_Element: TArray_Element;
  Suffix: string[2];
  Posn: LongInt;

begin
  BtnStart.Enabled := False;
  try
    for I := 1 to SENumToAdd.Value do
      begin
        PrevTicks := GetTickCount;
        FSharedMemory.GetUpdateAccess;
        LBDataView.Items.Add(Format('Waited %d ms to get update access',[GetTickCount - PrevTicks]));
        LBDataView.TopIndex := LBDataView.Items.Count - 1;
        LBDataView.Refresh;
        try
          With Array_Element do
            begin
              ProcessId := FProcessId;
              ThreadID := FThreadId;
              Text := EdBaseText.Text + Format(' [Entry %d]',[I]);
            end;
          Posn := FSharedMemory.Add(@Array_Element);
          case I mod 20 of
            1: Suffix := 'st';
            2: Suffix := 'nd';
            3: Suffix := 'rd';
          else
            Suffix := 'th';
          end;

          if Posn <> -1 then
            LBDataView.Items.Add(Format('Just added the %d%s item at position %d in the array',[I,Suffix,Posn]))
          else
            LBDataView.Items.Add(Format('Failed to add the %d%s item as the array is full!',[I,Suffix]));
          LBDataView.TopIndex := LBDataView.Items.Count - 1;
          LBDataView.Refresh;
          { Artificial write delay }
          PrevTicks := GetTickCount;
          Sleep(SEWriteDelay.Value,idSleep);
          LBDataView.Items.Add(Format('Kept write lock for %d ms',[GetTickCount - PrevTicks]));
          LBDataView.TopIndex := LBDataView.Items.Count - 1;
          LBDataView.Refresh;
        finally
          FSharedMemory.ReleaseUpdateAccess;
        end;
        { Simulate delay while we don't need access to resource }
        PrevTicks := GetTickCount;
        Sleep(SEInterval.Value,idSleep);
        LBDataView.Items.Add(Format('Did nothing for %d ms to simulate other processing',[GetTickCount - PrevTicks]));
        LBDataView.TopIndex := LBDataView.Items.Count -1;
        LBDataView.Refresh;
        If Application.Terminated then
          Break;
        LblProgress.Caption := Format('This process has added %d items so far',[I]);
        Application.ProcessMessages;
      end;
  finally
    BtnStart.Enabled := True;
    LblProgress.Caption := '';
  end;
end;

end.

