unit cursor;
{
  Author : Neil McClements
  Date   : 2nd Septmeber '96
  C/right: (c) 1996 N. McClements
  Purpose: An animated hourglass cursor implemented in a thread
}

interface

uses Classes, Forms,  WinProcs, Controls;


type TSpinningCursor=class(TThread)
  private
    procedure SpinCursor;
  protected
    procedure Execute; override;
  public
    constructor Create;
end;


implementation

{$R hourglss.res}

constructor TSpinningCursor.Create;
begin
  inherited Create(True);    // Create thread in a suspendend state
  screen.cursors[1] := LoadCursor(hInstance, pChar('CURSOR_1'));
  screen.cursors[2] := LoadCursor(hInstance, pChar('CURSOR_2'));
  screen.cursors[3] := LoadCursor(hInstance, pChar('CURSOR_3'));
  screen.cursors[4] := LoadCursor(hInstance, pChar('CURSOR_4'));
  screen.cursors[5] := LoadCursor(hInstance, pChar('CURSOR_5'));
  screen.cursors[6] := LoadCursor(hInstance, pChar('CURSOR_6'));
  screen.cursors[7] := LoadCursor(hInstance, pChar('CURSOR_7'));
  screen.cursors[8] := LoadCursor(hInstance, pChar('CURSOR_8'));
  screen.cursors[9] := LoadCursor(hInstance, pChar('CURSOR_9'));
  screen.cursors[10]:= LoadCursor(hInstance, pChar('CURSOR_10'));
  Priority:=tpLowest;
  FreeOnTerminate := True;   // Have thread object free itself when terminated
  Resume;
end;

procedure TSpinningCursor.SpinCursor;
var
  frame:integer;
  img,wait:longint;
begin
  frame:=0;
  for img:=1 to 10 do
  begin
    inc(frame);
    if frame>10 then frame:=1;
    screen.cursor:=frame;
    for wait:= 1 to 1000000 do
    begin
      // idle loop...
    end;
    // allow other things to be done, particularly in other parts of the interface
    Application.ProcessMessages;
  end;
  screen.cursor:=crDefault;
end;

procedure TSpinningCursor.Execute;
begin
   repeat
     Synchronize(SpinCursor);
   until Terminated;
end;


end.
