unit BitMapEg;

interface

uses
  WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TImageHolder = class(TPanel)
  private
    FImage: TImage;
  protected
    function GetPicture: TPicture;
    procedure SetPicture(Value: TPicture);
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Picture: TPicture read GetPicture write SetPicture;
  end;

procedure Register;

implementation

constructor TImageHolder.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FImage := TImage.Create(Self);
  FImage.Parent := Self;
  FImage.AutoSize := True;
  SetBounds(Left, Top, FImage.Width, FImage.Height)
end;

function TImageHolder.GetPicture: TPicture;
begin
  Result := FImage.Picture
end;

procedure TImageHolder.SetPicture(Value: TPicture);
begin
  FImage.Picture := Value;
  SetBounds(Left, Top, FImage.Width, FImage.Height)
end;

procedure Register;
begin
  RegisterComponents('Samples', [TImageHolder]);
end;

end.
