unit coolform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, Coolbar, Tabs;

type
    TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Alignment: TMenuItem;
    Left1: TMenuItem;
    Top1: TMenuItem;
    Right1: TMenuItem;
    Bottom1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure AlignmentClick(Sender: TObject);
    procedure Left1Click(Sender: TObject);
    private
        { Private declarations }
        hWndCoolbar: hWnd;
        CoolBarPos: TCoolBarPosition;
        procedure CoolBarInit (Pos: TCoolBarPosition);
    protected
        procedure WMCommand (var Msg: TWMCommand); message wm_Command;
    public
        { Public declarations }
    end;

var
  Form1: TForm1;

implementation

const
    id_CoolBar = 1111;
    id_Combo   = 2222;
    id_Button  = 3333;

{$R *.DFM}

procedure TForm1.CoolBarInit (Pos: TCoolBarPosition);
begin
    CoolBarPos := Pos;
    hWndCoolbar := AddCoolBar (Handle, Pos, id_CoolBar, id_Combo, id_Button);
end;

procedure TForm1.FormCreate (Sender: TObject);
begin
    CoolBarInit (cbp_Top);
end;

procedure TForm1.FormResize (Sender: TObject);
begin
    AlignCoolBar (hWndCoolbar, CoolBarPos);
end;

procedure TForm1.AlignmentClick(Sender: TObject);
begin
    Left1.Checked   := CoolBarPos = cbp_Left;
    Top1.Checked    := CoolBarPos = cbp_Top;
    Right1.Checked  := CoolBarPos = cbp_Right;
    Bottom1.Checked := CoolBarPos = cbp_Bottom;
end;

procedure TForm1.Left1Click (Sender: TObject);
begin
    with Sender as TMenuItem do
        if Ord (CoolBarPos) <> Tag then
        begin
            DestroyWindow (hWndCoolbar);
            CoolBarInit (TCoolBarPosition (Tag));
            FormResize (Self);
        end;
end;

procedure TForm1.WMCommand (var Msg: TWMCommand);
var
    Str: String;
begin
    Str := '';
    case Msg.ItemID of
        id_Button:  Str := 'You clicked the button';
        id_Combo:   if Msg.NotifyCode = cbn_SelChange then Str := 'You changed the combo selection';
    end;

    if Str <> '' then MessageDlg (Str , mtInformation, [mbOK], 0);
    Inherited;
end;

end.

