Function FileExistsOnPath(Const fName:String;Var aReturn:String):Boolean;
{ searches for the filename "FName" in the current directory
  or in the directories in the "PATH". 

  "FName"  should NOT contain any path information

  Returns the full path name to the file in "aReturn", if it is found.

  e.g.,

  Var
  s1, s2:String;
  begin
     s1 := 'PROGMAN.EXE'
     If FileExistsOnPath(s1, s2) then { do something with s2 ...}
     else MessageBox(0,'Program Manager not Found','Fatal Error', 0);
  end;
}

Begin
    {search current directory}
    If FileExists(fName) then begin
       aReturn := ExpandFileName(fName);
       Result := True;
       Exit;
    end;
    {else search path}
    aReturn := FileSearch(fName, GetEnvVar('PATH'));
    Result := aReturn > '';
End {FileExistsOnPath};
