unit TestCBF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    { Simply drop these components on the form and keep all default 
properties }
    Button1: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Button2: TButton;
    { Add click-event handlers for the buttons and a create handler for the 
form }
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  ComboFx;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
{ Try the buggy TComboBox properties. This shold select
  and copy '345' to the label. Instead the result is '012' }
begin
  ComboBox1.SelStart := 3;
  ComboBox1.SelLength := 3;
  Label1.Caption := ComboBox1.SelText;
end;

procedure TForm1.Button2Click(Sender: TObject);
{ Test the fixed combobox by doing a simple type-cast.
  This correctly results in '345' being selected and copied. }
begin
  TComboBoxFix(ComboBox1).SelStart := 3;
  TComboBoxFix(ComboBox1).SelLength := 3;
  Label1.Caption := ComboBox1.SelText;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  { Set the combobox up with some known text }
  ComboBox1.Text := '0123456789';
end;

end.

