unit OCXU1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TMainForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

uses
  OCXU2;

{$R *.DFM}

procedure TMainForm.Button1Click(Sender: TObject);
begin
  with TOCXForm.Create(Application) do
    try
      ShowModal;
    finally
      Free
    end
end;

procedure TMainForm.Button2Click(Sender: TObject);
type
  TDllFunc = function: HResult; stdcall;
var
  DLL: THandle;
  RegFunc, UnregFunc: TDllFunc;
begin
  DLL := LoadLibrary('CFX32.OCX');
  if DLL = 0 then
    raise Exception.Create('OCX not found');
  @RegFunc := GetProcAddress(DLL, 'DllRegisterServer');
  @UnregFunc := GetProcAddress(DLL, 'DllUnregisterServer');
  try
    if @RegFunc = nil then
      raise Exception.Create('Registration routine not found');
    RegFunc;
    with TOCXForm.Create(Application) do
      try
        ShowModal;
      finally
        Free
      end;
    if @UnregFunc = nil then
      raise Exception.Create('Unregistration routine not found');
    UnregFunc;
  finally
    FreeLibrary(DLL)
  end;
  Close
end;

end.
