unit ExecWait;
interface
uses
  WinTypes, WinProcs, Forms, SysUtils;

  function WinExecAndWait(Path: PChar; Visibility: Word): DWORD;

  procedure Delay(MilliSecondsToWait: LongInt);

implementation

  procedure Delay(MilliSecondsToWait: LongInt);
  var StartTime: LongInt;
  begin
    StartTime := GetTickCount;
    while (GetTickCount >= StartTime) and
          (GetTickCount < (StartTime + MilliSecondsToWait)) do
      Application.ProcessMessages
  end {Delay};

  function WinExecAndWait(Path: PChar; Visibility: Word): DWORD;
  { returns -1 if the Exec failed, otherwise returns the process' exit
    code when the process terminates }
  var zCurDir: Array[0..255] of char;
      WorkDir: ShortString;
      StartupInfo: TStartupInfo;
      ProcessInfo: TProcessInformation;
  begin
    GetDir(0,WorkDir);
    StrPCopy(zCurDir,WorkDir);
    FillChar(StartupInfo,Sizeof(StartupInfo),#0);
    StartupInfo.cb := Sizeof(StartupInfo);
    StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
    StartupInfo.wShowWindow := Visibility;
    if not CreateProcess(nil,
      Path,                  { pointer to command line string }
      nil,                   { pointer to process security attributes }
      nil,                   { pointer to thread security attributes }
      false,                 { handle inheritance flag }
      CREATE_NEW_CONSOLE or  { creation flags }
      NORMAL_PRIORITY_CLASS,
      nil,                   { pointer to new environment block }
      nil,                   { pointer to current directory name }
      StartupInfo,           { pointer to STARTUPINFO }
      ProcessInfo) then      { pointer to PROCESS_INF }
    begin
      MessageBox(GetFocus, Path, 'Could not create process:',
                 MB_ICONSTOP + MB_OK);
      Result := -1
    end
    else
    begin
      WaitforSingleObject(ProcessInfo.hProcess,INFINITE);
      GetExitCodeProcess(ProcessInfo.hProcess,Result)
    end
  end {WinExecAndWait};
end.
