unit mainform;
interface
uses
  Windows, Messages, SysUtils, Classes, Controls, Dialogs,Graphics, Forms,
  Buttons, Spin, StdCtrls, ExtCtrls, OleCtrls, ISP, ComCtrls;

type
  TDebugCGI = class(TForm)
    StatusBar: TStatusBar;
    PageControl: TPageControl;
    WWW: TTabSheet;
    HTML: TTabSheet;
    CGI: TTabSheet;
    ToolBar: TPanel;
    ComboBox: TComboBox;
    HTML1: THTML;
    Source: TMemo;
    JumpBtn: TBitBtn;
    RemoteCGI: TEdit;
    LocalCGI: TEdit;
    RadioGroup: TRadioGroup;
    SpinEdit: TSpinEdit;
    SpeedButton: TSpeedButton;
    RemoteLabel: TLabel;
    LocalLabel: TLabel;
    DelayLabel: TLabel;
    IniFileName: TEdit;
    Timer: TTimer;
    About: TTabSheet;
    Image3: TImage;
    procedure JumpBtnClick(Sender: TObject);
    procedure HTML1DoRequestDoc(Sender: TObject; const URL: string;
      const Element, DocInput: Variant; var EnableDefault: Wordbool);
    procedure HTML1DoRequestSubmit(Sender: TObject; const URL: string;
      const Form, DocOutput: Variant; var EnableDefault: Wordbool);
    procedure HTML1EndRetrieval(Sender: TObject);
    procedure RadioGroupClick(Sender: TObject);
    procedure RemoteCGIChange(Sender: TObject);
    procedure LocalCGIChange(Sender: TObject);
    procedure SpeedButtonClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure HTML1Error(Sender: TObject; Number: Smallint;
      var Description: string; Scode: Integer; const Source,
      HelpFile: string; HelpContext: Integer; var CancelDisplay: Wordbool);
  end;

var
  DebugCGI: TDebugCGI;

implementation
uses
  ExecWait, TBDosEnv;
{$R *.DFM}

procedure TDebugCGI.TimerTimer(Sender: TObject);
begin
  Timer.Enabled := False;
  JumpBtnClick(Sender)
end;

procedure TDebugCGI.JumpBtnClick(Sender: TObject);
begin
  StatusBar.Panels[0].Text := '@';
  if ComboBox.Text <> '' then
    HTML1.RequestDoc(ComboBox.Text)
end;

procedure TDebugCGI.HTML1DoRequestDoc(Sender: TObject; const URL: string;
  const Element, DocInput: Variant; var EnableDefault: Wordbool);
begin
  StatusBar.Panels[0].Text := '@@';
  StatusBar.Panels[1].Text := 'Contacting ' +URL
end;

procedure TDebugCGI.HTML1Error(Sender: TObject; Number: Smallint;
  var Description: string; Scode: Integer; const Source, HelpFile: string;
  HelpContext: Integer; var CancelDisplay: Wordbool);
begin
  StatusBar.Panels[0].Text := 'BAD';
  StatusBar.Panels[1].Text := HTML1.URL;
  Self.Source.Lines.Clear;
end;

procedure TDebugCGI.HTML1EndRetrieval(Sender: TObject);
var Str: ShortString;
    i: Integer;
begin
  StatusBar.Panels[0].Text := 'OK';
  StatusBar.Panels[1].Text := HTML1.URL;
  Source.Lines.Clear;
  Source.Lines[0] := HTML1.SourceText;
  i := 0;
  Str := '';
  repeat
    Str := UpperCase(Source.Lines[i]);
    if Pos('ACTION=',Str) > 0 then
    begin
      Str := Copy(Source.Lines[i],Pos('ACTION=',Str)+8,255);
      Delete(Str,Pos('"',Str),255)
    end
    else Str := '';
    Inc(i)
  until (i >= Source.Lines.Count) or (Length(Str) > 0);
  RemoteCGI.Text := Str
end;

procedure TDebugCGI.SpeedButtonClick(Sender: TObject);
begin
  with TOpenDialog.Create(Self) do
  try
    FileName := '*.exe';
    Title := 'Local CGI Application';
    DefaultExt := 'exe';
    Filter := '*.exe|cgi applications';
    if Execute then LocalCGI.Text := FileName
  finally
    Free
  end
end;

procedure TDebugCGI.RemoteCGIChange(Sender: TObject);
var Str: ShortString;
    i: Integer;
begin
  Str := RemoteCGI.Text;
  i := Length(Str);
  while (i > 0) and (Str[i] <> '/') do Dec(i);
  if i > 0 then Delete(Str,1,i);
  LocalCGI.Text := Str { just the EXE-name }
end;

procedure TDebugCGI.LocalCGIChange(Sender: TObject);
begin
  IniFileName.Text := ChangeFileExt(LocalCGI.Text,'.INI')
end;

procedure TDebugCGI.RadioGroupClick(Sender: TObject);
begin
  IniFileName.Enabled := RadioGroup.ItemIndex > 0
end;

procedure TDebugCGI.HTML1DoRequestSubmit(Sender: TObject;
  const URL: string; const Form, DocOutput: Variant;
  var EnableDefault: Wordbool);
var f: System.Text;
    Str: String;
    i: Integer;
begin
  if RadioGroup.ItemIndex = 1 then { Win-CGI }
  begin
    System.Assign(f,IniFileName.Text);
    Rewrite(f);
    writeln(f,'[cgi]');
    writeln(f,'URL=',URL);
    writeln(f,'Content Length=',Length(Form.URLEncodedBody));
    writeln(f);
    writeln(f,'[System]');
    writeln(f,'Output File=output.htm');
    writeln(f);
    writeln(f,'[Form Literal]');
    Str := Form.URLEncodedBody;
    i := Pos('&',Str);
    while (i > 0) do
    begin
      writeln(f,Copy(Str,1,i-1));
      Delete(Str,1,i);
      i := Pos('&',Str)
    end;
    System.Close(f);
    Str := LocalCGI.Text + ' ' + IniFileName.Text
  end
  else { Standard CGI }
  begin
    System.Assign(f,'data');
    Rewrite(f);
    writeln(f,Form.URLEncodedBody);
    System.Close(f);
    System.Assign(f,'cgi.bat');
    Rewrite(f);
    writeln(f,'set REQUEST_METHOD=POST');
    writeln(f,'set CONTENT_LENGTH=',Length(Form.URLEncodedBody));
    writeln(f,LocalCGI.Text,' < data > output.htm');
    System.Close(f);
    Str := 'COMMAND.COM';
    with TBDosEnvironment.Create(Self) do
    try
      Str := GetDosEnvStr('COMSPEC');
    finally
      Free
    end;
    Str := Str+' /C '+ExtractFilePath(Application.ExeName)+'cgi.bat'
  end;
  WinExecAndWait(PChar(Str),SW_NORMAL);
  Application.ProcessMessages;
  ComboBox.Text := 'file:///output.htm';
  Timer.Interval := SpinEdit.Value;
  if Timer.Interval <= 1 then Timer.Interval := 2;
  Timer.Enabled := True
end;

end.
