unit SerDemoU;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, ExtCtrls,
  CommDev;

type
  TSerialDemo1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Options1: TMenuItem;
    BaudRate1: TMenuItem;
    N11: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    DataBits1: TMenuItem;
    N51: TMenuItem;
    N61: TMenuItem;
    N71: TMenuItem;
    N81: TMenuItem;
    Parity1: TMenuItem;
    None1: TMenuItem;
    Odd1: TMenuItem;
    Even1: TMenuItem;
    Mark1: TMenuItem;
    Space1: TMenuItem;
    Stopbits1: TMenuItem;
    N12: TMenuItem;
    N151: TMenuItem;
    N22: TMenuItem;
    Port1: TMenuItem;
    N13: TMenuItem;
    N23: TMenuItem;
    N32: TMenuItem;
    N41: TMenuItem;
    OpenDevice1: TMenuItem;
    Closedevice1: TMenuItem;
    N1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    N12001: TMenuItem;
    N24001: TMenuItem;
    N48001: TMenuItem;
    N96001: TMenuItem;
    N144001: TMenuItem;
    N192001: TMenuItem;
    N384001: TMenuItem;
    N560001: TMenuItem;
    N1280001: TMenuItem;
    N2560001: TMenuItem;
    GBTerminalResponse: TGroupBox;
    GBTerminalCommands: TGroupBox;
    Command: TEdit;
    PreviousCommands: TListBox;
    GBModemStatus: TGroupBox;
    Panel1: TPanel;
    FlowControl1: TMenuItem;
    None2: TMenuItem;
    Software1: TMenuItem;
    HardwareCTSRTS1: TMenuItem;
    Memo1: TMemo;
    Timer1: TTimer;
    ClearTerminalBuffer1: TMenuItem;
    CTSStatus: TImage;
    LblCTSStatus: TLabel;
    LEDOn: TImage;
    LEDOff: TImage;
    LEDDis: TImage;
    DSRStatus: TImage;
    RIStatus: TImage;
    CDStatus: TImage;
    Actions1: TMenuItem;
    Hangup1: TMenuItem;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Breaktransmission1: TMenuItem;
    Resumetransmission1: TMenuItem;
    TDStatus: TImage;
    RDStatus: TImage;
    Label1: TLabel;
    Label3: TLabel;
    N42: TMenuItem;
    N2: TMenuItem;
    ShowEvents1: TMenuItem;
    GBEvents: TGroupBox;
    EventList: TListBox;
    N3: TMenuItem;
    Dial1: TMenuItem;
    N4: TMenuItem;
    Cleareventbuffer1: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure PortlMenuClick(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure OpenDevice1Click(Sender: TObject);
    procedure Closedevice1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CommandKeyPress(Sender: TObject; var Key: Char);
    procedure CommandKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure PreviousCommandsClick(Sender: TObject);
    procedure ToggleMenuItem(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ClearTerminalBuffer1Click(Sender: TObject);
    procedure Hangup1Click(Sender: TObject);
    procedure Breaktransmission1Click(Sender: TObject);
    procedure Resumetransmission1Click(Sender: TObject);
    procedure ShowEvents1Click(Sender: TObject);
    procedure Dial1Click(Sender: TObject);
    procedure Actions1Click(Sender: TObject);
    procedure Cleareventbuffer1Click(Sender: TObject);
    procedure BaudRateMenuClick(Sender: TObject);
    procedure DataBitsMenuClick(Sender: TObject);
    procedure ParityMenuClick(Sender: TObject);
    procedure StopBitsMenuClick(Sender: TObject);
    procedure FlowControlMenuClick(Sender: TObject);
  private
    { Private declarations }
    FCommDevice: TCommdevice;
    FWrkBuffer: Pointer;
    procedure SetControlEnabledState;
    procedure OnDataHandler(Buffer: Pointer; Length: Integer);
    procedure OnParityErrHandler;
    procedure OnFrameErrHandler;
    procedure OnOverRunErrHandler;
    procedure OnBreakHandler;
    procedure OnCTSChangeHandler(LineStatus: Boolean);
    procedure OnDSRChangeHandler(LineStatus: Boolean);
    procedure OnCDChangeHandler(LineStatus: Boolean);
    procedure DisableLED(LEDImage: TImage);
    procedure SetBaudRateFromMenu;
    procedure SetDataBitsFromMenu;
    procedure SetFlowControlFromMenu;
    procedure SetLEDStatus(LEDImage: TImage; lineHigh: Boolean);
    procedure SetParityFromMenu;
    procedure SetStopBitsFromMenu;
  public
    { Public declarations }
  end;

var
  SerialDemo1: TSerialDemo1;

implementation

uses SERAbout, SERDialU;

{$R *.DFM}

const
  WrkBufferLen = 32767;
  HighTag = 1;
  LowTag = 2;
  DisabledTag = 3;

procedure UnCheckAllSubMenus(MenuItem: TMenuItem);
var
  I: Integer;

begin
  for I := 0 to MenuItem.Count - 1 do
    MenuItem.Items[I].Checked := False;
end;

function TagValueOfCheckedSubMenu(MenuItem: TMenuItem): Integer;
var
  I: Integer;

begin
  Result := 0;
  for I := 0 to MenuItem.Count - 1 do
    if MenuItem.Items[I].Checked then
      begin
        Result := MenuItem.Items[I].Tag;
        Break;
      end;
end;

procedure TSerialDemo1.About1Click(Sender: TObject);
begin
  With TSerialPortDemoAbout.Create(Application) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TSerialDemo1.PortlMenuClick(Sender: TObject);
begin
  if Sender is TMenuItem then
    With TMenuItem(Sender) do
      if not Checked then
        begin
          UnCheckAllSubMenus(Parent);
          Checked := True;
        end;
end;

procedure TSerialDemo1.File1Click(Sender: TObject);
var
  OpenStatus: Boolean;

begin
  OpenStatus := FCommDevice.DeviceOpen;
  OpenDevice1.Enabled := not OpenStatus;
  CloseDevice1.Enabled := OpenStatus;
end;

procedure TSerialDemo1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TSerialDemo1.OpenDevice1Click(Sender: TObject);
var
  Device: Integer;
  I: Integer;

begin
  { Find out which commport should be opended }

  For I := 0 to Port1.Count - 1 do
    if Port1.Items[I].Checked then
      Device := Port1.Items[I].Tag;

  FCommDevice.Open(Device);

  SetBaudRateFromMenu;
  SetDataBitsFromMenu;
  SetFlowControlFromMenu;
  SetParityFromMenu;
  SetStopBitsFromMenu;

  SetControlEnabledState;
  ActiveControl := Command;
end;

procedure TSerialDemo1.Closedevice1Click(Sender: TObject);
begin
  FCommDevice.Close;
  Memo1.Lines.Clear;
  EventList.Items.Clear;
  SetControlEnabledState;
end;

procedure TSerialDemo1.FormDestroy(Sender: TObject);
begin
  FCommDevice.Free;
  FreeMem(FWrkBuffer,WrkBufferLen+1);
end;

procedure TSerialDemo1.CommandKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    begin
      if (PreviousCommands.ItemIndex = -1) or (Command.Text <> PreviousCommands.Items[0]) then
        PreviousCommands.Items.Insert(0,Command.Text);
      FCommDevice.WriteLn(Command.Text);
      SetLEDStatus(TDStatus,True); { As it will probably be written before the timer triggers }
      Command.Text := '';
      PreviousCommands.ItemIndex := -1;
      Key := #0;
    end;
end;

procedure TSerialDemo1.CommandKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    38: { Key up }
      begin
        With PreviousCommands do
          if Items.Count > 0 then
            begin
              case ItemIndex of
                -1: ItemIndex := Items.Count -1;
                 0: ;
              else
                ItemIndex := ItemIndex - 1;
              end;
              Command.Text := Items[ItemIndex];
            end;
        Key := 0;
      end;

    40: { Key down }
      begin
        With PreviousCommands do
          if Items.Count > 0 then
            begin
              if ItemIndex = - 1 then
                ItemIndex := 0
              else
                if ItemIndex <> Items.Count - 1 then
                ItemIndex := ItemIndex + 1;
              Command.Text := Items[ItemIndex];
            end;
        Key := 0;
      end;
  end;
end;

procedure TSerialDemo1.SetControlEnabledState;
begin
  Command.Enabled := Assigned(FCommDevice);
end;

procedure TSerialDemo1.FormCreate(Sender: TObject);
begin
  FCommDevice := TCommDevice.Create;

  With FCommDevice do
    begin
      OnData := OnDataHandler;
      OnParityErr := OnParityErrHandler;
      OnFrameErr := OnFrameErrHandler;
      OnOverrunErr := OnOverRunErrHandler;
      OnBreak := OnBreakHandler;
      OnCTSChange := OnCTSChangeHandler;
      OnDSRChange := OnDSRChangeHandler;
      OnCDChange := OnCDChangeHandler;
    end;

  SetControlEnabledState;
  FWrkBuffer := MemAlloc(WrkBufferLen+1);
  Height := 480;
end;

procedure TSerialDemo1.PreviousCommandsClick(Sender: TObject);
begin
  Command.Text := PreviousCommands.Items[PreviousCommands.ItemIndex];
  if Assigned(FCommDevice) then
    begin
      FCommDevice.WriteLn(Command.Text);
      SetLEDStatus(TDStatus,True);
      Command.Text := '';
      PreviousCommands.ItemIndex := -1;
    end;
end;

procedure TSerialDemo1.ToggleMenuItem(Sender: TObject);
begin
  With Sender as TMenuItem do
    Checked := not Checked;
end;

procedure TSerialDemo1.Options1Click(Sender: TObject);
var
  OpenStatus: Boolean;

begin
  OpenStatus := FCommDevice.DeviceOpen;
  BaudRate1.Enabled := not OpenStatus;
  Port1.Enabled := not OpenStatus;
  FlowControl1.Enabled := not OpenStatus;
end;
{++++}
procedure TSerialDemo1.OnDataHandler(Buffer: Pointer; Length: Integer);
var
  I,L: Integer;

begin
  SetLEDStatus(RDStatus,True);
  Memo1.GetTextBuf(FWrkBuffer,WrkBufferLen);
  PChar(Buffer)[Length] := #0;
  for I := 0 to Length - 1 do
    if PChar(Buffer)[I] in [#11] then
      PChar(Buffer)[I] := #32;
  StrCat(FWrkBuffer,Buffer);
  Memo1.Lines.BeginUpdate;
  Memo1.SetTextBuf(FWrkBuffer);
  While Memo1.Lines.Count > 100 do
    Memo1.Lines.Delete(0);
  SendMessage(Memo1.Handle,EM_LINESCROLL,0,Memo1.Lines.Count - 20);
  Memo1.Lines.EndUpdate;
end;

procedure TSerialDemo1.OnParityErrHandler;
begin
  While EventList.Items.Count > 100 do
    EventList.Items.Delete(0);
  EventList.ItemIndex := EventList.Items.Add(' A parity error has occurred');
end;

procedure TSerialDemo1.OnFrameErrHandler;
begin
  While EventList.Items.Count > 100 do
    EventList.Items.Delete(0);
  EventList.ItemIndex := EventList.Items.Add(' A frame error has occurred');
end;

procedure TSerialDemo1.OnOverrunErrHandler;
begin
  While EventList.Items.Count > 100 do
    EventList.Items.Delete(0);
  EventList.ItemIndex := EventList.Items.Add(' An overrun has occurred');
end;

procedure TSerialDemo1.OnBreakHandler;
begin
  While EventList.Items.Count > 100 do
    EventList.Items.Delete(0);
  EventList.ItemIndex := EventList.Items.Add(' A break has occurred');
end;

procedure TSerialDemo1.OnCTSChangeHandler(LineStatus: Boolean);
begin
  if lineStatus then
    EventList.ItemIndex := EventList.Items.Add('CTS is now on')
  else
    EventList.ItemIndex := EventList.Items.Add('CTS is now off');
  SetLEDStatus(CTSStatus,lineStatus);
end;

procedure TSerialDemo1.OnDSRChangeHandler(LineStatus: Boolean);
begin
  if lineStatus then
    EventList.ItemIndex := EventList.Items.Add('DSR is now on')
  else
    EventList.ItemIndex := EventList.Items.Add('DSR is now off');
  SetLEDStatus(DSRStatus,lineStatus);
end;

procedure TSerialDemo1.OnCDChangeHandler(LineStatus: Boolean);
begin
  if lineStatus then
    EventList.ItemIndex := EventList.Items.Add('CD is now on')
  else
    EventList.ItemIndex := EventList.Items.Add('CD is now off');
  SetLEDStatus(CDStatus,lineStatus);
end;

procedure TSerialDemo1.DisableLED(LEDImage: TImage);
begin
  if LEDImage.Tag <> DisabledTag then
    begin
      LEDImage.Picture.Assign(LEDdis.Picture);
      LEDImage.Tag := DisabledTag;
    end;
end;

procedure TSerialDemo1.SetLEDStatus(LEDImage: TImage; LineHigh: Boolean);
begin
  if LineHigh then
    begin
      if LEDImage.Tag <> HighTag then
        begin
          LEDImage.Picture.Assign(LEDOn.Picture);
          LEDImage.Tag := HighTag;
        end
    end
  else
    begin
      if LEDImage.Tag <> LowTag then
        begin
          LEDImage.Picture.Assign(LEDOff.Picture);
          LEDImage.Tag := LowTag;
        end
    end;
end;

procedure TSerialDemo1.Timer1Timer(Sender: TObject);
begin
  if Assigned(FCommDevice) then
    With FCommDevice do
      if DeviceOpen then
        begin
          SetLEDStatus(CTSStatus,CTSHigh);
          SetLEDStatus(DSRStatus,DSRHigh);
          SetLEDStatus(RIStatus,RIHigh);
          SetLEDStatus(CDStatus,CDHigh);
          SetLEDStatus(TDStatus,FCommDevice.OutPutByteCount > 0);
          SetLEDStatus(RDStatus,FCommDevice.InputByteCount > 0);
        end
      else
        begin
          DisableLED(CTSStatus);
          DisableLED(DSRStatus);
          DisableLED(RIStatus);
          DisableLED(CDStatus);
          DisableLED(TDStatus);
          DisableLED(RDStatus);
        end;
end;

procedure TSerialDemo1.ClearTerminalBuffer1Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;

procedure TSerialDemo1.Hangup1Click(Sender: TObject);
begin
  FCommDevice.HangUp;
end;

procedure TSerialDemo1.Breaktransmission1Click(Sender: TObject);
begin
  FCommDevice.BreakTransmission;
end;

procedure TSerialDemo1.Resumetransmission1Click(Sender: TObject);
begin
  FCommDevice.ResumeTransmission;
end;

procedure TSerialDemo1.ShowEvents1Click(Sender: TObject);
begin
  ShowEvents1.Checked := not ShowEvents1.Checked;
  if ShowEvents1.Checked  then
    Height := 610
  else
    Height := 480;
  GBEvents.Visible := ShowEvents1.Checked;
end;

procedure TSerialDemo1.Dial1Click(Sender: TObject);
begin
  With TSerialPortDemoDial.Create(Application) do
    try
      ShowModal;
      if Modalresult =mrOK then
        FCommDevice.Dial(DialString);
    finally
      Free;
    end;
end;

procedure TSerialDemo1.Actions1Click(Sender: TObject);
var
  OpenStatus: Boolean;

begin
  OpenStatus := FCommDevice.DeviceOpen;
  Hangup1.Enabled := OpenStatus;
  Breaktransmission1.Enabled := OpenStatus;
  Resumetransmission1.Enabled := OpenStatus;
  Dial1.Enabled := OpenStatus;
end;

procedure TSerialDemo1.Cleareventbuffer1Click(Sender: TObject);
begin
  EventList.Items.Clear;
end;

procedure TSerialDemo1.SetBaudRateFromMenu;
begin
  case TagValueOfCheckedSubMenu(BaudRate1) of
    1: FCommDevice.BaudRate := CBR_110;
    2: FCommDevice.BaudRate := CBR_300;
    3: FCommDevice.BaudRate := CBR_600;
    4: FCommDevice.BaudRate := CBR_1200;
    5: FCommDevice.BaudRate := CBR_2400;
    6: FCommDevice.BaudRate := CBR_4800;
    7: FCommDevice.BaudRate := CBR_9600;
    8: FCommDevice.BaudRate := CBR_14400;
    9: FCommDevice.BaudRate := CBR_19200;
   10: FCommDevice.BaudRate := CBR_38400;
   11: FCommDevice.BaudRate := CBR_56000;
   12: FCommDevice.BaudRate := CBR_128000;
   13: FCommDevice.BaudRate := CBR_256000;
  end;
end;

procedure TSerialDemo1.BaudRateMenuClick(Sender: TObject);
begin
  if Sender is TMenuItem then
    With TMenuItem(Sender) do
      if not Checked then
        begin
          UnCheckAllSubMenus(Parent);
          Checked := True;
          SetBaudRateFromMenu;
        end;
end;

procedure TSerialDemo1.SetDataBitsfromMenu;
begin
  FCommDevice.DataBits := TagValueOfCheckedSubMenu(DataBits1);
end;

procedure TSerialDemo1.DataBitsMenuClick(Sender: TObject);
begin
  if Sender is TMenuItem then
    With TMenuItem(Sender) do
      if not Checked then
        begin
          UnCheckAllSubMenus(Parent);
          Checked := True;
          SetDataBitsFromMenu;
        end;
end;

procedure TSerialDemo1.SetParityFromMenu;
begin
  case TagValueOfCheckedSubMenu(Parity1) of
    1: FCommDevice.Parity := NOPARITY;
    2: FCommDevice.Parity := ODDPARITY;
    3: FCommDevice.Parity := EVENPARITY;
    4: FCommDevice.Parity := MARKPARITY;
    5: FCommDevice.Parity := SPACEPARITY;
  end;
end;

procedure TSerialDemo1.ParityMenuClick(Sender: TObject);
begin
  if Sender is TMenuItem then
    With TMenuItem(Sender) do
      if not Checked then
        begin
          UnCheckAllSubMenus(Parent);
          Checked := True;
          SetParityFromMenu;
        end;
end;

procedure TSerialDemo1.SetStopBitsFromMenu;
begin
  case TagValueOfCheckedSubMenu(StopBits1) of
    1: FCommDevice.StopBits := ONESTOPBIT;
    2: FCommDevice.StopBits := ONE5STOPBITS;
    3: FCommDevice.StopBits := TWOSTOPBITS;
  end;
end;

procedure TSerialDemo1.StopBitsMenuClick(Sender: TObject);
begin
  if Sender is TMenuItem then
    With TMenuItem(Sender) do
      if not Checked then
        begin
          UnCheckAllSubMenus(Parent);
          Checked := True;
          SetStopBitsFromMenu;
        end;
end;

procedure TSerialDemo1.SetFlowControlFromMenu;
begin
  { Note: DST/DTR is not used here although the class supports it }
  case TagValueOfCheckedSubMenu(FlowControl1) of
    1: FCommDevice.FlowControl := fcNone;
    2: FCommDevice.FlowControl := fcHardwareCTSRTS;
    3: FCommDevice.FlowControl := fcSoftware;
  end;
end;

procedure TSerialDemo1.FlowControlMenuClick(Sender: TObject);
begin
  if Sender is TMenuItem then
    With TMenuItem(Sender) do
      if not Checked then
        begin
          UnCheckAllSubMenus(Parent);
          Checked := True;
          SetFlowControlFromMenu;
        end;
end;

end.



