program Harmony;

uses
  SysUtils, Windows, Registry, Classes;

{$R *.RES}

type
  ESyntaxError = class(Exception);
  ERunError = class(Exception);

var
  Loop, Index: Integer;
  Items, ItemValues: TStrings;
  VersionFrom, VersionTo, DelphiToRun,
  ChangedEntry, OptionalParameter: String;
  CommandLine: array[0..255] of Char;

const
  Help = 'Help';
  WinHelp = 'Software\Microsoft\Windows';
  Syntax = #13#13'Syntax:'#13'   HARMONY <Delphi-path> '+
      '<version-from-string> <version-to-string>'#13 +
      'e.g.'#13'   HARMONY c:\Delphi2.0\delphi32.exe ' +
      'Delphi3.0 Delphi2.0';

begin
  if ParamCount < 3 then
    raise ESyntaxError.Create(Syntax);
  DelphiToRun := ParamStr(1);
  VersionFrom := UpperCase(ParamStr(2));
  VersionTo := ParamStr(3);
  OptionalParameter := ParamStr(4);
  Items := TStringList.Create;
  ItemValues := TStringList.Create;
  try
    with TRegIniFile.Create('') do
      try
        RootKey := HKey_Local_Machine;
        OpenKey(WinHelp, False);
        ReadSection(Help, Items);
        ReadSectionValues(Help, ItemValues);
        for Loop := 1 to Items.Count do
        begin
          ChangedEntry := ItemValues.Values[Items[Loop - 1]];
          Index := Pos(VersionFrom, UpperCase(ChangedEntry));
          if Index > 0 then
          begin
            Delete(ChangedEntry, Index, Length(VersionFrom));
            Insert(VersionTo, ChangedEntry, Index);
            WriteString(Help, Items[Loop - 1], ChangedEntry);
          end;
        end;
      finally
        Free;
      end;
  finally
    Items.Free;
    ItemValues.Free;
  end;
  StrPCopy(CommandLine, DelphiToRun + ' ' + OptionalParameter);
  if WinExec(CommandLine, sw_ShowNormal) < HInstance_Error then
    raise Exception.Create('Can''t load app');
end.
