unit LBoxTab2;

interface

uses
  StdCtrls, Controls, Classes;

type
  TTabScrollListbox = class(TListbox)
  private
    FTabStopSupport: Boolean;
    FScrollWidth: Word;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure SetScrollWidth(Val: Word);
    procedure SetTabStopSupport(Value: Boolean);
  public
    function SetTabStops(Tabs: array of Integer): Boolean;
  published
    property ScrollWidth: Word read FScrollWidth write SetScrollWidth;
    property TabStopSupport: Boolean
      read FTabStopSupport write SetTabStopSupport
      default False;
  end;

procedure Register;

implementation

uses
  WinTypes, Messages;

procedure TTabScrollListbox.CreateParams(var Params: TCreateParams);
const
  TabStopSupport: array[Boolean] of Longint = (0, lbs_UseTabStops);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or TabStopSupport[FTabStopSupport];
end;

procedure TTabScrollListbox.CreateWnd;
begin
  inherited CreateWnd;
  { After reconstructing window, reset scrollbar }
  Perform(lb_SetHorizontalExtent, FScrollWidth, 0);
end;

procedure TTabScrollListbox.SetScrollWidth(Val: Word);
begin
  if Val <> FScrollWidth then
  begin
    FScrollWidth := Val;
    Perform(lb_SetHorizontalExtent, FScrollWidth, 0);
  end;
end;

procedure TTabScrollListbox.SetTabStopSupport(Value: Boolean);
begin
  if Value <> FTabStopSupport then
  begin
    FTabStopSupport := Value;
    RecreateWnd;
  end;
end;

function TTabScrollListbox.SetTabStops(Tabs: array of Integer): Boolean;
begin
  Result := Perform(lb_SetTabStops, High(Tabs) - Low(Tabs) + 1,
    Longint(@Tabs)) <> 0;
  if Result then
    Repaint;
end;

procedure Register;
begin
  RegisterComponents('Clinic', [TTabScrollListbox]);
end;

end.
