unit Caretu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit2: TEdit;
    Edit1: TEdit;
    { Set up an OnExit handler as normal, but then }
    { use the Object Inspector to disassociate the handler }
    { from the event as it will be called indirectly }
    procedure Edit1Exit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Have a data field to store the old window procedure }
    FOldWndProc: TFarProc;
    { Declare a new surrogate window procedure }
    procedure NewWndProc(var Message: TMessage);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ Here's the routine that was the normal event handler }
{ Of course it's now an abnormal event handler }
procedure TForm1.Edit1Exit(Sender: TObject);
begin
  ShowMessage('Hello world!');
end;

{ Here's the surrogate window procedure }
procedure TForm1.NewWndProc(var Message: TMessage);
begin
  with Message do
  begin
    { Do message processing }
    Result := CallWindowProc(FOldWndProc, Handle, Msg, WParam, LParam);
    { _After_ processing call the event handler manually }
    if Msg = wm_KillFocus then
      Edit1Exit(Edit1);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  { Set up replacement window procedure }
  FOldWndProc := TFarProc(SetWindowLong(Edit1.Handle, gwl_WndProc,
    Longint(MakeObjectInstance(NewWndProc))));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  { Tidy up replacement window procedure }
  FreeObjectInstance(
    Pointer(SetWindowLong(Edit1.Handle, gwl_WndProc, LongInt(FOldWndProc))));
end;

end.
