unit PoorPU2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  { Type to signify the different routines }
  TProcName = (pnProc1, pnProc2, pnProc3);
  TParamProc = procedure(const S: String);

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ Here are the routines }

procedure One(const S: String); far;
begin
  ShowMessage(S + ' One');
end;

procedure Two(const S: String); far;
begin
  ShowMessage(S + ' Two');
end;

procedure Three(const S: String); far;
begin
  ShowMessage(S + ' Three');
end;

{ Here is the handler routine that calls stuff }
procedure DoIt(ProcToCall: TProcName; const S: String);
const
  { An array of the routines }
  Procs: array[TProcName] of TParamProc =
    (One, Two, Three);
begin
  { Call the appropriate routine }
  Procs[ProcToCall](S);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  DoIt(pnProc1, 'Button1');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  DoIt(pnProc2, 'Button2');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  DoIt(pnProc3, 'Button3');
end;

end.
