unit ShareMem;
{ (c) 1997 by Bob Swart (aka Dr.Bob - http://home.pi.net/~drbob/ }
interface

const
  Delphi: Boolean = True; { can be used outside the unit as well }

  SysGetMem: function(Size: Integer): Pointer = nil;
  SysFreeMem: function(P: Pointer): Integer = nil;
  SysReallocMem: function(P: Pointer; Size: Integer): Pointer = nil;
  GetHeapStatus: function: THeapStatus = nil;
  GetAllocMemCount: function: Integer = nil;
  GetAllocMemSize: function: Integer = nil;
  DumpBlocks: procedure = nil;

implementation
uses
  Windows;

const
  Handle: THandle = 0;
const
  SharedMemoryManager: TMemoryManager = (
    GetMem: nil;
    FreeMem: nil;
    ReallocMem: nil);

function GetCommandLine: PChar; stdcall;
  external 'kernel32.dll' name 'GetCommandLineA';
var
  P: PChar;
  i: Integer;
initialization
  P := GetCommandLine;
  i := 0;
  repeat
    Inc(i)
  until (P[i] = #0) or
       ((P[i] = 'B') and (P[i+1] = 'C') and (P[i+2] = 'B'));
  Delphi := P[i] = #0;
  if not Delphi then
  begin
    Handle := LoadLibrary('BCBMM.DLL');
  { if Handle = 0 then
      MessageBox(HWnd(0),'Error: could not load BCBMM.DLL',
                                 nil,MB_OK or MB_ICONHAND); }
    @DumpBlocks := GetProcAddress(Handle, 'DumpBlocks');
    @SysGetMem := GetProcAddress(Handle, '@System@SysGetMem$qqri');
    @SysFreeMem := GetProcAddress(Handle, '@System@SysFreeMem$qqrpv');
    @SysReallocMem := GetProcAddress(Handle, '@System@SysReallocMem$qqrpvi');
  end
  else { Delphi }
  begin
    Handle := LoadLibrary('DELPHIMM.DLL');
  { if Handle = 0 then
      MessageBox(HWnd(0),'Error: could not load DELPHIMM.DLL',
                                 nil,MB_OK or MB_ICONHAND); }
    @SysGetMem := GetProcAddress(Handle, 'SysGetMem');
    @SysFreeMem := GetProcAddress(Handle, 'SysFreeMem');
    @SysReallocMem := GetProcAddress(Handle, 'SysReallocMem');
  end;
  @GetHeapStatus := GetProcAddress(Handle, 'GetHeapStatus');
  @GetAllocMemCount := GetProcAddress(Handle, 'GetAllocMemCount');
  @GetAllocMemSize := GetProcAddress(Handle, 'GetAllocMemSize');

  SharedMemoryManager.GetMem := @SysGetMem;
  SharedMemoryManager.FreeMem := @SysFreeMem;
  SharedMemoryManager.ReallocMem := @SysReallocMem;
  SetMemoryManager(SharedMemoryManager);
finalization
  FreeLibrary(Handle)
end.
