unit BtnRptU;
{$X+}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBCtrls, ExtCtrls, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    BtnFirst: TButton;
    BtnPrior: TButton;
    BtnNext: TButton;
    BtnLast: TButton;
    DBImage1: TDBImage;
    Timer1: TTimer;
    procedure BtnFirstClick(Sender: TObject);
    procedure BtnPriorClick(Sender: TObject);
    procedure BtnNextClick(Sender: TObject);
    procedure BtnLastClick(Sender: TObject);
    procedure NavBtnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure NavBtnMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure NavBtnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TimerExpired(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  end;

const
  InitRepeatPause = 400;  { pause before repeat timer starts (ms) }
  RepeatPause     = 200;  { pause before successsive hits (ms)}

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BtnFirstClick(Sender: TObject);
begin
  Table1.First;
end;

procedure TForm1.BtnPriorClick(Sender: TObject);
begin
  Table1.Prior;
end;

procedure TForm1.BtnNextClick(Sender: TObject);
begin
  Table1.Next;
end;

procedure TForm1.BtnLastClick(Sender: TObject);
begin
  Table1.Last;
end;

procedure TForm1.NavBtnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Interval := InitRepeatPause;
  Timer1.Enabled := True;
end;

procedure TForm1.NavBtnMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  Pt: TPoint;
begin
  { Even if mouse goes off button, mouse move events }
  { will still go to the button because it was }
  { created with the csCaptureMouse control style }
  Pt.X := X;
  Pt.Y := Y;
  if Timer1.Enabled then
    with (Sender as TButton) do
      Timer1.Enabled :=
        PtInRect(Rect(0, 0, Width, Height), Pt)
end;

procedure TForm1.NavBtnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Enabled := False;
end;

procedure TForm1.TimerExpired(Sender: TObject);
var
  ActiveCtrl: TControl;
begin
  Timer1.Interval := RepeatPause;
  try
    ActiveCtrl := ActiveControl;
    (ActiveCtrl as TButton).Click;
    { If button has been disabled as a result of what }
    { happens in its OnClick method, shutdown timer }
    Timer1.Enabled := ActiveCtrl.Enabled;
  except
    Timer1.Enabled := False;
    raise;
  end;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  BtnFirst.Enabled := not Table1.BOF;
  BtnPrior.Enabled := not Table1.BOF;
  BtnNext.Enabled := not Table1.EOF;
  BtnLast.Enabled := not Table1.EOF;
end;

end.
