unit ODBtnU;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Odbutton, Buttons;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OwnerDrawButton1: TOwnerDrawButton;
    Edit1: TEdit;
    procedure OwnerDrawButton1DrawButton(Button: TOwnerDrawButton;
      Canvas: TCanvas; Rect: TRect; State: TOwnerDrawState;
      Default: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}



procedure TForm1.OwnerDrawButton1DrawButton(Button: TOwnerDrawButton;
  Canvas: TCanvas; Rect: TRect; State: TOwnerDrawState; Default: Boolean);
var
  R: TRect;

  procedure FocusRect;
  begin
    if odFocused in State then
    begin
      R := Rect;
      InflateRect(R, -4, -4);
      Canvas.DrawFocusRect(R);
    end;
  end;

  procedure DefaultRect;
  begin
    if Default then
    begin
      Canvas.Brush.Color := clWindowFrame;
      Canvas.FrameRect(Rect);
    end;
  end;

begin
  Tag := Tag + 1;
  Caption := Format('Redraws: %d', [Tag]);
  with Canvas do
  begin
    FillRect(Rect);
    R := Rect;
    if odSelected in State then
      OffsetRect(R, 1, 1);
    TextOut((R.Right - TextWidth(Button.Caption)) div 2,
            (R.Bottom - TextHeight(Button.Caption)) div 2,
            Button.Caption);
    if odSelected in State then
    begin
      { Draw dotted focus rect }
      FocusRect;
      { Draw outer black rect }
      DefaultRect;
      R := Rect;
      InflateRect(R, -1, -1);
      Brush.Color := clBtnShadow;
      { Draw inner gray rect }
      FrameRect(R);
      InflateRect(R, -1, -1);
      Brush.Color := clBtnFace;
      { Draw innermost light gray rect }
      FrameRect(R);
    end
    else
    begin
      R := Rect;
      if Default then
        { Can't do the frame rect here as for some }
        { reason it prevents the focus rect at the end }
        InflateRect(R, -1, -1);
      { Draw black lines on bottom and at right }
      Pen.Color := clWindowFrame;
      MoveTo(R.Right - 1, R.Top);
      LineTo(R.Right - 1, R.Bottom - 1);
      LineTo(R.Left - 1, R.Bottom - 1);
      { Draw light gray lines on top and at left }
      Pen.Color := clBtnFace;
      MoveTo(R.Left, R.Bottom - 2);
      LineTo(R.Left, R.Top);
      LineTo(R.Right - 2, R.Top);
      InflateRect(R, -1, -1);
      { Draw dark gray lines on bottom and at right }
      Pen.Color := clBtnShadow;
      MoveTo(R.Right - 1, R.Top);
      LineTo(R.Right - 1, R.Bottom - 1);
      LineTo(R.Left - 1, R.Bottom - 1);
      { Draw white lines on top and at left }
      Pen.Color := clBtnHighlight;
      MoveTo(R.Left, R.Bottom - 2);
      LineTo(R.Left, R.Top);
      LineTo(R.Right - 2, R.Top);
      { Do dotted focus rectange if need be }
      FocusRect;
      { Do outer black rectange if need be }
      DefaultRect;
    end;
  end;
end;

end.


