unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ResolutionLabel: TLabel;
    Button1: TButton;
    TimeALabel: TLabel;
    TimeBLabel: TLabel;
    Button2: TButton;
    DifferenceLabel: TLabel;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
 Profit,
 HiResTmr;


const
 f_TimeA : comp = 0.0;
 f_TimeB : comp = 0.0;

function  sfunc_TimerValue( AValue : comp ) : string;
begin
  Str( AValue : 6 : 1, Result );
end;

procedure ShowDifference;
begin
  Form1.DifferenceLabel.Caption :=
    'Difference B-A: ' + sfunc_TimerValue( f_TimeB - f_TimeA );
end;


procedure TForm1.FormCreate(Sender: TObject);
var
 S : string;
begin
  Str( 1e6 / r_CountsPerSec.QuadPart : 0 : 6, S );
  ResolutionLabel.Caption :=
    'Time values are in units of ' + S + ' us';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 R : TLargeInteger;
begin
QueryPerformanceCounter( R );
f_TimeA := R.QuadPart;
ShowDifference;
TimeALabel.Caption := 'Time A: ' + sfunc_TimerValue( R.QuadPart );
end;

procedure TForm1.Button2Click(Sender: TObject);
var
 R : TLargeInteger;
begin
QueryPerformanceCounter( R );
f_TimeB := R.QuadPart;
ShowDifference;
TimeBLabel.Caption := 'Time B: ' + sfunc_TimerValue( R.QuadPart );
end;

procedure TForm1.Button3Click(Sender: TObject);
var
 L : longint;
begin
 {$IFNDEF PrinterPortProfiler}
 ShowMessage( 'You need to set the conditional define ''PrinterPortProfiler'' for this to work.' );
 Exit;
 {$ENDIF}

 ShowMessage(
 'Program will freeze for 10s while it toggles printer port I/O lines at address ' + Format( '%x hex', [ioAdr1] ));
 Screen.Cursor := crHourglass;
 PPPRInitialise( ioAdr1 );

 For L := 1 to 100000 do
   begin
   PPPRSetAllBits;
   { Sets the port to all data bits = 1 }

   DelayUS( 100 );

   PPPRClearAllBits;
   { Sets the port to all data bits = 1 }

   end;
 Screen.Cursor := crDefault;
end;

end.
