function ValidateBMP(bmpToChk: string; showMsg: boolean): boolean;
{ returns False if invalid BMP or if file doesn't exist }
var
   bmp: TBitMap;
   function LoadBmp(bmp: TBitmap; nameOfFile: string): boolean;
   { returns False if problem loading bmp }
   begin
      Result := True;
      try
         bmp.LoadFromFile(nameOfFile);
      except
         on EInvalidGraphic do begin
            if showMsg then
               MessageDlg(Format('Bitmap: %s is an invalid image',
                 [nameOfFile]), mtError, [mbOk], 0);
            Result := False;
         end;
     end;
   end;
begin
   if bmpToChk = '' then
      Result := False
   else begin
      Result := FileExists(bmpToChk);
      if Result then begin
         bmp := TBitMap.Create;
         try
            Result := LoadBmp(bmp, bmpToChk);
         finally
            bmp.Free;
         end;
      end;
   end;
end;

