unit OverlayForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TMyForm = class(TForm)
    ImageList: TImageList;
    ImageType: TRadioGroup;
    procedure FormPaint(Sender: TObject);
    procedure ImageTypeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MyForm: TMyForm;

implementation

{$R *.DFM}

const
  OverlayNumber = 0;
  MainImage = 0;
  OverlayImage = 1;

procedure TMyForm.FormPaint(Sender: TObject);
const
  itMain = 0;
  itOverlay = 1;
  itCombined = 2;
begin
  case ImageType.ItemIndex of
    itMain: ImageList.Draw (Self.Canvas, 10, 10, MainImage);
    itOverlay: ImageList.Draw (Self.Canvas, 10, 10, OverlayImage);
    itCombined: ImageList.DrawOverlay (Self.Canvas, 10, 10, MainImage, OverlayNumber);
  end;
end;

procedure TMyForm.ImageTypeClick(Sender: TObject);
begin
  // Draw the requested image (actually done in OnPaint).
  Invalidate;
end;

procedure TMyForm.FormCreate(Sender: TObject);
begin
  // Register the overlay.
  ImageList.Overlay (OverlayImage, OverlayNumber);
end;

end.
