{*********************************************************}
{* AADefine.inc                                          *}
{* Copyright (c) Julian M Bucknall 1998-1999             *}
{* All rights reserved.                                  *}
{*********************************************************}
{* Algorithms Alfresco compiler define include file      *}
{*********************************************************}

{Note: this include file is released as freeware. In other words, you
       are free to use this include file in your own units, however I
       retain all copyright to the defines. JMB}


{The following compiler define tells the compiler whether to include
 debug information or not; certain units will also compile extra code
 to be used for debugging with this define set}
{$DEFINE DebugMode}



{===DO NOT CHANGE ANYTHING FROM THIS POINT===========================}

{---Calculate compiler defines based on compiler version-------------}
{$IFDEF VER80}
  {$DEFINE Delphi1}
  {$DEFINE Delphi1Plus}
{$ENDIF}
{$IFDEF VER90}
  {$DEFINE Delphi2}
  {$DEFINE Delphi1Plus}
  {$DEFINE Delphi2Plus}
{$ENDIF}
{$IFDEF VER100}
  {$DEFINE Delphi3}
  {$DEFINE Delphi1Plus}
  {$DEFINE Delphi2Plus}
  {$DEFINE Delphi3Plus}
{$ENDIF}
{$IFDEF VER120}
  {$DEFINE Delphi4}
  {$DEFINE Delphi1Plus}
  {$DEFINE Delphi2Plus}
  {$DEFINE Delphi3Plus}
  {$DEFINE Delphi4Plus}
{$ENDIF}
{$IFDEF VER130}
  {$DEFINE Delphi5}
  {$DEFINE Delphi1Plus}
  {$DEFINE Delphi2Plus}
  {$DEFINE Delphi3Plus}
  {$DEFINE Delphi4Plus}
  {$DEFINE Delphi5Plus}
{$ENDIF}


{--Compiler options we MUST have set, others are no-care-------------}
{$B-   Short-circuit boolean expressions }
{$I+   I/O checking via exceptions }
{$V-   Disable var string checking }
{$W-   No Windows realmode stack frame }
{$X+   Enable extended syntax }
{$IFDEF DebugMode}
  {$D+,L+  Enable debug information }
{$ENDIF}
{$IFDEF Delphi1}
  {$G+   80286+ type instructions }
{$ENDIF}
{$IFDEF Delphi2Plus}
  {$WARNINGS ON}
  {$HINTS ON}
{$ENDIF}


{---Miscellaneous----------------------------------------------------}
{$IFDEF Delphi1}
  {$C MOVEABLE DEMANDLOAD DISCARDABLE}
{$ENDIF}
