{*********************************************************}
{*		    MROUNIT2.PAS 1.11			 *}
{*     Copyright (c) Tamarack Associates 1995, 1996.	 *}
{*		   All rights reserved. 		 *}
{*********************************************************}


unit MROUnit2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBCtrls, StdCtrls, Mask, ExtCtrls, Grids, DBGrids,
  taDBMRO, DB, DBTables;

type
  TForm1 = class(TForm)
    taDBMRO1: TtaDBMRO;
    Panel1: TPanel;
    DBEdit1: TDBEdit;
    DBNavigator1: TDBNavigator;
    DBComboBox1: TDBComboBox;
    DataSource1: TDataSource;
    Table1: TTable;
    Table1Company: TStringField;
    Table1State: TStringField;
    procedure taDBMRO1DrawControl(Sender: TObject; Control: TControl;
      const CellRect: TRect);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.taDBMRO1DrawControl(Sender: TObject;
  Control: TControl; const CellRect: TRect);
var  S : string;
     Rect : TRect;
     DrawFont : TFont;
     Offset : Integer;
begin
 if Control is TDBComboBox then
  with TDBComboBox(Control) do
   begin
    if not Visible then exit;
    S := '';
    if DataSource <> nil then
     try
      S := DataSource.DataSet.FieldByName(DataField).DisplayText;
     except
      on EDatabaseError do
      else raise
     end;
    Rect     := CalcRect(Control,CellRect);
    DrawFont := taDBMRO1.FetchFont(Font);
    Offset   := taDBMRO1.GetFontOffset(DrawFont) - 1;
    taDBMRO1.DrawBorder(bsSingle,Ctl3D,Rect);
    InflateRect(Rect,-1,-1);
    taDBMRO1.DrawText(taLeftJustify,taDBMRO1.FetchColor(Color),Enabled,DrawFont,
		      Offset,Offset,Rect,S);
   end
 else taDBMRO1.DrawControl(Control,CellRect)
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 taDBMRO1.FormKeyDown(ActiveControl,Key,Shift)
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Application.OnIdle := taDBMRO1.ApplicationIdle
end;

end.
