{$A+,B-,D-,F-,G+,I-,K+,L-,N-,P-,Q-,R-,S+,T-,V-,W-,X+,Y-}
unit PrExClos;
interface
uses
  WinTypes, Dialogs, ExptIntf;

Type
  TProjectExCloseExpert = class(TIExpert)
  public
    { Expert Style }
    function GetStyle: TExpertStyle; override;

    { Expert Strings }
    function GetName: string; override;
    function GetComment: string; override;
    function GetGlyph: HBITMAP; override;
    function GetState: TExpertState; override;
    function GetIDString: string; override;
    function GetMenuText: string; override;

    { Launch the Expert }
    procedure Execute; override;
  end;

  procedure Register;

implementation
uses SysUtils;

  function TProjectExCloseExpert.GetStyle: TExpertStyle;
  begin
    Result := esStandard
  end {GetStyle};

  function TProjectExCloseExpert.GetName: String;
  begin
    Result := 'Project ExClose Expert'
  end {GetName};

  function TProjectExCloseExpert.GetComment: String;
  begin
    Result := '' { not needed for esStandard }
  end {GetComment};

  function TProjectExCloseExpert.GetGlyph: HBITMAP;
  begin
    Result := 0 { not needed for esStandard }
  end {GetGlyph};

  function TProjectExCloseExpert.GetState: TExpertState;
  begin
    if Assigned(ToolServices) and
      (ToolServices.GetProjectName <> '') then Result := [esEnabled]
                                          else Result := []
  end {GetState};

  function TProjectExCloseExpert.GetIDString: String;
  begin
    Result := 'DrBob.ProjectExCloseExpert'
  end {GetIDString};

  function TProjectExCloseExpert.GetMenuText: String;
  begin
    if Assigned(ToolServices) and
      (ToolServices.GetProjectName <> '') then
      Result := '&Close Unit/Forms ' +
                  ExtractFileName(ToolServices.GetProjectName)
    else
      Result := 'No Project'
  end {GetMenuText};

  procedure TProjectExCloseExpert.Execute;
  { Execute: do your 'expert' stuff here... }
  var i: Integer;
  begin
    if Assigned(ToolServices) then with ToolServices do
    begin
      SaveProject;
      for i:=1 to GetUnitCount do CloseFile(GetUnitName(i))
    end
  end {Execute};


  procedure Register;
  begin
    RegisterLibraryExpert(TProjectExCloseExpert.Create)
  end {Register};
end.
