{$A+,B-,D-,F-,G+,I-,K+,L-,N-,P-,Q-,R-,S+,T-,V-,W-,X+,Y-}
unit PrExpand;
interface
uses
  WinTypes, Dialogs, ExptIntf;

Type
  TProjectExpandExpert = class(TIExpert)
  public
    { Expert Style }
    function GetStyle: TExpertStyle; override;

    { Expert Strings }
    function GetName: string; override;
    function GetComment: string; override;
    function GetGlyph: HBITMAP; override;
    function GetState: TExpertState; override;
    function GetIDString: string; override;
    function GetMenuText: string; override;

    { Launch the Expert }
    procedure Execute; override;
  end;

  procedure Register;

implementation
uses SysUtils;

  function TProjectExpandExpert.GetStyle: TExpertStyle;
  begin
    Result := esStandard
  end {GetStyle};

  function TProjectExpandExpert.GetName: String;
  begin
    Result := 'Project Expand Expert'
  end {GetName};

  function TProjectExpandExpert.GetComment: String;
  begin
    Result := '' { not needed for esStandard }
  end {GetComment};

  function TProjectExpandExpert.GetGlyph: HBITMAP;
  begin
    Result := 0 { not needed for esStandard }
  end {GetGlyph};

  function TProjectExpandExpert.GetState: TExpertState;
  begin
    if Assigned(ToolServices) and
      (ToolServices.GetProjectName <> '') then Result := [esEnabled]
                                          else Result := []
  end {GetState};

  function TProjectExpandExpert.GetIDString: String;
  begin
    Result := 'DrBob.ProjectExpandExpert'
  end {GetIDString};

  function TProjectExpandExpert.GetMenuText: String;
  begin
    if Assigned(ToolServices) and
      (ToolServices.GetProjectName <> '') then
      Result := '&Fully Expand ' +
                  ExtractFileName(ToolServices.GetProjectName)
    else
      Result := 'No Project'
  end {GetMenuText};

  procedure TProjectExpandExpert.Execute;
  { Execute: do your 'expert' stuff here... }
  var i: Integer;
  begin
    if Assigned(ToolServices) then with ToolServices do
    begin
      SaveProject;
      for i:=0 to GetUnitCount do OpenFile(GetUnitName(i))
    end
  end {Execute};


  procedure Register;
  begin
    RegisterLibraryExpert(TProjectExpandExpert.Create)
  end {Register};
end.
