{$B-,G+,X+}    {* Boolean evaluation, Generate 286 code, eXtended syntax *}
{$I TARUBICN.INC}
{*********************************************************}
{*		      RBLINK.PAS 1.00			 *}
{*	  Copyright (c) Tamarack Associates 1996.	 *}
{*		   All rights reserved. 		 *}
{*********************************************************}

unit rbLink;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, DB, DBTables, taRubicn, taLink,
  {$IFDEF HaveSysTools}
  StUtils;
  {$ELSE}
  taTools;
  {$ENDIF}

type
  TLinkForm = class(TForm)
    DataFieldComboBox: TComboBox;
    DataFieldLabel: TLabel;
    LinkTableComboBox: TComboBox;
    LinkTableLabel: TLabel;
    LinkFieldComboBox: TComboBox;
    LinkFieldLabel: TLabel;
    LinkDisplayComboBox: TComboBox;
    LinkDisplayLabel: TLabel;
    OkBitBtn: TBitBtn;
    CancelBitBtn: TBitBtn;
    HelpBitBtn: TBitBtn;
    LinkTable: TTable;
    DeleteBtn: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure LinkTableComboBoxChange(Sender: TObject);
    procedure OkBitBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    EditLink : TLinkData;
  end;

var
  LinkForm: TLinkForm;

implementation

{$R *.DFM}

procedure TLinkForm.FormShow(Sender: TObject);
begin
 DeleteBtn.Visible := EditLink <> NIL;
 WITH DataFieldComboBox DO
  IF EditLink <> NIL THEN ItemIndex := Items.IndexOf(EditLink.DataField)
  ELSE ItemIndex := 0;
 WITH LinkTableComboBox DO
  IF EditLink <> NIL THEN Text := EditLink.LinkTableName
  ELSE IF Items.Count > 0 THEN Text := Items[0];
 LinkTableComboBoxChange(NIL);
 IF EditLink <> NIL THEN
  BEGIN
   WITH LinkFieldComboBox DO ItemIndex := Items.IndexOf(EditLink.LinkFieldNames);
   LinkDisplayComboBox.Text := EditLink.LinkDisplay
  END
end;

procedure TLinkForm.LinkTableComboBoxChange(Sender: TObject);
VAR       i : INTEGER;
begin
 WITH LinkTable DO
  BEGIN
   TableName := LinkTableComboBox.Text;
   GetFieldNames(LinkFieldComboBox.Items);
   GetFieldNames(LinkDisplayComboBox.Items)
  END;
 {* Check if any of the Link FieldNames are the same as the DataField *}
 {* Unfortunately, IndexOf is case sensitive			      *}
 WITH DataFieldComboBox DO
  i := LinkFieldComboBox.Items.IndexOf(Items[ItemIndex]);
 WITH LinkFieldComboBox DO
  IF i = -1 THEN ItemIndex := 0
  ELSE ItemIndex := i;
 WITH LinkDisplayComboBox DO Text := Items[0]
end;

procedure TLinkForm.OkBitBtnClick(Sender: TObject);
begin
 WITH LinkTable DO
  TRY
   IndexFieldNames := LinkFieldComboBox.Text;
   Open;
   Close;
   ModalResult := mrOk;
  EXCEPT
   ON EDatabaseError DO ModalResult := mrNone
  END
end;

end.
