{$B-,G+,X+}
{$I TARUBICN.INC}
{*********************************************************}
{*		      RBMAIN.PAS 1.00			 *}
{*	  Copyright (c) Tamarack Associates 1996.	 *}
{*		   All rights reserved. 		 *}
{*********************************************************}

unit rbMain;

interface

uses
  {$IFDEF WIN32}
  Windows,
  PrevInst,
  {$ELSE}
  WinTypes, WinProcs,
  {$ENDIF}
  SysUtils, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TabNotBk, DB, DBTables, Menus, Gauges, ExtCtrls,
  {$IFDEF WIN32}
  ComCtrls,
  {$ENDIF}
  {$IFDEF HaveSysTools}
  StUtils,
  {$ELSE}
  taTools,
  {$ENDIF}
  taRubicn, taLink,
  rbDBGrid, rbLink, rbPhase, rbAbout;

type
  TSearchProc = PROCEDURE(Find : STRING) OF OBJECT;

  TMainForm = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    KeyViolTable1: TTable;
    KeyViolDataSource: TDataSource;
    MatchTable1: TTable;
    MatchDataSource: TDataSource;
    SearchTable1: TTable;
    SearchDataSource: TDataSource;
    WordsTable1: TTable;
    WordsDataSource: TDataSource;
    {* Intro Tab *}
    LightningLabel: TLabel;
    EngineLabel: TLabel;
    CopyrightLabel: TLabel;
    IntroNextBtn: TButton;
    TablePrevBtn: TButton;
    TableNextBtn: TButton;
    {* Fields Tab *}
    AvailLabel: TLabel;
    SelectLabel: TLabel;
    AvailFldListBox: TListBox;
    SelectFldListBox: TListBox;
    MoveRightBtn: TButton;
    MoveLeftBtn: TButton;
    AddLinkBtn: TButton;
    EditLinkBtn: TButton;
    FieldsPrevBtn: TButton;
    FieldsNextBtn: TButton;
    {* Config Tab *}
    TablesGroupBox: TGroupBox;
     WordsLabel: TLabel;
     MatchedLabel: TLabel;
     KeyViolLabel: TLabel;
     WordsEdit: TEdit;
     MatchedEdit: TEdit;
     KeyViolEdit: TEdit;
    IndexModeGroupBox: TGroupBox;
     IndexModeComboBox: TComboBox;
     StrictCheckingCheckBox: TCheckBox;
    WordDelimGroupBox: TGroupBox;
     DelimsEdit: TEdit;
    ConfigPrevBtn: TButton;
    ConfigNextBtn: TButton;
    {* Build Tab *}
    StatsGroupBox: TGroupBox;
     StatElapsedLabel: TLabel;
     StatWordLabel: TLabel;
     StatMemLabel: TLabel;
     StatTableLabel: TLabel;
     StatBlobLabel: TLabel;
     StatCompressLabel: TLabel;
     BuildTimeLabel: TLabel;
     WordCountLabel: TLabel;
     MemUsedLabel: TLabel;
     DBSizeLabel: TLabel;
     MBSizeLabel: TLabel;
     CompressionLabel: TLabel;
    OptionsGroupBox: TGroupBox;
     FileCompressionCheckBox: TCheckBox;
     MinWordLenLabel: TLabel;
     MinWordLenEdit: TEdit;
     RecordLimitLabel: TLabel;
     RecordLimitEdit: TEdit;
    MemoryGroupBox: TGroupBox;
     MemoryComboBox: TComboBox;
    BuildBtn: TButton;
    BuildPrevBtn: TButton;
    BuildNextBtn: TButton;
    {* Search Tab *}
    SearchForGroupBox: TGroupBox;
     SearchComboBox: TComboBox;
    SearchLogicRadioGroup: TRadioGroup;
    WildCardGroupBox: TGroupBox;
     AnyCharLabel: TLabel;
     OneCharLabel: TLabel;
     AnyCharEdit: TEdit;
     OneCharEdit: TEdit;
    SearchResultsGroupBox: TGroupBox;
     WordsLabel2: TLabel;
     RecordsLabel: TLabel;
     RecordsMatchLabel: TLabel;
     WordsMatchLabel: TLabel;
    ElapsedTimeGroupBox: TGroupBox;
     ElapsedTimeLabel: TLabel;
    SearchBtn: TButton;
    NarrowSearchBtn: TButton;
    SearchPrevBtn: TButton;
    {* Menus *}
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SaveMenuItem: TMenuItem;
    SaveAsMenuItem: TMenuItem;
    OpenMenuItem: TMenuItem;
    NewMenuItem: TMenuItem;
    View1: TMenuItem;
    SearchTableMenuItem: TMenuItem;
    WordsTableMenuItem: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    MatchTableMenuItem: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    MakeDictionary1: TMakeDictionary;
    SearchDictionary1: TSearchDictionary;
    N1: TMenuItem;
    ShowAllFieldsMenuItem: TMenuItem;
    ExitMenuItem: TMenuItem;
    KeyViolTableMenuItem: TMenuItem;
    ShowHintsMenuItem: TMenuItem;
    TableGroupBox: TGroupBox;
    AliasLabel: TLabel;
    AliasComboBox: TComboBox;
    TableComboBox: TComboBox;
    TableLabel: TLabel;
    IndexComboBox: TComboBox;
    IndexLabel: TLabel;
    Contents1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure NextBtnClick(Sender: TObject);
    procedure PrevBtnClick(Sender: TObject);
    {* Table Tab *}
    procedure AliasComboBoxChange(Sender: TObject);
    procedure TableComboBoxChange(Sender: TObject);
    procedure IndexComboBoxChange(Sender: TObject);
    {* Fields Tab *}
    procedure MoveRightBtnClick(Sender: TObject);
    procedure MoveLeftBtnClick(Sender: TObject);
    procedure AddLinkBtnClick(Sender: TObject);
    procedure EditLinkBtnClick(Sender: TObject);
    procedure AvailFldListBoxClick(Sender: TObject);
    {* Config Tab *}
    procedure IndexModeComboBoxChange(Sender: TObject);
    {* Build Tab *}
    procedure MinWordLenEditExit(Sender: TObject);
    procedure RecordLimitEditExit(Sender: TObject);
    procedure BuildBtnClick(Sender: TObject);
    {* Search Tab *}
    procedure AnyCharEditExit(Sender: TObject);
    procedure SearchBtnClick(Sender: TObject);
    procedure NarrowSearchBtnClick(Sender: TObject);
    {* Menus *}
    procedure SearchTableMenuItemClick(Sender: TObject);
    procedure WordsTableMenuItemClick(Sender: TObject);
    procedure MatchTableMenuItemClick(Sender: TObject);
    procedure SaveMenuItemClick(Sender: TObject);
    procedure OpenMenuItemClick(Sender: TObject);
    procedure ShowAllFieldsMenuItemClick(Sender: TObject);

    procedure WordsTable1AfterOpen(DataSet: TDataset);
    procedure SearchTable1CalcFields(DataSet: TDataset);
    procedure SearchTable1AfterOpen(DataSet: TDataset);
    procedure SearchTable1BeforeClose(DataSet: TDataset);
    procedure WordsTable1BeforeClose(DataSet: TDataset);
    procedure MatchTable1AfterOpen(DataSet: TDataset);
    procedure MatchTable1BeforeClose(DataSet: TDataset);
    procedure SaveAsMenuItemClick(Sender: TObject);
    procedure ExitMenuItemClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    PROCEDURE PhaseOneNotify(Sender : TObject);
    PROCEDURE PhaseTwoNotify(Sender : TObject);
    procedure TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure WordsEditExit(Sender: TObject);
    procedure MatchedEditExit(Sender: TObject);
    procedure NewMenuItemClick(Sender: TObject);
    procedure KeyViolTable1AfterOpen(DataSet: TDataset);
    procedure KeyViolTable1BeforeClose(DataSet: TDataset);
    procedure KeyViolTableMenuItemClick(Sender: TObject);
    procedure KeyViolEditExit(Sender: TObject);
    procedure ShowHintsMenuItemClick(Sender: TObject);
    procedure SearchDictionary1Search(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
  private
    { Private declarations }
    FEditLink : TLinkData;
    FFileName : STRING;
    FFileNo   : INTEGER;
    FLinkList : TLinkList;
    FUpdFreq  : LONGINT;
    StartTime : TDateTime;
    FTableType: TTableType;
    FContinue : BOOLEAN;
    PROCEDURE SetDefaults;
    PROCEDURE StructureTable(Table : TTable);
    PROCEDURE ViewGridForm(DataSource : TDataSource);
  public
    { Public declarations }
    PROCEDURE Search(SearchProc : TSearchProc);
  end;


var
  MainForm: TMainForm;

implementation
{.$DEFINE Debug}
{$R *.DFM}

CONST	  FileSignature = 'Lightning Demo';
	  FileVersion	= $00010000;

PROCEDURE  SetComboBoxIndex(CB : TComboBox ; S : STRING);
BEGIN
 WITH CB DO ItemIndex := Items.IndexOf(S)
END;

FUNCTION FindForm(Caption : STRING) : TForm;
VAR i : INTEGER;
BEGIN
 Result := NIL;
 WITH Application DO
  FOR i := 0 TO ComponentCount - 1 DO
   IF (Components[i] IS TForm) AND
      (TForm(Components[i]).Caption = Caption) THEN
    BEGIN
     Result := TForm(Components[i]);
     EXIT
    END
END;

{* Table must be closed *}

PROCEDURE FixupTable(Table : TTable);
VAR       Alias : STRING;
BEGIN
 WITH Table DO
  BEGIN
   Alias := JustAliasName(TableName);
   IF Alias <> '' THEN
    BEGIN
     DatabaseName := Alias;
     TableName := COPY(TableName,LENGTH(Alias) + 3,LENGTH(TableName) - LENGTH(Alias) - 2)
    END
  END
END;

FUNCTION NameChanged(Table : TTable ; NewName : STRING) : BOOLEAN;
VAR      Alias : STRING;
BEGIN
 Alias := JustAliasName(NewName);
 IF Alias = '' THEN Result := CompareText(NewName,Table.TableName) <> 0
 ELSE
  BEGIN
   NewName := COPY(NewName,LENGTH(Alias) + 3,LENGTH(NewName) - LENGTH(Alias) - 2);
   Result  := (CompareText(Alias,Table.DatabaseName) <> 0) OR
              (CompareText(NewName,Table.TableName) <> 0)
  END
END;

{$IFDEF Debug}
{* Used only for testing the OmitList feature *}
PROCEDURE LoadOmits(D : TAbstractDictionary);
VAR       T : TTable;
BEGIN
 T := TTable.Create(NIL);
 TRY
  T.TableName := ExtractFilePath(ParamStr(0)) + 'omits.db';
  TRY
   LoadOmitsFromTable(D,T,'Word')
  EXCEPT
  END
 FINALLY
  T.Free
 END
END;
{$ENDIF}

procedure TMainForm.PhaseOneNotify(Sender: TObject);
BEGIN
 WITH TMakeDictionary(Sender),PhaseForm DO
  BEGIN
   IF dsStart IN State THEN
    BEGIN
     Gauge.MinValue := 0;
     IF RecordLimit = 0 THEN
      Gauge.MaxValue := SearchTable1.RecordCount
     ELSE
      Gauge.MaxValue := MinLong(RecordLimit,SearchTable1.RecordCount);
     Gauge.Progress := 0;
     FUpdFreq := MaxLong(Gauge.MaxValue DIV 100,1);
     Caption := 'Phase One';
     Show;
     SetFocus;
     DBSizeLabel.Caption := '';
     MBSizeLabel.Caption := '';
     CompressionLabel.Caption := '';
    END;
   IF (RecordNo MOD FUpdFreq = 0) OR (dsDone IN State) THEN
    BEGIN
     Gauge.Progress := RecordNo;
     BuildTimeLabel.Caption := FormatDateTime('  hh:nn:ss',Now - StartTime);
     MemUsedLabel.Caption := Format('%10.0n',[MemoryUsage + 0.001]);
     WordCountLabel.Caption := Format('%10.0n',[CacheCount + 0.001]);
     Application.ProcessMessages;
     IF NOT PhaseForm.Visible THEN State := State + [dsAbort];
    END
  END
END;

procedure TMainForm.PhaseTwoNotify(Sender: TObject);
VAR	  MemUsage : LONGINT;
BEGIN
 WITH TMakeDictionary(Sender),PhaseForm DO
  BEGIN
   IF dsStart IN State THEN
    BEGIN
     Caption := 'Phase Two';
     Gauge.MinValue := 0;
     Gauge.MaxValue := CacheCount;
     Gauge.Progress := 0;
     FUpdFreq := MaxLong(Gauge.MaxValue DIV 100,1);
     IF NOT FileCompression THEN CompressionLabel.Caption := '       N/A'
    END;
   IF (DiskInserts MOD FUpdFreq = 0) OR (dsDone IN State) OR (RecordNo = Gauge.MaxValue) THEN
    BEGIN
     Gauge.Progress := DiskInserts;
     BuildTimeLabel.Caption := FormatDateTime('  hh:nn:ss',Now - StartTime);
     IF dsDone IN State THEN MemUsage := MaxMemUsed
     ELSE MemUsage := MemoryUsage;
     MemUsedLabel.Caption   := Format('%10.0n',[MemUsage + 0.001]);
     DBSizeLabel.Caption    := Format('%10.0n',[DiskInserts * WordsTable1.Tag + 0.001]);
     MBSizeLabel.Caption    := Format('%10.0n',[BlobBytesWritten + 0.001]);
     IF (DiskInserts > 0) AND FileCompression THEN
      CompressionLabel.Caption :=
       Format('%9.1n%%',[(1.0 - BlobBytesWritten / (DiskInserts * ((IndexRange + 8) SHR 3))) * 100]);
     Application.ProcessMessages;
     IF NOT PhaseForm.Visible THEN State := State + [dsAbort]
    END
  END
END;

procedure TMainForm.FormCreate(Sender: TObject);
begin
 {$IFDEF WIN32}
 IF DoIExist(Caption) THEN Application.Terminate;
 {$ENDIF}
 FFileNo   := 1;
 FLinkList := TLinkList.Create;
 SetDefaults;
 Application.ShowHint := TRUE;
 {$IFDEF Debug};
 LoadOmits(MakeDictionary1);
 LoadOmits(SearchDictionary1)
 {$ENDIF}
end;

PROCEDURE TMainForm.SetDefaults;
BEGIN
 FFileName := 'LINK' + IntToStr(FFileNo) + '.LLM';
 MemoryComboBox.ItemIndex := 2; {* 8 mega bytes *}
 WITH AliasComboBox DO
  BEGIN
   Session.GetAliasNames(Items);
   IF Items.Count > 0 THEN
    BEGIN
     ItemIndex := 0;
     AliasComboBoxChange(NIL)
    END
  END;
 WordsEdit.Text := 'words';
 MatchedEdit.Text := 'matched';
 KeyViolEdit.Text := 'keyviol';
 StrictCheckingCheckBox.Checked := TRUE;
 MakeDictionary1.WordDelims := '';
 DelimsEdit.Text := DefaultWordDelims;
 FileCompressionCheckBox.Checked := TRUE;
 MinWordLenEdit.Text := '3';
 RecordLimitEdit.Text := '';
 SearchComboBox.Text := '';
 SearchComboBox.Items.Clear;
 SearchLogicRadioGroup.ItemIndex := 0;
 AnyCharEdit.Text := '*';
 OneCharEdit.Text := '?';
 BuildTimeLabel.Caption := '';
 WordCountLabel.Caption := '';
 MemUsedLabel.Caption := '';
 DBSizeLabel.Caption := '';
 MBSizeLabel.Caption := '';
 CompressionLabel.Caption := '';
 WordsMatchLabel.Caption := '0';
 RecordsMatchLabel.Caption := '0';
 FUpdFreq := 32;
END;

procedure TMainForm.AliasComboBoxChange(Sender: TObject);
begin
 WITH TableComboBox DO
  TRY
   Session.GetTableNames(AliasComboBox.Items[AliasComboBox.ItemIndex],'',TRUE,FALSE,Items);
   IF Items.Count > 0 THEN
    BEGIN
     Text := Items[0];
     TableComboBoxChange(NIL)
    END
  EXCEPT
   RAISE
  END
end;

procedure TMainForm.TableComboBoxChange(Sender: TObject);
begin
 WITH SearchTable1 DO
  TRY
   Close;
   WordsTable1.Close;
   KeyViolTable1.Close;
   MatchTable1.Close;
   FLinkList.ClearLinks;
   WITH AliasComboBox DO
    DatabaseName := Items[ItemIndex];
   TableName	:= TableComboBox.Text;
   WordsTable1.DatabaseName := DatabaseName;
   MatchTable1.DatabaseName := DatabaseName;
   StructureTable(SearchTable1);
   MakeDictionary1.DataSource := NIL;
   Open;
   FTableType := GetTableType(SearchTable1);
   WordsTable1.TableType := FTableType;
   MatchTable1.TableType := FTableType;
   MakeDictionary1.IndexMode := SafeIndexMode(SearchTable1);
   MakeDictionary1.DataSource := SearchDataSource;
   GetIndexNames(IndexComboBox.Items);
   GetFieldNames(AvailFldListBox.Items);
   MakeDictionary1.IndexMode := SafeIndexMode(SearchTable1);
   IndexModeComboBox.ItemIndex := ORD(MakeDictionary1.IndexMode);
   MakeDictionary1.DataSource := SearchDataSource; {* Force a reset of FResultBits *}
   SelectFldListBox.Items.Clear;
   FieldsNextBtn.Enabled := FALSE;
   IndexComboBoxChange(NIL);
   TableNextBtn.Enabled := TRUE
  EXCEPT
   ON EDatabaseError DO
    BEGIN
     IF TableNextBtn.Enabled THEN TableNextBtn.Enabled := FALSE;
     RAISE
    END
  END
end;

procedure TMainForm.IndexComboBoxChange(Sender: TObject);
begin
 TRY
  WITH IndexComboBox, SearchTable1 DO
   IF ItemIndex >= 0 THEN
    IndexName := Items[ItemIndex]
   ELSE
    IndexName := ''
 EXCEPT
  ON EDatabaseError DO
 END
end;

procedure TMainForm.NextBtnClick(Sender: TObject);
begin
 WITH TabbedNotebook1 DO PageIndex := PageIndex + 1;
end;

procedure TMainForm.PrevBtnClick(Sender: TObject);
begin
 WITH TabbedNotebook1 DO PageIndex := PageIndex - 1
end;

procedure TMainForm.MoveRightBtnClick(Sender: TObject);
VAR i : INTEGER;
begin
 WITH AvailFldListBox DO
  IF SelCount > 0 THEN
   FOR i := Items.Count - 1 DOWNTO 0 DO
    IF Selected[i] THEN
     BEGIN
      SelectFldListBox.Items.Add(Items[i]);
      IF NOT ShowAllFieldsMenuItem.Checked THEN
       SearchTable1.FieldByName(Items[i]).Visible := TRUE;
      Items.Delete(i)
     END;
 WITH FieldsNextBtn DO
  IF NOT Enabled THEN
   BEGIN
    Enabled := SelectFldListBox.Items.Count > 0;
    ShowAllFieldsMenuItem.Enabled := Enabled
   END
end;

procedure TMainForm.MoveLeftBtnClick(Sender: TObject);
VAR i : INTEGER;
begin
 WITH SelectFldListBox DO
  IF SelCount > 0 THEN
   FOR i := Items.Count - 1 DOWNTO 0 DO
    IF Selected[i] THEN
     BEGIN
      AvailFldListBox.Items.Add(Items[i]);
      IF NOT ShowAllFieldsMenuItem.Checked THEN
       SearchTable1.FieldByName(Items[i]).Visible := FALSE;
      Items.Delete(i)
     END;
 WITH FieldsNextBtn DO
  IF Enabled THEN
   BEGIN
    Enabled := SelectFldListBox.Items.Count > 0;
    IF NOT Enabled THEN
     WITH ShowAllFieldsMenuItem DO
      BEGIN
       Enabled := FALSE;
       IF NOT Checked THEN
	ShowAllFieldsMenuItemClick(ShowAllFieldsMenuItem)
      END
   END
end;

procedure TMainForm.ViewGridForm(DataSource : TDataSource);
VAR	  F : TDBGridForm;
	  GridCaption : STRING;
BEGIN
 GridCaption := UpperCase(TTable(DataSource.DataSet).TableName);
 F := TDBGridForm(FindForm(GridCaption));
 IF F = NIL THEN
  BEGIN
   Application.CreateForm(TDBGridForm,F);
   F.Grid.DataSource := DataSource;
   F.Caption := GridCaption;
   F.Show
  END
 ELSE
  BEGIN
   IF F.WindowState = wsMinimized THEN
    F.WindowState := wsNormal;
   F.BringToFront
  END
END;

procedure TMainForm.SearchTableMenuItemClick(Sender: TObject);
begin
 ViewGridForm(SearchDataSource)
end;

procedure TMainForm.BuildBtnClick(Sender: TObject);
CONST	  MemoryA : ARRAY[0..4] OF INTEGER = (16,12,8,4,2);
VAR	  Stop : BOOLEAN;
begin
 {$IFNDEF WIN32}
 HeapLimit := 16384;
 HeapBlock := {HeapLimit * 8}65535;
 {$ENDIF}
 Screen.Cursor := crHourGlass;
 WITH MakeDictionary1 DO
  TRY
   WordsTable1.Close;
   WordsTable1.TableName := WordsEdit.Text;
   FixupTable(WordsTable1);
   KeyViolTable1.Close;
   KeyViolTable1.TableName := AliasToPath(KeyViolEdit.Text);
   FixupTable(MatchTable1);
   MatchTable1.Close;
   MatchTable1.TableName := MatchedEdit.Text;
   FixupTable(MatchTable1);
   FieldNames.Assign(SelectFldListBox.Items);
   FileCompression := FileCompressionCheckBox.Checked;
   MemoryLimit	   := MemoryA[MemoryComboBox.ItemIndex] * 1048575 {2^20 - 1};
   WordDelims	   := DelimsEdit.Text;
   MinWordLen	   := StrToInt(MinWordLenEdit.Text);
   StrictChecking  := StrictCheckingCheckBox.Checked;
   IndexMode	   := TIndexMode(IndexModeComboBox.ItemIndex);
   KeyViolName     := KeyViolEdit.Text;
   WITH RecordLimitEdit DO
    IF Text = '' THEN RecordLimit := 0
    ELSE RecordLimit := StrToInt(Text);
   StartTime := Now;
   Execute;
   BuildNextBtn.Enabled := TRUE
  FINALLY
   {$IFDEF Debug}
   State := [];
   {$ENDIF}
   PhaseTwoNotify(MakeDictionary1);
   TRY
    KeyViolTable1.Open
   EXCEPT
   END;
   Screen.Cursor := crDefault;
   PhaseForm.Hide
  END;
end;

procedure TMainForm.SearchBtnClick(Sender: TObject);
begin
 IF SearchBtn.Caption = 'Search' THEN
  TRY
   FContinue := TRUE;
   SearchBtn.Caption := 'Stop';
   Search(SearchDictionary1.Search);
  FINALLY
   SearchBtn.Caption := 'Search'
  END
 ELSE FContinue := FALSE
end;

procedure TMainForm.NarrowSearchBtnClick(Sender: TObject);
begin
 IF NarrowSearchBtn.Caption = '&Narrow' THEN
  TRY
   FContinue := TRUE;
   NarrowSearchBtn.Caption := 'Stop';
   Search(SearchDictionary1.NarrowSearch)
  FINALLY
   NarrowSearchBtn.Caption := '&Narrow'
  END
 ELSE FContinue := FALSE
end;

procedure TMainForm.Search(SearchProc : TSearchProc);
VAR	   Time  : LONGINT;
BEGIN
 WITH SearchDictionary1 DO
  BEGIN
   WordDelims	   := DelimsEdit.Text;
   StrictChecking  := StrictCheckingCheckBox.Checked;
   IndexMode	   := TIndexMode(IndexModeComboBox.ItemIndex);
   SearchLogic	   := TLogicType(SearchLogicRadioGroup.ItemIndex);
   AnyChar	   := AnyCharEdit.Text[1];
   OneChar	   := OneCharEdit.Text[1];
   WITH SearchComboBox DO
    BEGIN
     Screen.Cursor := crHourGlass;
     TRY
      Time := GetTickCount;
      SearchProc(Text)
     FINALLY
      Time := GetTickCount - Time;
      IF Time < 1000 THEN
       ElapsedTimeLabel.Caption := Format('%4.3f seconds',[Time/1000])
      ELSE
       ElapsedTimeLabel.Caption := Format('%4.1f seconds',[Time/1000]);
      Screen.Cursor := crDefault;
      IF (ItemIndex = -1) AND (Text <> '') THEN Items.Insert(0,Text);
      IF ItemIndex > 0 THEN
       BEGIN
        Items.Insert(0,Items[ItemIndex]);  {* This will adjust ItemIndex up 1 *}
        Items.Delete(ItemIndex);           {* Not ItemIndex + 1!              *}
        ItemIndex := 0
       END;
     END
    END;
   RecordsMatchLabel.Caption := IntToStr(RecordCount);
   WordsMatchLabel.Caption := IntToStr(MatchCount);
   IF RecordLimit = 0 THEN
    IF (FindForm(SysUtils.UpperCase(MatchTable1.TableName)) <> NIL) AND
       (RecordCount < 100) THEN
     BEGIN
      CreateMatchTable(MatchTable1,100);
      StructureTable(MatchTable1)
     END
    ELSE MatchTable1.Tag := 1;
   IF RecordCount > 0 THEN MatchTableMenuItem.Enabled := TRUE
  END
END;

procedure TMainForm.AddLinkBtnClick(Sender: TObject);
VAR	  Link : TLinkData;
	  List : TStrings;
	  i    : INTEGER;

 PROCEDURE DeleteLink;
 BEGIN
  IF FEditLink = NIL THEN EXIT;
  WITH FLinkList DO
   DeleteLink(IndexOf(FEditLink));              {* can invalidate other links *}
  WITH TListBox(EditLinkBtn.Tag) DO Items.Delete(ItemIndex);
  FEditLink := NIL;
 END;

begin
 Application.CreateForm(TLinkForm,LinkForm);
 WITH LinkForm DO
  TRY
 { SearchTable1.GetFieldNames(DataFieldComboBox.Items); }
   GetNonCalcFieldNames(SearchTable1,DataFieldComboBox.Items);
   WITH AliasComboBox DO
    Session.GetTableNames(Items[ItemIndex],'',TRUE,FALSE,LinkTableComboBox.Items);
   LinkTable.DatabaseName := SearchTable1.DatabaseName;
   EditLink := FEditLink;
   CASE ShowModal OF
    mrOk :
     BEGIN
      DeleteLink;
      Link := TLinkData.Create;
      WITH Link DO
       BEGIN
	DataField      := DataFieldComboBox.Text;
	LinkDisplay    := LinkDisplayComboBox.Text;
	LinkTableName  := LinkTableComboBox.Text;
	LinkFieldNames := LinkFieldComboBox.Text;
	LinkTable.DatabaseName := SearchTable1.DatabaseName;
	List := TStringList.Create;
	TRY
	 DisplayFieldsList(List);
	 FOR i := 0 TO List.Count - 1 DO
	  SelectFldListBox.Items.Add(JustFileName(LinkTableName) + List[I])
	FINALLY
	 List.Free
	END
       END;
      FLinkList.Add(Link);
      Link.CreateLinkFields(SearchTable1)
     END;
    mrNo : DeleteLink;
    ELSE FEditLink := NIL
   END
  FINALLY
   Release
  END;
 WITH FieldsNextBtn DO
  IF NOT Enabled THEN
   BEGIN
    Enabled := SelectFldListBox.Items.Count > 0;
    ShowAllFieldsMenuItem.Enabled := Enabled
   END
end;

procedure TMainForm.EditLinkBtnClick(Sender: TObject);
VAR	  FieldName : STRING;
	  Index     : INTEGER;
begin
 WITH TListBox(EditLinkBtn.Tag) DO FieldName := Items[ItemIndex];
 Index := FLinkList.FindLinkDisplayField(FieldName,TRUE);
 IF Index >= 0 THEN FEditLink := FLinkList.Items[Index];
 AddLinkBtnClick(Self);
 IF FEditLink <> NIL THEN
  BEGIN
   WITH FLinkList DO DeleteLink(IndexOf(FEditLink));
   FEditLink := NIL
  END;
 AvailFldListBoxClick(TObject(EditLinkBtn.Tag))
end;

procedure TMainForm.AvailFldListBoxClick(Sender: TObject);
VAR	  Field   : TField;
	  CanEdit : BOOLEAN;
begin
 CanEdit := FALSE;
 WITH Sender AS TListBox,SearchTable1 DO
  IF SelCount = 1 THEN
   BEGIN
    Field := FindField(Items[ItemIndex]);
    IF Field <> NIL THEN CanEdit := Field.Calculated
   END;
 EditLinkBtn.Enabled := CanEdit;
 EditLinkBtn.Tag := LONGINT(Sender)
end;

procedure TMainForm.SearchTable1CalcFields(DataSet: TDataset);
VAR	  i,j : INTEGER;
	  JustName,DisplayName : STRING;
	  Field : TField;
begin
 FOR i := 0 TO FLinkList.Count - 1 DO
  WITH TLinkData(FLinkList.Items[i]),DataSet DO
   BEGIN
    IF NOT LinkTable.Active THEN LinkTable.Open;
    IF LinkTable.FindKey([FieldByName(DataField).AsString]) THEN
     BEGIN
      JustName := JustFileName(LinkTable.TableName);
      j := 1;
      WHILE j < LENGTH(LinkDisplay) DO
       BEGIN
	DisplayName := ExtractFieldName(LinkDisplay,j);
	Field := FindField(JustName + DisplayName);
	IF Field <> NIL THEN
	 Field.AsString := LinkTable.FieldByname(DisplayName).AsString
       END
     END
   END
end;

procedure TMainForm.WordsTableMenuItemClick(Sender: TObject);
begin
 ViewGridForm(WordsDataSource)
end;

procedure TMainForm.MatchTableMenuItemClick(Sender: TObject);
begin
 IF MatchTable1.Tag <> 0 THEN
  BEGIN
   MatchTable1.Tag := 0;
   SearchDictionary1.CreateMatchTable(MatchTable1,100)
  END;
 StructureTable(MatchTable1);
 ViewGridForm(MatchDataSource)
end;

PROCEDURE TMainForm.StructureTable(Table : TTable);
VAR	  i	 : INTEGER;
	  Field  : TField;
	  Reopen : BOOLEAN;
BEGIN
 WITH Table DO
  BEGIN
   Reopen := Active;
   Close;
   FreeFields(Table);
   FieldDefs.Update;
   FOR i := 0 TO FieldDefs.Count - 1 DO
    FieldDefs[i].CreateField(Table);
   FOR i := 0 TO FLinkList.Count - 1 DO
    TLinkData(FLinkList[i]).CreateLinkFields(Table);
   IF NOT ShowAllFieldsMenuItem.Checked THEN
    FOR i := 0 TO AvailFldListBox.Items.Count - 1 DO
     BEGIN
      Field := FindField(AvailFldListBox.Items[i]);
      IF Field <> NIL THEN Field.Visible := FALSE
     END;
   IF Reopen THEN Open
  END
END;

procedure TMainForm.SaveMenuItemClick(Sender: TObject);
VAR	  Stream : TFileStream;
	  Writer : TWriter;
	  i	 : INTEGER;
	  List	 : TStrings;
	  Save	 : BOOLEAN;
begin
 List := TStringList.Create;
 WITH SaveDialog1 DO
  TRY
   WITH AliasComboBox DO
    Session.GetAliasParams(Items[ItemIndex],List);
   SaveDialog1.InitialDir := List.Values['PATH'];
   FileName := FFileName;
   Save := Execute;
   IF Save THEN FFileName := FileName
  FINALLY
   List.Free
  END;
 IF NOT Save THEN EXIT;
 Stream := TFileStream.Create(FFileName,fmCreate);
 TRY
  Writer := TWriter.Create(Stream,1024);
  WITH Writer DO
   TRY
    WriteString(FileSignature);
    WriteInteger(FileVersion);
    WriteBoolean(ShowAllFieldsMenuItem.Checked);
    {* Table Tab *}
    WITH AliasComboBox DO WriteString(Items[ItemIndex]);
    WriteString(TableComboBox.Text);
    WITH IndexComboBox DO WriteString(Items[ItemIndex]);
    {* Fields Tab *}
    FLinkList.Write(Writer);
    WriteInteger(SelectFldListBox.Items.Count);
    FOR i := 0 TO SelectFldListBox.Items.Count - 1 DO
     WriteString(SelectFldListBox.Items[i]);
    {* Configure Tab *}
    WriteString(WordsEdit.Text);
    WriteString(MatchedEdit.Text);
    WriteString(KeyViolEdit.Text);
    WriteBoolean(StrictCheckingCheckBox.Checked);
    WriteInteger(IndexModeComboBox.ItemIndex);
    WriteString(DelimsEdit.Text);
    {* Build Tab *}
    WriteString(BuildTimeLabel.Caption);
    WriteString(WordCountLabel.Caption);
    WriteString(MemUsedLabel.Caption);
    WriteString(DBSizeLabel.Caption);
    WriteString(MBSizeLabel.Caption);
    WriteString(CompressionLabel.Caption);
    WriteBoolean(FileCompressionCheckBox.Checked);
    WriteString(MinWordLenEdit.Text);
    WriteString(RecordLimitEdit.Text);
    WriteInteger(MemoryComboBox.ItemIndex);
    {* Search Tab *}
    WriteString(SearchComboBox.Text);
    WriteInteger(SearchLogicRadioGroup.ItemIndex);
    WriteString(AnyCharEdit.Text);
    WriteString(OneCharEdit.Text);
    WriteString(WordsMatchLabel.Caption);
    WriteString(RecordsMatchLabel.Caption);
    WriteString(ElapsedTimeLabel.Caption);
    {* Reserved for future use *}
    FOR i := 0 TO 3 DO WriteString('~~~');
   FINALLY
    Free
   END
 FINALLY
  Stream.Free
 END
end;

procedure TMainForm.OpenMenuItemClick(Sender: TObject);
VAR	  Stream    : TFileStream;
	  Reader    : TReader;
	  Count,i,j : INTEGER;
	  List	    : TStrings;
	  Version   : LONGINT;
	  Open	    : BOOLEAN;
begin
 List := TStringList.Create;
 WITH OpenDialog1 DO
  TRY
   Session.GetAliasParams(AliasComboBox.Text,List);
   InitialDir := List.Values['PATH'];
   Open := Execute;
   IF Open THEN FFileName := FileName
  FINALLY
   List.Free
  END;
 IF NOT Open THEN EXIT;
 Stream := TFileStream.Create(FFileName,fmOpenRead);
 TRY
  Reader := TReader.Create(Stream,1024);
  WITH Reader DO
   TRY
    IF ReadString <> FileSignature THEN
     RAISE EDictionary.Create('Invalid file format!');
    Version := ReadInteger;
    ShowAllFieldsMenuItem.Checked := NOT ReadBoolean;
    ShowAllFieldsMenuItemClick(ShowAllFieldsMenuItem);
    {* Table Tab *}
    SetComboBoxIndex(AliasComboBox,ReadString);
    AliasComboBoxChange(NIL);
    TableComboBox.Text := ReadString;
    TableComboBoxChange(NIL);
    SetComboBoxIndex(IndexComboBox,ReadString);
    IndexComboboxChange(NIL);
    {* Fields Tab *}
    FLinkList.Read(Reader);
    FOR i := 0 TO FLinkList.Count - 1 DO
     WITH TLinkData(FLinkList.Items[i]) DO
      BEGIN
       List := TStringList.Create;
       TRY
	DisplayFieldsList(List);
	FOR j := 0 TO List.Count - 1 DO
	 AvailFldListBox.Items.Add(JustFileName(LinkTableName) + List[j])
       FINALLY
	List.Free
       END;
       CreateLinkFields(SearchTable1)
      END;

    Count := ReadInteger;
    FOR i := 1 TO Count DO
     BEGIN
      j := AvailFldListBox.Items.IndexOf(ReadString);
      IF j >= 0 THEN AvailFldListBox.Selected[j] := TRUE
     END;
    MoveRightBtnClick(NIL);
    {* Configure Tab *}
    WordsEdit.Text := ReadString;
    MatchedEdit.Text := ReadString;
    KeyViolEdit.Text := ReadString;
    StrictCheckingCheckBox.Checked := ReadBoolean;
    IndexModeComboBox.ItemIndex := ReadInteger;
    DelimsEdit.Text := ReadString;
    {* Build Tab *}
    BuildTimeLabel.Caption := ReadString;
    WordCountLabel.Caption := ReadString;
    MemUsedLabel.Caption := ReadString;
    DBSizeLabel.Caption := ReadString;
    MBSizeLabel.Caption := ReadString;
    CompressionLabel.Caption := ReadString;
    FileCompressionCheckBox.Checked := ReadBoolean;
    MinWordLenEdit.Text := ReadString;
    RecordLimitEdit.Text := ReadString;
    MemoryComboBox.ItemIndex := ReadInteger;
    {* Search Tab *}
    SearchComboBox.Text := ReadString;
    SearchLogicRadioGroup.ItemIndex := ReadInteger;
    AnyCharEdit.Text := ReadString;
    OneCharEdit.Text := ReadString;
    WordsMatchLabel.Caption := ReadString;
    RecordsMatchLabel.Caption := ReadString;
    ElapsedTimeLabel.Caption := ReadString;
    {* Reserved for future use *}
    FOR i := 0 TO 3 DO ReadString;
   FINALLY
    Free
   END
 FINALLY
  Stream.Free
 END;
{$IFDEF Debug}
 SearchTable1.Open;
 MatchTable1.DatabaseName := SearchTable1.DatabaseName;
 MatchTable1.TableName := MatchedEdit.Text;
 KeyViolTable1.TableName := AliasToPath(KeyViolEdit.Text);
 WordsTable1.DatabaseName := SearchTable1.DatabaseName;
 WordsTable1.TableName := WordsEdit.Text;
 WordsTable1.IndexFieldNames := 'Word';
 WordsTable1.Open;
 BuildNextBtn.Enabled := TRUE
 {$ENDIF}
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
 FLinkList.Free
end;

procedure TMainForm.WordsTable1AfterOpen(DataSet: TDataset);
begin
 DataSet.Tag := GetRecordSize(DataSet);
 WordsTableMenuItem.Enabled := TRUE
end;

procedure TMainForm.AnyCharEditExit(Sender: TObject);
begin
 WITH SearchBtn DO
  BEGIN
   Enabled := LENGTH((Sender AS TEdit).Text) = 1;
   NarrowSearchBtn.Enabled := Enabled;
   IF NOT Enabled THEN
    BEGIN
     MessageDlg('Cannot search without valid wildcards',mtError,[mbOk],0);
     (Sender AS TEdit).SetFocus
    END
  END
end;

procedure TMainForm.MinWordLenEditExit(Sender: TObject);

 PROCEDURE Error;
 BEGIN
  MessageDlg('Value must be in the range 1 - 9',mtError,[mbOk],0);
  TEdit(Sender).SetFocus
 END;

begin
 WITH Sender AS TEdit DO
  TRY
   IF (StrToInt(Text) > 9) OR
      (StrToInt(Text) < 1) THEN Error
  EXCEPT
   ON EConvertError DO Error
  END
end;

procedure TMainForm.IndexModeComboBoxChange(Sender: TObject);
begin
 WITH Sender AS TComboBox,MakeDictionary1 DO
  BEGIN
   DataSource := SearchDataSource;
   StrictChecking := StrictCheckingCheckBox.Checked;
   TRY
    IndexMode := TIndexMode(ItemIndex)
   EXCEPT
    ON EDictionary DO
     ItemIndex := ORD(SafeIndexMode(SearchTable1))
   END
  END
end;

procedure TMainForm.ShowAllFieldsMenuItemClick(Sender: TObject);
VAR i : INTEGER;
begin
 WITH SearchTable1,Sender AS TMenuItem DO
  BEGIN
   Checked := NOT Checked;
   FOR i := 0 TO FieldCount - 1 DO
    WITH Fields[i] DO
     Visible := Checked OR (SelectFldListBox.Items.IndexOf(FieldName) <> -1)
  END
end;

procedure TMainForm.RecordLimitEditExit(Sender: TObject);

 PROCEDURE Error;
 BEGIN
  MessageDlg('Value must be a positive integer or blank',mtError,[mbOk],0);
  TEdit(Sender).SetFocus
 END;

begin
 WITH Sender AS TEdit DO
  IF Text <> '' THEN
   TRY
    IF StrToInt(Text) < 0 THEN Error
   EXCEPT
    ON EConvertError DO Error
   END
end;

procedure TMainForm.SearchTable1AfterOpen(DataSet: TDataset);
VAR F : TForm;
begin
 SearchTableMenuItem.Enabled := TRUE;
 F := FindForm('Search Table');
 IF F <> NIL THEN F.Caption := UpperCase(TTable(DataSet).TableName)
end;

procedure TMainForm.SearchTable1BeforeClose(DataSet: TDataset);
VAR	  F : TForm;
begin
 SearchTableMenuItem.Enabled := FALSE;
 F := FindForm(UpperCase(TTable(DataSet).TableName));
 IF F <> NIL THEN F.Caption := 'Search Table'
end;

procedure TMainForm.WordsTable1BeforeClose(DataSet: TDataset);
begin
 WordsTableMenuItem.Enabled := FALSE;
end;

procedure TMainForm.MatchTable1AfterOpen(DataSet: TDataset);
begin
 MatchTableMenuItem.Enabled := TRUE
end;

procedure TMainForm.MatchTable1BeforeClose(DataSet: TDataset);
begin
 MatchTableMenuItem.Enabled := FALSE
end;

procedure TMainForm.SaveAsMenuItemClick(Sender: TObject);
begin
 FFilename := 'LINK1.LLM';
 SaveMenuItemClick(Sender)
end;

procedure TMainForm.ExitMenuItemClick(Sender: TObject);
begin
 Application.Terminate
end;

procedure TMainForm.About1Click(Sender: TObject);
var F : TForm;
begin
 Application.CreateForm(TAboutForm,F);
 F.ShowModal
end;

procedure TMainForm.TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
 CASE NewTab OF
  0,1  : AllowChange := TRUE;
  2    : AllowChange := TableNextBtn.Enabled;
  3,4  : AllowChange := FieldsNextBtn.Enabled;
  5    : BEGIN
          AllowChange := BuildNextBtn.Enabled;
          SearchDictionary1.FlushCache
         END
 END
end;

procedure TMainForm.WordsEditExit(Sender: TObject);
begin
 WITH WordsTable1 DO
  IF Active AND (CompareText(WordsEdit.Text,TableName) <> 0) THEN
   BEGIN
    Close;
    DeleteTable;
    BuildNextBtn.Enabled := FALSE
   END
end;

procedure TMainForm.MatchedEditExit(Sender: TObject);
begin
 WITH MatchTable1 DO
  IF Active AND (CompareText(WordsEdit.Text,TableName) <> 0) THEN
   BEGIN
    Close;
    DeleteTable
   END
end;

procedure TMainForm.NewMenuItemClick(Sender: TObject);
begin
 INC(FFileNo);
 SetDefaults;
 TabbedNotebook1.PageIndex := 0;
end;

procedure TMainForm.KeyViolTable1AfterOpen(DataSet: TDataset);
begin
 KeyViolTableMenuItem.Enabled := TRUE
end;

procedure TMainForm.KeyViolTable1BeforeClose(DataSet: TDataset);
begin
 KeyViolTableMenuItem.Enabled := FALSE
end;

procedure TMainForm.KeyViolTableMenuItemClick(Sender: TObject);
begin
 ViewGridForm(KeyViolDataSource)
end;

procedure TMainForm.KeyViolEditExit(Sender: TObject);
begin
 WITH KeyViolTable1 DO
  IF Active AND (CompareText(KeyViolEdit.Text,TableName) <> 0) THEN
   BEGIN
    Close;
    DeleteTable
   END
end;

procedure TMainForm.ShowHintsMenuItemClick(Sender: TObject);
begin
 WITH ShowHintsMenuItem DO
  BEGIN
   Checked := NOT Checked;
   Application.ShowHint := Checked
  END
end;

procedure TMainForm.SearchDictionary1Search(Sender: TObject);
begin
 Application.ProcessMessages;
 IF NOT FContinue THEN
  WITH SearchDictionary1 DO
   State := State + [dsAbort]
end;

procedure TMainForm.Contents1Click(Sender: TObject);
begin
 Application.HelpCommand(HELP_CONTENTS,0)
end;

end.
