UNIT Rubicon;

INTERFACE

USES	  Classes, SysUtils, Consts, DsgnIntf, taRubicn;

TYPE	  TtaWildCardProperty = CLASS(TCharProperty)
	  PUBLIC
	   FUNCTION  GetAttributes : TPropertyAttributes ; OVERRIDE;
	   FUNCTION  GetValue : STRING ; OVERRIDE;
	   PROCEDURE GetValues(Proc : TGetStrProc) ; OVERRIDE;
	   PROCEDURE SetValue(CONST Value : STRING); OVERRIDE;
	  END;

	 TtaWordDelimsProperty = CLASS(TStringProperty)
	  PUBLIC
	   FUNCTION  GetValue : STRING ; OVERRIDE;
	  END;

PROCEDURE Register;

IMPLEMENTATION

FUNCTION  TtaWildCardProperty.GetAttributes : TPropertyAttributes;
BEGIN
 Result := [paValueList] + INHERITED GetAttributes
END;

FUNCTION  TtaWildCardProperty.GetValue : STRING;
BEGIN
 Result := INHERITED GetValue;
 IF Result = '#0' THEN
  IF GetName = 'AnyChar' THEN Result := '*'
  ELSE Result := '?'
END;

PROCEDURE TtaWildCardProperty.GetValues(Proc : TGetStrProc);
BEGIN
 Proc('*');
 Proc('?');
 Proc('!');
 Proc('@');
 Proc('#');
 Proc('$');
 Proc('%');
 Proc('&');
 Proc('/');
 Proc('\');
 Proc('+');
 Proc('|');
 Proc('-');
END;

PROCEDURE TtaWildCardProperty.SetValue(CONST Value : STRING);
VAR	  SD : TSearchDictionary;
	  Ch : CHAR;
BEGIN
 SD := GetComponent(0) AS TSearchDictionary;
 Ch := Value[1];
 IF ((GetName = 'AnyChar') AND (Ch = SD.OneChar)) OR
    ((GetName = 'OneChar') AND (Ch = SD.AnyChar)) THEN
  RAISE EPropertyError.Create(LoadStr(SInvalidPropertyValue))
 ELSE INHERITED SetValue(Value)
END;

FUNCTION  TtaWordDelimsProperty.GetValue : STRING;
BEGIN
 Result := INHERITED GetValue;
 IF Result = '' THEN Result := DefaultWordDelims
END;

PROCEDURE Register;
BEGIN
  RegisterComponents('Tamarack', [TMakeDictionary,TUpdateDictionary,TSearchDictionary]);
  RegisterPropertyEditor(TypeInfo(CHAR),TSearchDictionary,'AnyChar',
			 TtaWildCardProperty);
  RegisterPropertyEditor(TypeInfo(CHAR),TSearchDictionary,'OneChar',
			 TtaWildCardProperty);
  RegisterPropertyEditor(TypeInfo(STRING),TAbstractDictionary,'WordDelims',
			 TtaWordDelimsProperty);
{ RegisterPropertyEditor(TypeInfo(STRING),TUpdateDictionary,'WordDelims',
			 TtaWordDelimsProperty); }
END;

END.
