/* ************************************************************************
Activity linked to Activity
************************************************************************ */
CREATE TABLE ACTACT (
    ACTIVITY                            integer              ,
        /** Activity that linke to Activity. **/
    LINKETOACTIVITY                     integer              ,
        /** Activity that Activity linke to. **/

    PRIMARY KEY (ACTIVITY, LINKETOACTIVITY)
)
/* ************************************************************************
Activity linked to Document
************************************************************************ */
CREATE TABLE ACTDOCT (
    ACTIVITY                            integer              ,
        /** Activity that linked to Document. **/
    LINKEDTODOCUMENT                    character       (20) ,
        /** Document that Activity linked to. **/

    PRIMARY KEY (ACTIVITY, LINKEDTODOCUMENT)
)
/* ************************************************************************
Activity is an  any kind of Law Firm activity and cold be associated with 
a lot of things ( matters, clients, ..., oher activitis )
************************************************************************ */
CREATE TABLE ACTIVITY (
    ACTIVITY                            integer              ,
        /** The primary identifier of Activity **/
    PROJECTEDDATE                       date                 ,
        /** ProjectedDate that Activity has. **/
    PROJECTEDTIME                       time                 ,
        /** ProjectedTime that Activity has. **/
    ACTIVITYTYPE                        character       (20) ,
        /** ActivityType that Activity has. **/
    COMPLETIONSTATUS                    character       (1)  ,
        /** CompletionStatus that Activity has. **/
    ACTIVITYSUMMARY                     char            (255) ,
        /** ActivitySummary that Activity has. **/
    SUCCESSSTATUS                       character       (1)  ,
        /** SuccessStatus that Activity has. **/
    LABELEACTIVITYTITLE                 character       (15) ,
        /** ActivityTitle that Activity labele by. **/
    DEADLINEDATE                        date                 ,
        /** DeadLineDate that Activity has. **/
    COMPLETIONDATE                      date                 ,
        /** CompletionDate that Activity has. **/

    PRIMARY KEY (ACTIVITY)
)
/* ************************************************************************
Assignment is an appointing of a person to a duty on a case.
************************************************************************ */
CREATE TABLE ASSNT (
    ASSIGNMENT                          integer              ,
        /** The primary identifier of Assignment **/
    MATTERTRAILID                       integer              ,
        /** MatterTrailID that identify MatterTrail. **/
    MATTERTRAILNO                       integer              ,
        /** MatterTrailNo that MatterTrail has. **/
    ASSIGNID                            integer              ,
        /** AssignID that Assignment has. **/
    ASNDATE                             date                 ,
        /** AsnDate that Assignment has. **/
    COMPDATE                            date                 ,
        /** CompDate that Assignment has. **/
    DEADLINE                            date                 ,
        /** DeadLine that Assignment has. **/
    ASSIGNMENTHRRATE                    float                ,
        /** AssignmentHrRate that Assignment has. **/
    OSFSTATUS                           character       (1)  ,
        /** OSFstatus that Assignment has. **/
    ASSIGNMENTSTATUS                    smallint             ,
        /** AssignmentStatus that Assignment has. **/

    PRIMARY KEY (ASSIGNMENT)
)
/* ************************************************************************
AssignmentStatus is used to record ongoing progress of the displayed assiggnment
************************************************************************ */
CREATE TABLE ASSTSTAT (
    ASSIGNMENTSTATUS                    smallint             ,
        /** The primary identifier of AssignmentStatus **/
    STATDATE                            date                 ,
        /** StatDate that AssignmentStatus has. **/
    STATUSDESCRIPTION                   character       (140) ,
        /** StatusDescription that AssignmentStatus has. **/
    TIMESPENT                           float                ,
        /** TimeSpent that AssignmentStatus has. **/
    CLOSED                              boolean              ,
        /** Indicates whether AssignmentStatus closed or not **/
    STATUSTITLE                         character       (20) ,
        /** StatusTitle that AssignmentStatus has. **/

    PRIMARY KEY (ASSIGNMENTSTATUS)
)
/* ************************************************************************
Attorney: Accociate or Parallegal
************************************************************************ */
CREATE TABLE ATTORNEY (
    ATTORNEY                            character       (12) ,
        /** The primary identifier of Attorney **/
    ATTORNEYFIRSTNAME                   character       (20) ,
        /** AttorneyFirstName that Attorney has. **/
    ATTORNEYLASTNAME                    character       (20) ,
        /** AttorneyLastName that Attorney has. **/
    ATTORNEYTYPE                        character       (1)  ,
        /** AttorneyType that Attorney is. **/

    PRIMARY KEY (ATTORNEY)
)
/* ************************************************************************
Client open Matter
************************************************************************ */
CREATE TABLE CLMATT (
    CLIENT                              character       (16) ,
        /** Client that open Matter. **/
    OPENMATTER                          integer              ,
        /** Matter that Client open. **/

    PRIMARY KEY (CLIENT, OPENMATTER)
)
/* ************************************************************************
Client is a Company or a Person using a servise of the Law Firm
************************************************************************ */
CREATE TABLE CLIENT (
    CLIENT                              character       (16) ,
        /** The primary identifier of Client **/
    RETDATE                             date                 ,
        /** RetDate that Client has. **/
    RELENTITY                           integer              ,
        /** RelEntity that Client has. **/
    CLIENTNAME                          character       (25) ,
        /** ClientName that Client has. **/
    CATEGORY                            character       (7)  ,
        /** Category that Client has. **/
    CONTACTFISTNAME                     character       (15) ,
        /** ContactFistName that Client has. **/
    CONTACTLASTNAME                     character       (15) ,
        /** ContactLastName that Client has. **/
    PROFILE                             integer              ,
        /** Profile that Client has. **/

    PRIMARY KEY (CLIENT)
)
