///////////////////////////////////////////////////////
// scrolbar.c                                        //
// -- Program demonstrates that SetScrollRange() can //
//    create a scrollbar where none was before!      //
// -- Written by Paul R. Bonneau 11/25/94.           //
///////////////////////////////////////////////////////
#include <windows.h>

#ifdef __WATCOMC__
    #pragma off (unreferenced);
#endif

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hins, HINSTANCE hinsPrev,
  LPSTR lpsz, int wShow)
    {
    HWND    hwnd;
    MSG     msg;
    int     dx  = GetSystemMetrics(SM_CXSCREEN);
    int     dy  = GetSystemMetrics(SM_CYSCREEN);

    if (NULL != (hwnd = CreateWindow("ListBox",
      "I have a Scrollbar!", WS_OVERLAPPEDWINDOW,
      dx / 4, dy / 4, dx / 2, dy / 2, NULL, NULL,
      hins, NULL)))
        {
        int isz;

        for (isz = 0; 100 > isz; isz++)
            {
            char    szBuf[256];

            wsprintf(szBuf, "This is line %d", isz);
            SendMessage(hwnd, LB_ADDSTRING, 0,
              (LPARAM)(LPSTR)szBuf);
            }
        ShowWindow(hwnd, wShow);
        MessageBox(hwnd, "About to add a scrollbar",
          "Scrollbar demo", MB_OK);
        SetScrollRange(hwnd, SB_VERT, 0, 100, TRUE);
        MessageBox(hwnd, "About to remove the scrollbar",
          "Scrollbar demo", MB_OK);
        SetScrollRange(hwnd, SB_VERT, 100, 100, TRUE);
        while (GetMessage(&msg, NULL, 0, 0))
            {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
            if (!IsWindow(hwnd))
                break;
            }
        }

    return 0;
    }
