unit Stopwch1;

{ Really quick and dirty high-res stopwatch using QueryPerformanceCounter.
  Needs to be spruced up with proper 64-bit arithmetic.
  Currently only good for one half-hour intervals
  05-06-96 GW Original

}

interface
uses windows;

Type
  TStopwatch = class
  private
    PerfCounterFreq: TLargeInteger;
    msDivider: integer;
    StartTime: TLargeInteger;
  public
    procedure Reset;
    constructor Create;
   { function ElapsedTimeSec: Real; }
    function ElapsedTimems: integer;
  end;

implementation

{--------------------------------}
constructor TStopwatch.Create;
{--------------------------------}
Var
  Success: boolean;
Begin
  Success := QueryPerformanceFrequency(PerfCounterFreq);
  msDivider := PerfCounterFreq.LowPart div 2000;
  Reset;
end;

{--------------------------------}
procedure TStopwatch.Reset;
{--------------------------------}
Var
  Success: boolean;
Begin
  Success := QueryPerformanceCounter(StartTime);
end;

{--------------------------------}
function TStopwatch.ElapsedTimems: integer;
{--------------------------------}
Var
  Success: boolean;
  NewTime: TLargeInteger;
  NewLowPartSh, StartLowPartSh, ElapsedCountSh: integer;
  { shr avoids math problem with integer sign (ie: shr does not preserve sign) }
Begin
  Success := QueryPerformanceCounter(NewTime);
  NewLowPartSh   := NewTime.LowPart shr 1;
  StartLowPartSh := StartTime.LowPart shr 1;
  ElapsedCountSh := NewLowPartSh - StartLowPartSh;
  { answers from - $4000 0000 to +$3FFF FFFF, if -ve then assume timer wrapped }
  If ElapsedCountSh < 0 then ElapsedCountSh := ElapsedCountSh + $40000000;

  Result := ElapsedCountSh div msDivider;
end;

end.
