{

Demonstration program for the TSolver component

Shows:
  - user-edited expressions
  - call Parse method once
  - call Solve method many times
  - how to plot results
  - how to display error messages and locations

}

unit Testb1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Solver;

type
  TForm1 = class(TForm)
    Solver1: TSolver;
    Memo1: TMemo;
    PaintBox1: TPaintBox;
    pnlError: TPanel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Solver1FunctionCall(Sender: TObject; index: Integer;
      params: PRealArray; NumParams: Integer; var OK: Boolean;
      var result: Double);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{
uses Misc;
}

{$R *.DFM}

var
  x: real;

function LineToOffset(memo: TMemo; line: integer): integer;
var i: integer;
begin
  result:=0;
  if line >= memo.lines.count then
    result:=memo.GetTextLen else
  for i:=1 to line do
    inc(result,length(memo.lines.strings[i-1])+2);
end;

procedure TForm1.Button1Click(Sender: TObject);
var p: TPoint;
    index,i,y: integer;
begin
  with Solver1 do
  begin
    pnlError.Caption:='';
    Equations.Assign(Memo1.Lines);
    if not Parse then
    begin
      p:=ErrorPos;
      if p.x < 0 then p.x:=0;
      if p.y >= 0 then
      begin
        Memo1.SelStart:=LineToOffset(Memo1,p.y)+p.x;
        Memo1.SelLength:=0;
      end;
      Memo1.SetFocus;
      pnlError.Caption:=ErrorString;
    end else
    with PaintBox1,Canvas do
    begin
      for index:=0 to Memo1.Lines.Count-1 do
      for i:=0 to Width do
      begin
        x:=i/20;
        Solve;
        if Known[index] then
        begin
          y:=Height div 2 - trunc(Value[index]*50);
          if i = 0 then
            MoveTo(i,y) else
            LineTo(i,y);
        end;
      end;
    end;
  end;
end;

procedure TForm1.Solver1FunctionCall(Sender: TObject; index: Integer;
  params: PRealArray; NumParams: Integer; var OK: Boolean;
  var result: Double);
begin
  result:=X;
end;

end.

