unit Testrep;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Quickrep, StdCtrls, DBCtrls, DB, DBTables;

type
  TTestReport = class(TForm)
    DemoReport: TQuickReport;
    DataSource1: TDataSource;
    Customer: TTable;
    Title: TQRBand;
    QRLabel1: TQRLabel;
    PageHeader: TQRBand;
    PageNumber: TQRLabel;
    Group1Header: TQRBand;
    Alphabetic: TQRGroup;
    Letter: TQRLabel;
    CustomerCustNo: TFloatField;
    CustomerCompany: TStringField;
    CustomerAddr1: TStringField;
    CustomerAddr2: TStringField;
    CustomerCity: TStringField;
    CustomerState: TStringField;
    CustomerZip: TStringField;
    CustomerCountry: TStringField;
    CustomerPhone: TStringField;
    CustomerFAX: TStringField;
    CustomerTaxRate: TFloatField;
    CustomerContact: TStringField;
    CustomerLastInvoiceDate: TDateTimeField;
    Detail: TQRBand;
    QRDBText1: TQRDBText;
    Summary: TQRBand;
    SummaryLabel: TQRLabel;
    CustCountLabel: TQRLabel;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    PageFooter: TQRBand;
    TimeLabel: TQRLabel;
    QRLabel2: TQRLabel;
    QRDBText4: TQRDBText;
    QRShape1: TQRShape;
    procedure PageHeaderBeforePrint(Sender: TObject);
    procedure TitleAfterPrint(Sender: TObject);
    procedure DemoReportBeforePrint(Sender: TObject);
    procedure Group1HeaderBeforePrint(Sender: TObject);
    procedure AlphabeticNeedData(var Value: OpenString);
    procedure DetailBeforePrint(Sender: TObject);
    procedure SummaryBeforePrint(Sender: TObject);
     private
    { Private declarations }
  public
    { Public declarations }
    CustomerCount : Longint;

  end;

var
  TestReport: TTestReport;

implementation

{$R *.DFM}



procedure TTestReport.PageHeaderBeforePrint(Sender: TObject);
begin
   PageNumber.Caption:='Page '+InttoStr(DemoReport.PageNumber);
end;

procedure TTestReport.TitleAfterPrint(Sender: TObject);
begin
   PageHeader.Enabled:=True;
end;

procedure TTestReport.DemoReportBeforePrint(Sender: TObject);
begin
   PageHeader.Enabled:=False;
   CustomerCount:=0;
   TimeLabel.Caption:='Printed at '+TimeToStr(Time);
end;

procedure TTestReport.Group1HeaderBeforePrint(Sender: TObject);
begin
   Letter.Caption:=copy(CustomerCompany.AsString,1,1);
end;

procedure TTestReport.AlphabeticNeedData(var Value: OpenString);
begin
   Value:=copy(CustomerCompany.Asstring,1,1);
end;

procedure TTestReport.DetailBeforePrint(Sender: TObject);
begin
   CustomerCount:=CustomerCount+1;
end;

procedure TTestReport.SummaryBeforePrint(Sender: TObject);
begin
   CustCountLabel.Caption:=IntToStr(CustomerCount);
end;

end.
