unit Toolmain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, Buttons, Menus, DemoBar, ExtCtrls;

type
  TToolDemoForm = class(TForm)
    CloseBtn: TBitBtn;
    MainMenu1: TMainMenu;
    ToolBar1: TMenuItem;
    Hide1: TMenuItem;
    Show1: TMenuItem;
    N1: TMenuItem;
    DockatTop1: TMenuItem;
    Top1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Bottom1: TMenuItem;
    TopLH1: TMenuItem;
    TopLV1: TMenuItem;
    TopRH1: TMenuItem;
    TopRV1: TMenuItem;
    BotLH1: TMenuItem;
    BotLV1: TMenuItem;
    BotRH1: TMenuItem;
    BotRV1: TMenuItem;
    N2: TMenuItem;
    Dock1: TMenuItem;
    Label1: TLabel;
    Image1: TImage;
    procedure CloseBtnClick(Sender: TObject);
    procedure Show1Click(Sender: TObject);
    procedure Hide1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Top1Click(Sender: TObject);
    procedure Dock1Click(Sender: TObject);
  private
    initialized : boolean;
    procedure WMMove(var Message : TWMMove); Message WM_MOVE;
  public
    { Public declarations }
  end;

var
  ToolDemoForm: TToolDemoForm;

implementation

{$R *.DFM}

procedure TToolDemoForm.WMMove(var Message:TWMMove);
begin
  if initialized then if Tools.SnapOnMove then
    Tools.SnapBar(Self,Tools.DefaultSnap);
  Message.Result := 0;
end;

procedure TToolDemoForm.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TToolDemoForm.Show1Click(Sender: TObject);
begin
  Tools.Show;
  Show1.Checked := true;
  Hide1.Checked := false;
end;

procedure TToolDemoForm.Hide1Click(Sender: TObject);
begin
  Tools.Hide;
  Show1.Checked := false;
  Hide1.Checked := true;
end;

procedure TToolDemoForm.FormShow(Sender: TObject);
begin
  initialized := true;
end;

procedure TToolDemoForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  initialized := false;
end;


procedure TToolDemoForm.Top1Click(Sender: TObject);
begin
  Tools.SnapBar(Self,TSnapOn(TmenuItem(Sender).Tag));
end;

procedure TToolDemoForm.Dock1Click(Sender: TObject);
begin
  Dock1.Checked := not Dock1.Checked;
  Tools.SnapOnMove := Dock1.Checked;
  Tools.SnapBar(Self,Tools.DefaultSnap);
end;

END.
