unit TreeTst1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Tree2vw, ExtCtrls, Stopwch1, Grids, Menus;

Type
  Tecd_xxx = (ecd_Expand, ecd_Collapse, ecd_Delete);
  Tba_xxx = (ba_Before, ba_After);

type
  Tfm_TreeTest = class(TForm)
    bt_ClearMemo: TButton;
    T2V: TTree2View;
    Timer1: TTimer;
    Label4: TLabel;
    lb_Elapsed: TLabel;
    SG1: TStringGrid;
    rg_Instr: TRadioGroup;
    lb_InstrOn: TLabel;
    Memo1: TMemo;
    Label5: TLabel;
    GroupBox1: TGroupBox;
    ck_Sort: TCheckBox;
    ck_BeginEndUpdate: TCheckBox;
    ck_Visible: TCheckBox;
    ck_NodeBEUpdate: TCheckBox;
    ck_HasChildren: TCheckBox;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    lb_MemUsed: TLabel;
    lb_SnapShot: TLabel;
    lb_Difference: TLabel;
    Label7: TLabel;
    bt_SnapShot: TButton;
    ck_MemoOn: TCheckBox;
    Label6: TLabel;
    lb_NodeCount: TLabel;
    bt_AddTopNodes: TButton;
    lb_VerNum: TLabel;
    bt_ClearNodes: TButton;
    cb_GWEnableSpecialUpdating: TCheckBox;
    Label8: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    PopupMenu1: TPopupMenu;
    pu_Delete: TMenuItem;
    bt_CountReset: TButton;
    ck_ProperOnExpand: TCheckBox;
    SG_ExpCol: TStringGrid;
    pu_Expand: TMenuItem;
    pu_Collapse: TMenuItem;
    Label9: TLabel;
    Label1: TLabel;
    tx_Qty: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure bt_Sort2Click(Sender: TObject);
    procedure bt_UnsortClick(Sender: TObject);
    procedure T2VExpanding(Sender: TObject; Node: TTree2Node;
      var AllowExpansion: Boolean);
    procedure ck_SortClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure bt_SnapShotClick(Sender: TObject);
    procedure T2VCollapsed(Sender: TObject; Node: TTree2Node);
    procedure T2VCollapsing(Sender: TObject; Node: TTree2Node;
      var AllowCollapse: Boolean);
    procedure T2VExpanded(Sender: TObject; Node: TTree2Node);
    procedure bt_ShowClick(Sender: TObject);
    procedure bt_ClearMemoClick(Sender: TObject);
    procedure ck_MemoOnClick(Sender: TObject);
    procedure bt_AddTopNodesClick(Sender: TObject);
    procedure bt_ClearNodesClick(Sender: TObject);
    procedure cb_GWEnableSpecialUpdatingClick(Sender: TObject);
    procedure pu_DeleteClick(Sender: TObject);
    procedure T2VDeletion(Sender: TObject; Node: TTree2Node);
    procedure T2VMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bt_CountResetClick(Sender: TObject);
    procedure ck_ProperOnExpandClick(Sender: TObject);
    procedure pu_ExpandClick(Sender: TObject);
    procedure pu_CollapseClick(Sender: TObject);
  private
    { Private declarations }
    MemUsed: integer;
    SnapShot: integer;
    Difference: integer;
    ECCounts: array[ecd_Expand..ecd_Delete, ba_Before..ba_After] of integer;
    procedure CollapseDeleteChildren(Node: TTree2Node);
  public
    MySW: TStopwatch;
    { Public declarations }
    procedure ShowMem;
    procedure StartInstrument;
    procedure StopInstrument;
    procedure CounterShow;
    procedure ECCountsReset;
  end;

var
  fm_TreeTest: Tfm_TreeTest;

implementation
uses GWWinTV;

{$R *.DFM}
Const
  Numbers: array[0..9] of string = (
    'Zero','One','Two','Three','Four','Five','Six','Seven','Eight','Nine');

procedure Tfm_TreeTest.FormCreate(Sender: TObject);
begin
  {----------------------
    T2V
  ----------------------}
  (**************************
  if you want to add 'manually'

  T2V := TTree2View.Create(Self);
  T2V.Parent := Self;
  T2V.Left := 8;
  T2V.Top := 170;
  T2V.Width := 385;
  T2V.Height := 209;
  T2V.Show;
  T2V.OnExpanding := T2VExpanding;
  T2V.OnCollapsing := T2VCollapsing;
  ***************************)
  { T2V.GWDebugMemo := Memo1; }
  MySW := TStopwatch.Create;
  Left := 40; Top := 40;

  SG1.ColWidths[1] := 50;
  tx_Qty.text := '10';
  lb_VerNum.Caption := 'T2V Version: '+IntToStr(T2V.GWVerNum);
  GWEnableSpecialNodesUpdating := cb_GWEnableSpecialUpdating.Checked;

  SG_ExpCol.Cells[1,0] := 'Before';
  SG_ExpCol.Cells[2,0] := 'After';
  SG_ExpCol.Cells[0,1] := 'Expand';
  SG_ExpCol.Cells[0,2] := 'Collapse';
  SG_ExpCol.Cells[0,3] := 'Delete';

end;


procedure Tfm_TreeTest.T2VExpanding(Sender: TObject; Node: TTree2Node;
  var AllowExpansion: Boolean);
Var
  N1, N2, AddQty, Err: integer;
  NewNode: TTree2Node;
  S, S2: string;
begin
  Inc(ECCounts[ecd_Expand,ba_Before]);
  { delete existing dummy node }
  { TreeView1.BeginUpdate; }
  Node.DeleteChildren;
  Val(tx_Qty.text, AddQty, Err);
  If AddQty < 1 then AddQty := 1;

  try
    Screen.Cursor := crHourGlass;
    if ck_Visible.checked then T2V.Visible := false;
    if ck_BeginEndUpdate.checked then T2V.Items.BeginUpdate;

    If rg_Instr.ItemIndex = 0 then StartInstrument;
    If ck_NodeBEUpdate.checked then Node.GWBeginNodeUpdate;
    { add new nodes }
    For N1 := 0 to AddQty-1 do
    Begin
      N2 := Random(AddQty){ N1};
      S := Node.Text + '-' + IntToStr(N2);
      S2 := '--------'+S+'----------';
      NewNode := T2V.Items.AddChild(Node,S);
      { add dummy to force button to appear }
      S2 := '--------Dummy---------';
      if ck_HasChildren.checked then
        NewNode.HasChildren := true else
        T2V.Items.AddChild(NewNode,'Dummy');
      { NewNode.SelectedIndex := 1; }
    end;
  finally
    If ck_NodeBEUpdate.checked then Node.GWEndNodeUpdate;
    if ck_BeginEndUpdate.checked then T2V.Items.EndUpdate;
    if ck_Visible.checked then T2V.Visible := true;
    Screen.Cursor := crDefault;
  end;
  If rg_Instr.ItemIndex = 0 then StopInstrument;
  If rg_Instr.ItemIndex = 1 then StartInstrument;
end;

procedure Tfm_TreeTest.T2VExpanded(Sender: TObject; Node: TTree2Node);
begin
  Inc(ECCounts[ecd_Expand,ba_After]);
  If rg_Instr.ItemIndex = 1 then StopInstrument;
end;


procedure Tfm_TreeTest.CollapseDeleteChildren(Node: TTree2Node);
Begin
  If rg_Instr.ItemIndex = 0 then StartInstrument;
  try
    if ck_Visible.checked then T2V.Visible := false;
    if ck_BeginEndUpdate.checked then T2V.Items.BeginUpdate;

    Node.DeleteChildren;
    if ck_HasChildren.checked then
      Node.HasChildren := true else
      T2V.Items.AddChild(Node,'Dummy');
    Node.SelectedIndex := 1;
  finally
    if ck_BeginEndUpdate.checked then T2V.Items.EndUpdate;
    if ck_Visible.checked then T2V.Visible := true;
  end;

  If rg_Instr.ItemIndex = 0 then StopInstrument;
end;

procedure Tfm_TreeTest.T2VCollapsing(Sender: TObject; Node: TTree2Node;
  var AllowCollapse: Boolean);
begin
  Inc(ECCounts[ecd_Collapse, ba_Before]);
  If rg_Instr.ItemIndex = 1 then StartInstrument;
  Screen.Cursor := crHourGlass;
end;

procedure Tfm_TreeTest.T2VCollapsed(Sender: TObject; Node: TTree2Node);
begin
  Inc(ECCounts[ecd_Collapse,ba_After]);
  If rg_Instr.ItemIndex = 1 then StopInstrument;
  Refresh;
  CollapseDeleteChildren(Node);
  Screen.Cursor := crDefault;
end;

procedure Tfm_TreeTest.bt_Sort2Click(Sender: TObject);
Var
  S: string;
begin
  T2V.SortType := stText;
end;

procedure Tfm_TreeTest.bt_UnsortClick(Sender: TObject);
begin
  T2V.SortType := stNone;
end;

procedure Tfm_TreeTest.ck_SortClick(Sender: TObject);
Var
  S: string;
begin
  if ck_Sort.Checked then
  Begin
    Screen.Cursor := crHourGlass;
    StartInstrument;
    T2V.SortType := stText;
    StopInstrument;
    Screen.Cursor := crDefault;
  end else
  Begin
    T2V.SortType := stNone;
  end;
end;

procedure Tfm_TreeTest.ShowMem;
Var
  HS: THeapStatus;
Begin
  HS := GetHeapStatus;
  MemUsed := HS.TotalAllocated;
  Difference := MemUsed - SnapShot;
  lb_MemUsed.Caption := IntToStr(MemUsed);
  lb_SnapShot.Caption := IntToStr(SnapShot);
  lb_Difference.Caption := IntToStr(Difference);
end;

procedure Tfm_TreeTest.Timer1Timer(Sender: TObject);
var
  ecd: Tecd_xxx;
  ba:  Tba_xxx;
begin
  ShowMem;
  lb_NodeCount.Caption := IntToStr(T2V.Items.Count);
  for ba := ba_Before to ba_After do
    for ecd := ecd_Expand to ecd_Delete do
      SG_ExpCol.Cells[Ord(ba)+1,Ord(ecd)+1] := IntToStr(ECCounts[ecd,ba]);
end;

procedure Tfm_TreeTest.ECCountsReset;
var
  ecd: Tecd_xxx;
  ba:  Tba_xxx;
begin
  for ba := ba_Before to ba_After do
    for ecd := ecd_Expand to ecd_Delete do
      ECCounts[ecd,ba] := 0;
end;


procedure Tfm_TreeTest.bt_SnapShotClick(Sender: TObject);
begin
  SnapShot := MemUsed;
  ShowMem;
end;

procedure Tfm_TreeTest.bt_ShowClick(Sender: TObject);
Begin
  COunterShow;
end;

procedure Tfm_TreeTest.bt_ClearMemoClick(Sender: TObject);
begin
  {
  GTVCountReset;
  bt_ShowClick(Sender);
  }
  Memo1.Clear;
end;

procedure Tfm_TreeTest.StartInstrument;
Begin
  lb_InstrOn.Caption := 'X';
  lb_InstrOn.Refresh;
  GTVCountReset;
  MySW.Reset;
end;
procedure Tfm_TreeTest.StopInstrument;
Begin
  lb_Elapsed.Caption := IntToStr(MySW.ElapsedTimems);
  CounterShow;
  lb_InstrOn.Caption := ' ';
  lb_InstrOn.Refresh;
end;

procedure Tfm_TreeTest.CounterShow;
Var
  N: Ttvf_xxx;
Begin
  For N := tvf_Begin to tvf_End do
  Begin
    SG1.Cells[0,ord(N)+1] := tvf_Info[N].Caption;
    SG1.Cells[1,ord(N)+1] := IntToStr(tvf_Info[N].Count);
  end;
end;

procedure Tfm_TreeTest.ck_MemoOnClick(Sender: TObject);
begin
  If ck_MemoOn.Checked then T2V.GWDebugMemo := Memo1
    else T2V.GWDebugMemo := nil;
end;

procedure Tfm_TreeTest.bt_AddTopNodesClick(Sender: TObject);
Var
  N,  AddQty, Err: integer;
  Node2: TTree2Node;
  S: string;
begin
  ECCountsReset;
  Screen.Cursor := crHourGlass;
  Val(tx_Qty.text, AddQty, Err);
  If AddQty < 0 then AddQty := 0;

  StartInstrument;
  if ck_BeginEndUpdate.checked then T2V.Items.BeginUpdate;
  { If ck_NodeBEUpdate.checked then T2V.Items.GWBeginNodeUpdate; }
  StartInstrument;
  try
  For N := 0 to AddQty-1 do
    Begin
      S := IntToHex(Random(AddQty), 5);
      Node2 := T2V.Items.Add(nil,S);
      if ck_HasChildren.checked then Node2.HasChildren := true
        else T2V.Items.AddChild(Node2,'Dummy');
    end;
  finally
     { If ck_NodeBEUpdate.checked then T2V.Items.GWEndUpdate; }
     if ck_BeginEndUpdate.checked then T2V.Items.EndUpdate;
     StopInstrument;
     Screen.Cursor := crDefault;
  end;
end;

procedure Tfm_TreeTest.bt_ClearNodesClick(Sender: TObject);
begin
  ECCountsReset;
  Screen.Cursor := crHourGlass;

  StartInstrument;
  if ck_BeginEndUpdate.checked then T2V.Items.BeginUpdate;
  { If ck_NodeBEUpdate.checked then T2V.Items.GWBeginUpdate; }

  T2V.Items.Clear;

  { If ck_NodeBEUpdate.checked then T2V.Items.GWEndUpdate; }
  if ck_BeginEndUpdate.checked then T2V.Items.EndUpdate;
  StopInstrument;

  Screen.Cursor := crDefault;
end;

procedure Tfm_TreeTest.cb_GWEnableSpecialUpdatingClick(Sender: TObject);
begin
  GWEnableSpecialNodesUpdating := cb_GWEnableSpecialUpdating.Checked;
end;

procedure Tfm_TreeTest.pu_DeleteClick(Sender: TObject);
begin
  ECCountsReset;
  T2V.Selected.Delete;
end;

procedure Tfm_TreeTest.T2VDeletion(Sender: TObject; Node: TTree2Node);
begin
  Inc(ECCounts[ecd_Delete, ba_Before]);
end;

procedure Tfm_TreeTest.T2VMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var TN: TTree2Node;
begin
  { ECCountsReset; can't do this: MouseDown is called AFTER [+][-]Expand/Collapse operation }
  TN := T2V.GetNodeAt(X,Y);
  If TN <> nil then TN.Selected := true;
end;

procedure Tfm_TreeTest.bt_CountResetClick(Sender: TObject);
begin
  ECCountsReset;
end;

procedure Tfm_TreeTest.ck_ProperOnExpandClick(Sender: TObject);
begin
  GWProperExpandCollapseBehaviorFix := ck_ProperOnExpand.checked;
end;

procedure Tfm_TreeTest.pu_ExpandClick(Sender: TObject);
Var
  TN: TTree2Node;
begin
  ECCountsReset;
  TN := T2V.Selected;
  If TN <> nil then TN.Expand(false);
end;

procedure Tfm_TreeTest.pu_CollapseClick(Sender: TObject);
Var
  TN: TTree2Node;
begin
  ECCountsReset;
  TN := T2V.Selected;
  If TN <> nil then TN.Collapse(false);
end;

end.
