unit WPDefs;
{ ------------------------------------------------------
   Defines only constants and types for the use of the
   buildin buttons of WPToolBar and of them of WPRuler!
  ------ (C) 1995 by Julian Ziersch --------------------}
interface
uses Graphics;

const
   FilterString = 'formatted text (*.RTF)|*.RTF|plain text (*.TXT)|*.TXT|all (*.*)|*.*';


type
  THyperLinkEvent = procedure(Sender: TObject;
          text    : string;  { marked Text }
          stamp   : string;  { reserved !  }
          LineNumber:Longint) of object;


  TWPUnit = (UnitCm, UnitIn, UnitPt, UnitPix);

  {------ Tabulatorenliste im aktuellen Style  --------------}
  PTWPTabulator = ^TWPTabulator;
  TWPTabulator = record
    pos    :  Longint;       { Position in twips }
    typ    :  (tabLeft,tabRight,tabCenter,tabNumber);
    x      :  Integer;  { Position in absoluter X Pos }
    prev,next : PTWPTabulator;
    end;
   { Absatzlayouts incl. Tastenzuordnung siehe RTF \stylesheet
     wird fuer Tabulatoren verwendet                }
   PTStyleDef = ^TStyleDef;
   TStyleDef = record
     name : string;
     nr   : Integer;
     Typ : (sdChar, sdParagraph, sdSection);
     keys : set of (sdAlt,sdShift,sdCtrl);
     key: Integer;
     { Formatting: brdrdef, parfmt, apoctl, tabdef, shading, chrfmt }
     next : PTStyleDef;
   end;
  {------ Lineal ----------------------------- --------------}
  const KeepOldValue = -1000; { Bei Aufruf von Margin o.ae. den alten Wert behalten }

  type
  PTWPRulerVar = ^TWPRulerVar;
  TWPRulerVar = record
    paperw  : Longint; { default 12240 }
    paperh  : Longint; { dafault 15840 }
    psz     : Integer; { DMPAPER_ values #1-41 }
    margl, margr : Longint; { default 1800 = Rand }
    margt,margb  : Longint; { default 1440 }
    margmirror   : Boolean;
    landscape    : Boolean;
    pgnstart     : Integer;
    { Absatz }
    align      :(alLeft, alRight, alCenter, alBlock);  { RTF : \ql \qr \qc qj  }
    indentfirst, indentleft, indentright : LongInt; { Indentation }
    spacebefore, spaceafter, spacebetween :Integer; { Spacing }
    { Rahmen }
    line_o,line_r,line_l,line_u : Boolean;
    line_art : Integer; { 1, 2 , 3 }
    line_color : TColor;
    backgrund  : TColor;
    FUnit         : TWPUnit;
    { Zeiger auf 1. Tabulator bzw. nil }
    ptab        : PTWPTabulator;
    tab_default : Integer; { default X-Ausrichtung }
    {--------- Arbeitswerte : -------------------------------------}
    papWidth : Longint; { Maximale Papierbreite incl Scrolling     }
    papHeight: Longint; { Papierhhe, ectl. Seitenumbruch anzeigen }

    {------ RTF \stylesheet ..... Absatzlayouts }
    Style : TStyleDef; { im ersten Style ist Default, evtl. mehrere }
    ActiveStyle : PTStyleDef;
    ActiveStyleNr : Integer;
    {------ Styles entahlten auch Tabulatoren -------}
end;

type
  TWpSelNr=(wptNone,wptName,wptSize,wptColor,wptBkColor,
           wptTyp,wptIconSel,wptIconDeSel,wptPage,wptParagraph);
  { Auswahl der vordefinierten Icons }
  TWpTbIcon = (SelNormal,SelBold,SelItalic,SelUnder,SelHyperLink,
               SelLeft,SelRight,SelBlock,SelCenter);

  TWpTbIcon2 = (SelExit,SelNew,SelOpen,SelSave,SelClose,
                SelPrint,SelPrintSetup);

  TWPTbIcon3 = (SelNext,SelPrev,SelEdit,SelAdd,SelDel,SelCancel,SelToStart,SelToEnd);

  TwpTbIcons = set of TWpTbIcon;
  TwpTbIcons2 = set of TWpTbIcon2;
  TwpTbIcons3 = set of TWpTbIcon3;

  { Auswahl der Listboxen }
  TWpTbListbox = (SelFontName,SelFontSize,SelFontColor,SelBackgroundColor,SelStyle);
  TwpTbListboxen = set of TWpTbListbox;

  TWPSelectEvent = procedure(Sender: TObject;
          var Typ:TWpSelNr;
          var str:string;
          var num:Integer ) of object;

  { Icon oder Ruler ausgewhlt }
  TWPIconSelectEvent = procedure(Sender: TObject;
          var Typ:TWpSelNr; { wptIconSel / wptIconDeSel }
          var str:string;  { name bzw nil }
          var group : Integer;
          var num   : Integer;
          var index : Integer) of object;

  TWPRulerSelectEvent = procedure(Sender: TObject;
          var Typ:TWpSelNr; { wptPage,wptParagraph }
          var group : Integer;
          var num   : Integer;
          changing : Boolean) of object;

  TWPToolLanguage = (twpEnglish,twpGerman,twpOther);

const WPI_IDX_INTERN =0; { ToolBar defined Button }
      WPI_IDX_EXTERN =1; { User defined Button, auch zum Suchen verwendbar }

{ 2. Groups }
const WPI_GR_STYLE = 1; { allow all up }
      WPI_GR_ALIGN = 2; { radion button }
      WPI_GR_EDIT  = 3; { copy, paste ... }
      WPI_GR_DISK  = 4; { new,open,save ... }
      WPI_GR_PRINT = 5; { print, print setup }
      WPI_GR_DATA  = 6; { prev, next ... }

      WPI_GR_PARAGRAPH = 10; { Ereignisse der Formatierung }
      WPI_GR_TABSTOP   = 11;
      WPI_GR_PAGE      = 12;

      WPI_GR_USER  = 21; { free for User use }


{ 1. Commands }
const WPI_CO_Normal=1;   { Group: WPI_GR_STYLE }
      WPI_CO_Bold  =2;
      WPI_CO_Italic=3;
      WPI_CO_Under =4;
      WPI_CO_HYPERLINK = 5;

      WPI_CO_Left  =1;  { Group: WPI_GR_ALIGN }
      WPI_CO_Right =2;
      WPI_CO_Justified =3;
      WPI_CO_Center=4;

      WPI_CO_Exit  =1; { Group: WPI_GR_DISK }
      WPI_CO_New   =2;
      WPI_CO_Open  =3;
      WPI_CO_Save  =4;
      WPI_CO_Close =5;

      WPI_CO_Print =1; { Group: WPI_PRINT }
      WPI_CO_PrintSetup=2;

      WPI_CO_Next   =1; { Group: WPI_DATA }
      WPI_CO_Prev   =2;
      WPI_CO_Add    =3;
      WPI_CO_Del    =4;
      WPI_CO_Edit   =5;
      WPI_CO_Cancel =6;
      WPI_CO_ToStart=7;
      WPI_CO_ToEnd  =8;

      { Ruler Events }
      WPI_CO_PAG_L   = 1; { left border of Page }
      WPI_CO_PAG_R   = 2; { right border of Page }
      WPI_CO_PAG_T   = 3; { Top border of Page }
      WPI_CO_PAG_B   = 4; { bottom border of Page }

      WPI_CO_PAR_R   = 1; { Right of Paragraph }
      WPI_CO_PAR_L   = 2; { Left of Paragraph }
      WPI_CO_PAR_FIRST=3; { Left of first Line ---> dont change!}

      WPI_CO_PAR_T   = 13; { vor Absatz in Twips }
      WPI_CO_PAR_LINE= 14; { Zeilenabstand in Twips }
      WPI_CO_PAR_B   = 15; { nach Absatz in Twips }


implementation

end.
