unit adReg;

{
	Project 'AutoDraw Grids Registration'
  by Rick Rogers
  Copyright  1996. All Rights Reserved.

  Version 1.01
  Release Date 04/27/96
}

interface

procedure Register;

implementation

uses
  Windows, Messages, SysUtils, Classes, Grids, TypInfo, DsgnIntf,
  adEditor, adGrids;

{ TadColumnAttributesProperty }

type
	TadColumnAttributesProperty = class(TClassProperty)
  public
  	procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure TadColumnAttributesProperty.Edit;
begin
	if EditColumns(TadColumns(GetOrdValue)) then Modified;
end;

function TadColumnAttributesProperty.GetAttributes: TPropertyAttributes;
begin
	Result := [paDialog, paReadOnly];
end;

{ TAutoDrawEditor }

type
  TAutoDrawEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
	end;

procedure TAutoDrawEditor.ExecuteVerb(Index: Integer);
var
	PropInfo : PPropInfo;		{ RTTI property information }
	Columns	 : TadColumns;	{ Columns property }
begin
	{ Assign columns using RTTI }
	PropInfo := GetPropInfo(Component.ClassInfo,'Columns');
	Columns := TadColumns(GetOrdProp(Component,PropInfo));
  { Execute verb }
  case Index of
  0 : if EditColumns(Columns) then Designer.Modified;
  1 : SendMessage(TDrawGrid(Component).Handle,CM_RESETROWHEIGHTS, 0, 0);
  end;
end;

function TAutoDrawEditor.GetVerb(Index: Integer): String;
begin
	case Index of
  0 : Result := 'Columns Editor...';
  1 : Result := 'Reset Row Heights';
  end;
end;

function TAutoDrawEditor.GetVerbCount: Integer;
begin
	Result := 2;
end;

procedure Register;
begin
	RegisterComponents('Samples', [TadDrawGrid,TadStringGrid]);
  RegisterComponentEditor(TadDrawGrid, TAutoDrawEditor);
  RegisterComponentEditor(TadStringGrid, TAutoDrawEditor);
  RegisterPropertyEditor(TypeInfo(TadColumns), nil, '', TadColumnAttributesProperty);
end;

end.
