unit GWWinTV;

interface

uses Messages, Windows, SysUtils, CommCtrl, Classes, Controls, Forms,
  Menus, Graphics, StdCtrls, RichEdit, DsgnIntf;

{ ====== TREEVIEW CONTROL =================== }

function GTreeView_InsertItem(hwnd: HWND; const lpis: TTVInsertStruct): HTreeItem;
function GTreeView_DeleteItem(hwnd: HWND; hitem: HTreeItem): Bool;
function GTreeView_DeleteAllItems(hwnd: HWND): Bool;
function GTreeView_Expand(hwnd: HWND; hitem: HTreeItem; code: Integer): Bool;
function GTreeView_GetItemRect(hwnd: HWND; hitem: HTreeItem;  var prc: TRect; code: Bool): Bool;
function GTreeView_GetCount(hwnd: HWND): UINT;
function GTreeView_GetIndent(hwnd: HWND): UINT;
function GTreeView_SetIndent(hwnd: HWND; indent: Integer): Bool;
function GTreeView_GetImageList(hwnd: HWND; iImage: Integer): HImageList;
function GTreeView_SetImageList(hwnd: HWND; himl: HImageList;  iImage: Integer): HImageList;
function GTreeView_GetNextItem(hwnd: HWND; hitem: HTreeItem;  code: Integer): HTreeItem;
function GTreeView_GetChild(hwnd: HWND; hitem: HTreeItem): HTreeItem;
function GTreeView_GetNextSibling(hwnd: HWND; hitem: HTreeItem): HTreeItem;
function GTreeView_GetPrevSibling(hwnd: HWND; hitem: HTreeItem): HTreeItem;
function GTreeView_GetParent(hwnd: HWND; hitem: HTreeItem): HTreeItem;
function GTreeView_GetFirstVisible(hwnd: HWND): HTreeItem;
function GTreeView_GetNextVisible(hwnd: HWND; hitem: HTreeItem): HTreeItem;
function GTreeView_GetPrevVisible(hwnd: HWND; hitem: HTreeItem): HTreeItem;
function GTreeView_GetSelection(hwnd: HWND): HTreeItem;
function GTreeView_GetDropHilite(hwnd: HWND): HTreeItem;
function GTreeView_GetRoot(hwnd: HWND): HTreeItem;
function GTreeView_Select(hwnd: HWND; hitem: HTreeItem;  code: Integer): HTreeItem;
function GTreeView_SelectItem(hwnd: HWND; hitem: HTreeItem): HTreeItem;
function GTreeView_SelectDropTarget(hwnd: HWND; hitem: HTreeItem): HTreeItem;
function GTreeView_SelectSetFirstVisible(hwnd: HWND; hitem: HTreeItem): HTreeItem;
function GTreeView_GetItemA(hwnd: HWND; var pitem: TTVItemA): Bool;
function GTreeView_GetItemW(hwnd: HWND; var pitem: TTVItemW): Bool;
function GTreeView_GetItem(hwnd: HWND; var pitem: TTVItem): Bool;
function GTreeView_SetItemA(hwnd: HWND; const pitem: TTVItemA): Bool;
function GTreeView_SetItemW(hwnd: HWND; const pitem: TTVItemW): Bool;
function GTreeView_SetItem(hwnd: HWND; const pitem: TTVItem): Bool;
function GTreeView_EditLabelA(hwnd: HWND; hitem: HTreeItem): HWND;
function GTreeView_EditLabelW(hwnd: HWND; hitem: HTreeItem): HWND;
function GTreeView_EditLabel(hwnd: HWND; hitem: HTreeItem): HWND;
function GTreeView_GetEditControl(hwnd: HWND): HWND;
function GTreeView_GetVisibleCount(hwnd: HWND): UINT;
function GTreeView_HitTest(hwnd: HWND; var lpht: TTVHitTestInfo): HTreeItem;
function GTreeView_CreateDragImage(hwnd: HWND; hitem: HTreeItem): HimageList;
function GTreeView_SortChildren(hwnd: HWND; hitem: HTreeItem;  recurse: Integer): Bool;
function GTreeView_EnsureVisible(hwnd: HWND; hitem: HTreeItem): Bool;
function GTreeView_SortChildrenCB(hwnd: HWND; const psort: TTVSortCB;  recurse: Integer): Bool;
function GTreeView_EndEditLabelNow(hwnd: HWND; fCancel: Bool): Bool;
function GTreeView_GetISearchStringA(hwndTV: HWND; lpsz: PAnsiChar): Bool;
function GTreeView_GetISearchStringW(hwndTV: HWND; lpsz: PWideChar): Bool;
function GTreeView_GetISearchString(hwndTV: HWND; lpsz: PChar): Bool;
procedure GTVCountReset;

{ ====== TREEVIEW CONTROL =================== }
Type
{ TV Function Constants }
  Ttvf_xxx = (
    tvf_InsertItem,
    tvf_DeleteItem,
    tvf_DeleteAllItems,
    tvf_Expand,
    tvf_GetItemRect,
    tvf_GetCount,
    tvf_GetIndent,
    tvf_SetIndent,
    tvf_GetImageList,
    tvf_SetImageList,
    tvf_GetNextItem,
    tvf_GetChild,
    tvf_GetNextSibling,
    tvf_GetPrevSibling,
    tvf_GetParent,
    tvf_GetFirstVisible,
    tvf_GetNextVisible,
    tvf_GetPrevVisible,
    tvf_GetSelection,
    tvf_GetDropHilite,
    tvf_GetRoot,
    tvf_Select,
    tvf_SelectItem,
    tvf_SelectDropTarget,
    tvf_SelectSetFirstVisible,
    tvf_GetItemA,
    tvf_GetItemW,
    tvf_GetItem,
    tvf_SetItemA,
    tvf_SetItemW,
    tvf_SetItem,
    tvf_EditLabelA,
    tvf_EditLabelW,
    tvf_EditLabel,
    tvf_GetEditControl,
    tvf_GetVisibleCount,
    tvf_HitTest,
    tvf_CreateDragImage,
    tvf_SortChildren,
    tvf_EnsureVisible,
    tvf_SortChildrenCB,
    tvf_EndEditLabelNow,
    tvf_GetISearchStringA,
    tvf_GetISearchStringW,
    tvf_GetISearchString);

  TTVf_Info = record
    Caption: string;
    Count: integer;
  end;

Const
  tvf_Begin = tvf_InsertItem;  tvf_End = tvf_GetISearchString;

  TVf_Info: array[tvf_Begin..tvf_End] of  TTVf_Info = (
    (Caption: 'InsertItem'),
    (Caption: 'DeleteItem'),
    (Caption: 'DeleteAllItems'),
    (Caption: 'Expand'),
    (Caption: 'GetItemRect'),
    (Caption: 'GetCount'),
    (Caption: 'GetIndent'),
    (Caption: 'SetIndent'),
    (Caption: 'GetImageList'),
    (Caption: 'SetImageList'),
    (Caption: 'GetNextItem'),
    (Caption: 'GetChild'),
    (Caption: 'GetNextSibling'),
    (Caption: 'GetPrevSibling'),
    (Caption: 'GetParent'),
    (Caption: 'GetFirstVisible'),
    (Caption: 'GetNextVisible'),
    (Caption: 'GetPrevVisible'),
    (Caption: 'GetSelection'),
    (Caption: 'GetDropHilite'),
    (Caption: 'GetRoot'),
    (Caption: 'Select'),
    (Caption: 'SelectItem'),
    (Caption: 'SelectDropTarget'),
    (Caption: 'SelectSetFirstVisible'),
    (Caption: 'GetItemA'),
    (Caption: 'GetItemW'),
    (Caption: 'GetItem'),
    (Caption: 'SetItemA'),
    (Caption: 'SetItemW'),
    (Caption: 'SetItem'),
    (Caption: 'EditLabelA'),
    (Caption: 'EditLabelW'),
    (Caption: 'EditLabel'),
    (Caption: 'GetEditControl'),
    (Caption: 'GetVisibleCount'),
    (Caption: 'HitTest'),
    (Caption: 'CreateDragImage'),
    (Caption: 'SortChildren'),
    (Caption: 'EnsureVisible'),
    (Caption: 'SortChildrenCB'),
    (Caption: 'EndEditLabelNow'),
    (Caption: 'GetISearchStringA'),
    (Caption: 'GetISearchStringW'),
    (Caption: 'GetISearchString'));

implementation

function GTreeView_InsertItem(hwnd: HWND; const lpis: TTVInsertStruct): HTreeItem;
Begin
  Inc(tvf_Info[tvf_InsertItem].Count);
  Result := TreeView_InsertItem(hwnd, lpis);
End;

function GTreeView_DeleteItem(hwnd: HWND; hitem: HTreeItem): Bool;
Begin
  Inc(tvf_Info[tvf_DeleteItem].Count);
  Result := TreeView_DeleteItem(hwnd, hitem);
End;

function GTreeView_DeleteAllItems(hwnd: HWND): Bool;
Begin
  Inc(tvf_Info[tvf_DeleteAllItems].Count);
  Result := TreeView_DeleteAllItems(hwnd);
End;

function GTreeView_Expand(hwnd: HWND; hitem: HTreeItem; code: Integer): Bool;
Begin
  Inc(tvf_Info[tvf_Expand].Count);
  Result := TreeView_Expand(hwnd, hitem, code);
End;

function GTreeView_GetItemRect(hwnd: HWND; hitem: HTreeItem;  var prc: TRect; code: Bool): Bool;
Begin
  Inc(tvf_Info[tvf_GetItemRect].Count);
  Result := TreeView_GetItemRect(hwnd, hitem,  prc, code);
End;

function GTreeView_GetCount(hwnd: HWND): UINT;
Begin
  Inc(tvf_Info[tvf_GetCount].Count);
  Result := TreeView_GetCount(hwnd);
End;

function GTreeView_GetIndent(hwnd: HWND): UINT;
Begin
  Inc(tvf_Info[tvf_GetIndent].Count);
  Result := TreeView_GetIndent(hwnd);
End;

function GTreeView_SetIndent(hwnd: HWND; indent: Integer): Bool;
Begin
  Inc(tvf_Info[tvf_SetIndent].Count);
  Result := TreeView_SetIndent(hwnd, indent);
End;

function GTreeView_GetImageList(hwnd: HWND; iImage: Integer): HImageList;
Begin
  Inc(tvf_Info[tvf_GetImageList].Count);
  Result := TreeView_GetImageList(hwnd, iImage);
End;

function GTreeView_SetImageList(hwnd: HWND; himl: HImageList;  iImage: Integer): HImageList;
Begin
  Inc(tvf_Info[tvf_SetImageList].Count);
  Result := TreeView_SetImageList(hwnd, himl,  iImage);
End;

function GTreeView_GetNextItem(hwnd: HWND; hitem: HTreeItem;  code: Integer): HTreeItem;
Begin
  Inc(tvf_Info[tvf_GetNextItem].Count);
  Result := TreeView_GetNextItem(hwnd, hitem,  code);
End;

function GTreeView_GetChild(hwnd: HWND; hitem: HTreeItem): HTreeItem;
Begin
  Inc(tvf_Info[tvf_GetChild].Count);
  Result := TreeView_GetChild(hwnd, hitem);
End;

function GTreeView_GetNextSibling(hwnd: HWND; hitem: HTreeItem): HTreeItem;
Begin
  Inc(tvf_Info[tvf_GetNextSibling].Count);
  Result := TreeView_GetNextSibling(hwnd, hitem);
End;

function GTreeView_GetPrevSibling(hwnd: HWND; hitem: HTreeItem): HTreeItem;
Begin
  Inc(tvf_Info[tvf_GetPrevSibling].Count);
  Result := TreeView_GetPrevSibling(hwnd, hitem);
End;

function GTreeView_GetParent(hwnd: HWND; hitem: HTreeItem): HTreeItem;
Begin
  Inc(tvf_Info[tvf_GetParent].Count);
  Result := TreeView_GetParent(hwnd, hitem);
End;

function GTreeView_GetFirstVisible(hwnd: HWND): HTreeItem;
Begin
  Inc(tvf_Info[tvf_GetFirstVisible].Count);
  Result := TreeView_GetFirstVisible(hwnd);
End;

function GTreeView_GetNextVisible(hwnd: HWND; hitem: HTreeItem): HTreeItem;
Begin
  Inc(tvf_Info[tvf_GetNextVisible].Count);
  Result := TreeView_GetNextVisible(hwnd, hitem);
End;

function GTreeView_GetPrevVisible(hwnd: HWND; hitem: HTreeItem): HTreeItem;
Begin
  Inc(tvf_Info[tvf_GetPrevVisible].Count);
  Result := TreeView_GetPrevVisible(hwnd, hitem);
End;

function GTreeView_GetSelection(hwnd: HWND): HTreeItem;
Begin
  Inc(tvf_Info[tvf_GetSelection].Count);
  Result := TreeView_GetSelection(hwnd);
End;

function GTreeView_GetDropHilite(hwnd: HWND): HTreeItem;
Begin
  Inc(tvf_Info[tvf_GetDropHilite].Count);
  Result := TreeView_GetDropHilite(hwnd);
End;

function GTreeView_GetRoot(hwnd: HWND): HTreeItem;
Begin
  Inc(tvf_Info[tvf_GetRoot].Count);
  Result := TreeView_GetRoot(hwnd);
End;

function GTreeView_Select(hwnd: HWND; hitem: HTreeItem;  code: Integer): HTreeItem;
Begin
  Inc(tvf_Info[tvf_Select].Count);
  Result := TreeView_Select(hwnd, hitem,  code);
End;

function GTreeView_SelectItem(hwnd: HWND; hitem: HTreeItem): HTreeItem;
Begin
  Inc(tvf_Info[tvf_SelectItem].Count);
  Result := TreeView_SelectItem(hwnd, hitem);
End;

function GTreeView_SelectDropTarget(hwnd: HWND; hitem: HTreeItem): HTreeItem;
Begin
  Inc(tvf_Info[tvf_SelectDropTarget].Count);
  Result := TreeView_SelectDropTarget(hwnd, hitem);
End;

function GTreeView_SelectSetFirstVisible(hwnd: HWND; hitem: HTreeItem): HTreeItem;
Begin
  Inc(tvf_Info[tvf_SelectSetFirstVisible].Count);
  Result := TreeView_SelectSetFirstVisible(hwnd, hitem);
End;

function GTreeView_GetItemA(hwnd: HWND; var pitem: TTVItemA): Bool;
Begin
  Inc(tvf_Info[tvf_GetItemA].Count);
  Result := TreeView_GetItemA(hwnd, pitem);
End;

function GTreeView_GetItemW(hwnd: HWND; var pitem: TTVItemW): Bool;
Begin
  Inc(tvf_Info[tvf_GetItemW].Count);
  Result := TreeView_GetItemW(hwnd, pitem);
End;

function GTreeView_GetItem(hwnd: HWND; var pitem: TTVItem): Bool;
Begin
  Inc(tvf_Info[tvf_GetItem].Count);
  Result := TreeView_GetItem(hwnd, pitem);
End;

function GTreeView_SetItemA(hwnd: HWND; const pitem: TTVItemA): Bool;
Begin
  Inc(tvf_Info[tvf_SetItemA].Count);
  Result := TreeView_SetItemA(hwnd, pitem);
End;

function GTreeView_SetItemW(hwnd: HWND; const pitem: TTVItemW): Bool;
Begin
  Inc(tvf_Info[tvf_SetItemW].Count);
  Result := TreeView_SetItemW(hwnd, pitem);
End;

function GTreeView_SetItem(hwnd: HWND; const pitem: TTVItem): Bool;
Begin
  Inc(tvf_Info[tvf_SetItem].Count);
  Result := TreeView_SetItem(hwnd,  pitem);
End;

function GTreeView_EditLabelA(hwnd: HWND; hitem: HTreeItem): HWND;
Begin
  Inc(tvf_Info[tvf_EditLabelA].Count);
  Result := TreeView_EditLabelA(hwnd, hitem);
End;

function GTreeView_EditLabelW(hwnd: HWND; hitem: HTreeItem): HWND;
Begin
  Inc(tvf_Info[tvf_EditLabelW].Count);
  Result := TreeView_EditLabelW(hwnd, hitem);
End;

function GTreeView_EditLabel(hwnd: HWND; hitem: HTreeItem): HWND;
Begin
  Inc(tvf_Info[tvf_EditLabel].Count);
  Result := TreeView_EditLabel(hwnd, hitem);
End;

function GTreeView_GetEditControl(hwnd: HWND): HWND;
Begin
  Inc(tvf_Info[tvf_GetEditControl].Count);
  Result := TreeView_GetEditControl(hwnd);
End;

function GTreeView_GetVisibleCount(hwnd: HWND): UINT;
Begin
  Inc(tvf_Info[tvf_GetVisibleCount].Count);
  Result := TreeView_GetVisibleCount(hwnd);
End;

function GTreeView_HitTest(hwnd: HWND; var lpht: TTVHitTestInfo): HTreeItem;
Begin
  Inc(tvf_Info[tvf_HitTest].Count);
  Result := TreeView_HitTest(hwnd, lpht);
End;

function GTreeView_CreateDragImage(hwnd: HWND; hitem: HTreeItem): HimageList;
Begin
  Inc(tvf_Info[tvf_CreateDragImage].Count);
  Result := TreeView_CreateDragImage(hwnd, hitem);
End;

function GTreeView_SortChildren(hwnd: HWND; hitem: HTreeItem;  recurse: Integer): Bool;
Begin
  Inc(tvf_Info[tvf_SortChildren].Count);
  Result := TreeView_SortChildren(hwnd, hitem,  recurse);
end;

function GTreeView_EnsureVisible(hwnd: HWND; hitem: HTreeItem): Bool;
Begin
  Inc(tvf_Info[tvf_EnsureVisible].Count);
  Result := TreeView_EnsureVisible(hwnd, hitem);
End;

function GTreeView_SortChildrenCB(hwnd: HWND; const psort: TTVSortCB;  recurse: Integer): Bool;
Begin
  Inc(tvf_Info[tvf_SortChildrenCB].Count);
  Result := TreeView_SortChildrenCB(hwnd, psort,  recurse);
End;

function GTreeView_EndEditLabelNow(hwnd: HWND; fCancel: Bool): Bool;
Begin
  Inc(tvf_Info[tvf_EndEditLabelNow].Count);
  Result := TreeView_EndEditLabelNow(hwnd, fCancel);
End;

function GTreeView_GetISearchStringA(hwndTV: HWND; lpsz: PAnsiChar): Bool;
Begin
  Inc(tvf_Info[tvf_GetISearchStringA].Count);
  Result := TreeView_GetISearchStringA(hwndTV, lpsz);
End;

function GTreeView_GetISearchStringW(hwndTV: HWND; lpsz: PWideChar): Bool;
Begin
  Inc(tvf_Info[tvf_GetISearchStringW].Count);
  Result := TreeView_GetISearchStringW(hwndTV, lpsz);
End;

function GTreeView_GetISearchString(hwndTV: HWND; lpsz: PChar): Bool;
Begin
  Inc(tvf_Info[tvf_GetISearchString].Count);
  Result := TreeView_GetISearchString(hwndTV, lpsz);
End;

procedure GTVCountReset;
Var
  N: Ttvf_xxx;
Begin
  For N := tvf_Begin to tvf_End do
  Begin
    tvf_Info[N].Count := 0;
  end;
end;


end.
